package com.sharppaint;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextPane;


public class InfoDialog {
	private static InfoDialog infoDialog = null;
	
	private JDialog infoJDialog;
	
	private JPanel centerPanel, southPanel;
	
	private JPanel infoPanel, authorPanel, licensePanel;
	
	private JButton okButton;
	
	private JTabbedPane tab;
	
	private ImageIcon infoImage;

	private JTextPane authorTextBox;
	
	private JTextPane licenseTextBox;
	
	private JScrollPane authorTextScroller;
	
	private JScrollPane licenseTextScroller;
	
	public static int INNERTAB_PANEL_WIDTH = 640;
	
	public static int INNERTAB_PANEL_HEIGHT = 480;
	
	public static InfoDialog getInstance() {
		if (infoDialog == null) {
			infoDialog = new InfoDialog();
		}
		return infoDialog;
	}
	
	private InfoDialog() {
        makeGUI();
	}
	
	private void makeGUI() {
		infoJDialog = new JDialog(MainWindow.getInstance(), "Information", false);
		centerPanel = new JPanel();
		centerPanel.setLayout(new BorderLayout());		
		makeTabGUI();

		southPanel = new JPanel();
		okButton = new JButton("OK");
		okButton.setPreferredSize(new Dimension(75, 20));
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				okButton_actionPerformed();
			}
		});
		southPanel.add(okButton);
		//southPanel.setPreferredSize(new Dimension(670, 40));

		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		infoJDialog.getContentPane().add(centerPanel, BorderLayout.CENTER);
		infoJDialog.getContentPane().add(southPanel, BorderLayout.SOUTH);
		infoJDialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		infoJDialog.pack();
		infoJDialog.setVisible(true);
		infoJDialog.setLocation(screenSize.width/5, screenSize.height/5);
		infoJDialog.setResizable(false);
	}
	
	public void okButton_actionPerformed() {
		infoJDialog.dispose();
	}	
	
	private void makeTabGUI() {
		infoImage = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "info_image.jpg"));

		infoPanel = new JPanel(){
			private static final long serialVersionUID = 5369706846656547855L;

			public void paintComponent(Graphics g) {
                g.drawImage(infoImage.getImage(), 0, 0, null);
                setOpaque(false);
                super.paintComponent(g);
                g.dispose();
            }
        };

		authorPanel = new JPanel();
        authorTextBox = new JTextPane();
        authorTextBox.setEditable(false);
		authorTextScroller = new JScrollPane(authorTextBox,
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		authorTextScroller.setWheelScrollingEnabled(true);
        authorPanel.setLayout(new BorderLayout());
		authorPanel.add(authorTextScroller, BorderLayout.CENTER);
		
		licensePanel = new JPanel();
		licenseTextBox = new JTextPane();
		licenseTextBox.setEditable(false);
		licenseTextScroller = new JScrollPane(licenseTextBox,
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		licenseTextScroller.setWheelScrollingEnabled(true);
		licensePanel.setLayout(new BorderLayout());
		licensePanel.add(licenseTextScroller, BorderLayout.CENTER);

		
		infoPanel.setPreferredSize(new Dimension(
				INNERTAB_PANEL_WIDTH, INNERTAB_PANEL_HEIGHT));
		authorPanel.setPreferredSize(new Dimension(
				INNERTAB_PANEL_WIDTH, INNERTAB_PANEL_HEIGHT));
		licensePanel.setPreferredSize(new Dimension(
				INNERTAB_PANEL_WIDTH, INNERTAB_PANEL_HEIGHT));
		tab = new JTabbedPane();
		tab.addTab("About", infoPanel);
		tab.addTab("Authors", authorPanel);
		tab.addTab("License", licensePanel);
		centerPanel.add(BorderLayout.CENTER, tab);

        authorTextBox.setText(Constants.AUTHORS);
        licenseTextBox.setText(Constants.LICENSE);
	}
	/*
	private void setLicenseText() {
		try {
			File licenseFile = new File("/com/sharppaint/license.txt");
			FileReader fileReader = new FileReader(licenseFile);
			BufferedReader reader = new BufferedReader(fileReader);
			StringBuffer doc = new StringBuffer();
			String line = null;
			while((line = reader.readLine()) != null) {
				doc = doc.append(line);
				doc = doc.append("\n");
			}
			reader.close();
			licenseTextBox.setText(doc.toString());
		} catch(Exception ex) {
			ex.printStackTrace();
		}
	}*/
	
	public void setVisible(boolean isVisible) {
		if(isVisible) {
			infoJDialog.setVisible(true);
		} else {
			infoJDialog.setVisible(false);
		}
	}
}
