package com.sharppaint;

import java.awt.*;

import javax.swing.*;
import javax.swing.border.TitledBorder;
import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.BorderFactory;
import java.text.DecimalFormat;

public class NewFileDialog {
	/**
	 * 
	 */
	private static final long serialVersionUID = -4380572695834179590L;
	
	private static NewFileDialog newFile = null; 
	
	private JDialog dialog;
	
	private String commandWidth = "pixels",  commandHeight = "pixels";
	
	private String[] listSize = {"pixels", "inches", "cm"};
	
	private String[] preSize = {
			" Custom", 
			"", 
			" Default SharpPaint Size", 
			"",
			" 640  480", " 800  600", " 1024  768",
			"",
			" 3  2", " 6  4", " 7  5", 
			"",
			" 2  3", " 4  6", " 5  7",
			"", 
			" Letter", " Legal", " Tabloid", " Envelope",
			"", 
			" A4", " A5", " B5"};
	
	private int widthPixel, heightPixel;
	
	private JPanel panelWest;
	
	private JPanel panelEast;
	
	private JLabel labelName;
	
	private JTextField nameTextField;
	
	private JPanel panelSet;  
	
	private JPanel panelName;  
	
	private JLabel widthLabel;
	
	private JTextField widthTextField;
	
	private JLabel heightLabel;
	
	private JTextField heightTextField;
	
	private JComboBox comboBoxWidth;
	
	private JComboBox comboBoxHeight;
	
	private JButton buttonOk;  
	
	private JButton buttonCancel;  
	
	private JLabel resolutionLabel;
	
	private JComboBox comboBoxPre;
	
	private NewFileDialog() {
		make_gui();
	}
	
	public static NewFileDialog getInstance() {
		if(newFile == null) {
			newFile = new NewFileDialog();
		}
		return newFile;
	}
	
	public void make_gui() {
		dialog = new JDialog(MainWindow.getInstance(), "NewFile", true);
		dialog.getContentPane().setLayout(new FlowLayout());
		widthPixel = 0;
		heightPixel = 0;
		panelWest = new JPanel();
		panelEast = new JPanel();
		labelName = new JLabel();
		nameTextField = new JTextField();
		panelSet = new JPanel();  
		panelName = new JPanel();  
		widthLabel = new JLabel();
		widthTextField = new JTextField();
		heightLabel = new JLabel();
		heightTextField = new JTextField();
		comboBoxWidth = new JComboBox(listSize);
		comboBoxHeight = new JComboBox(listSize);
		buttonOk = new JButton();  
		buttonCancel = new JButton();
		resolutionLabel = new JLabel();
		comboBoxPre = new JComboBox(preSize);
		
		nameTextField.setColumns(8);
		nameTextField.addKeyListener(new NameTextFieldKeyListener());
		widthLabel.setText("     Width:");
		widthTextField.setPreferredSize(new Dimension(66, 21));
		widthTextField.setText("580");
		widthTextField.setColumns(5);
		heightLabel.setText("    Height:");
		heightTextField.setPreferredSize(new Dimension(66, 21));
		heightTextField.setText("435");
		heightTextField.setColumns(5);
		buttonOk.setPreferredSize(new Dimension(75, 20));
		buttonOk.setText("OK");
		buttonOk.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				buttonOk_actionPerformed();
			}
		});
		buttonCancel.setPreferredSize(new Dimension(75, 20));
		buttonCancel.setText("Cancel");
		buttonCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				buttonCancel_actionPerformed();
			}
		});
		panelEast.setLayout(new FlowLayout());
		panelName.setPreferredSize(new Dimension(225, 27));
		panelSet.setPreferredSize(new Dimension(225, 140));
		panelWest.setPreferredSize(new Dimension(235, 169));
		panelEast.setPreferredSize(new Dimension(85, 169));
		comboBoxWidth.setBorder(BorderFactory.createEtchedBorder());
		comboBoxWidth.setPreferredSize(new Dimension(79, 22));
		comboBoxHeight.setBorder(BorderFactory.createEtchedBorder());
		comboBoxHeight.setPreferredSize(new Dimension(79, 22));
		
		comboBoxWidth.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				comboBoxWidth_actionPerformed(e);
			}
		});
		comboBoxHeight.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				comboBoxHeight_actionPerformed(e);
			}
		});
		comboBoxPre.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				comboBoxPre_actionPerformed(e);
			}
		});
		resolutionLabel.setText("Resolution: 72 pixels/inch");
		comboBoxPre.setBorder(BorderFactory.createEtchedBorder());
		comboBoxPre.setPreferredSize(new Dimension(170, 22));
		dialog.getContentPane().add(panelWest);
		BoxLayout boxWest= new BoxLayout(panelWest, BoxLayout.Y_AXIS);
		panelWest.setLayout(boxWest);
		TitledBorder titledBorder = new TitledBorder(" Preset: ");
		panelSet.setBorder(titledBorder);
		panelName.add(labelName);
		panelName.add(nameTextField);
		panelSet.add(comboBoxPre);
		panelSet.add(widthLabel);
		panelSet.add(widthTextField);
		panelSet.add(comboBoxWidth);
		panelSet.add(heightLabel);
		panelSet.add(heightTextField);
		panelSet.add(comboBoxHeight);
		panelSet.add(resolutionLabel);
		panelWest.add(panelName);
		panelWest.add(panelSet);
		dialog.getContentPane().add(panelEast);
		panelEast.add(buttonOk);
		panelEast.add(buttonCancel);
		labelName.setText("Name:");
	}
	
	public void init(String fileName) {
		nameTextField.setText(fileName);
		Dimension screenSize = 
			Toolkit.getDefaultToolkit().getScreenSize();
		dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		dialog.setLocation(screenSize.width/4, screenSize.height/4);	
		dialog.pack();
		dialog.setResizable(false);
		dialog.setVisible(true);
	}	
	
	public void comboBoxWidth_actionPerformed(ActionEvent e) {
		float width;
		float pixelPerInch = 72.0f;
		DecimalFormat df = new DecimalFormat("#.###");
		width = Float.parseFloat(widthTextField.getText());
		JComboBox cb = (JComboBox)e.getSource();
		String newSelection = (String)cb.getSelectedItem();
		if(newSelection == "pixels") {
			comboBoxHeight.setSelectedItem("pixels");
			if(commandWidth == "inches") {
				widthTextField.setText(Integer.toString(Math.round(width * pixelPerInch)));
			}
			else if(commandWidth == "cm") {
				widthTextField.setText(Integer.toString(Math.round(width * pixelPerInch / 2.54f)));
			}
			commandWidth = "pixels";
		}
		else if(newSelection == "inches") {
			comboBoxHeight.setSelectedItem("inches");
			if(commandWidth == "pixels") {
				widthTextField.setText(df.format(width / pixelPerInch));
			}
			else if(commandWidth == "cm") {
				widthTextField.setText(df.format(width / 2.54f));
			}
			commandWidth = "inches";
		}
		else if(newSelection == "cm") {
			comboBoxHeight.setSelectedItem("cm");
			if(commandWidth == "pixels") {
				widthTextField.setText(df.format(width / pixelPerInch * 2.54f));
			}
			else if(commandWidth == "inches") {
				widthTextField.setText(df.format(width * 2.54f));
			}
			commandWidth = "cm";
		}
	}
	
	public void comboBoxHeight_actionPerformed(ActionEvent e) {
		float height;
		float pixelPerInch = 72.0f;
		DecimalFormat df = new DecimalFormat("#.###");
		height = Float.parseFloat(heightTextField.getText());
		JComboBox cb = (JComboBox)e.getSource();
		String newSelection = (String)cb.getSelectedItem();
		if(newSelection == "pixels") {
			comboBoxWidth.setSelectedItem("pixels");
			if(commandHeight == "inches") {
				heightTextField.setText(Integer.toString(Math.round(height * pixelPerInch)));
			}
			else if(commandHeight == "cm") {
				heightTextField.setText(Integer.toString(Math.round(height * pixelPerInch / 2.54f)));
			}
			commandHeight = "pixels";
		}
		else if(newSelection == "inches") {
			comboBoxWidth.setSelectedItem("inches");
			if(commandHeight == "pixels") {
				heightTextField.setText(df.format(height / pixelPerInch));
			}
			else if(commandHeight == "cm") {
				heightTextField.setText(df.format(height / 2.54f));
			}
			commandHeight = "inches";
		}
		else if(newSelection == "cm") {
			comboBoxWidth.setSelectedItem("cm");
			if(commandHeight == "pixels") {
				heightTextField.setText(df.format(height / pixelPerInch * 2.54f));
			}
			else if(commandHeight == "inches") {
				heightTextField.setText(df.format(height * 2.54f));
			}
			commandHeight = "cm";
		}
	}
	public void comboBoxPre_actionPerformed(ActionEvent e) {
		JComboBox cb = (JComboBox)e.getSource();
		String selection = (String)cb.getSelectedItem();
		if(selection != " Custom") {
			widthTextField.setEditable(false);
			heightTextField.setEditable(false);
		}
		if(selection == " Custom") {
			widthTextField.setEditable(true);
			heightTextField.setEditable(true);
		}
		else if(selection == " Default SharpPaint Size") {
			comboBoxWidth.setSelectedIndex(0);
			comboBoxHeight.setSelectedIndex(0);
			widthTextField.setText("580");
			heightTextField.setText("435");
		}
		else if(selection == " 2  3") {
			comboBoxWidth.setSelectedIndex(1);
			comboBoxHeight.setSelectedIndex(1);
			widthTextField.setText("2");
			heightTextField.setText("3");
		}
		else if(selection == " 4  6") {
			comboBoxWidth.setSelectedIndex(1);
			comboBoxHeight.setSelectedIndex(1);
			widthTextField.setText("4");
			heightTextField.setText("6");
		}
		else if(selection == " 5  7") {
			comboBoxWidth.setSelectedIndex(1);
			comboBoxHeight.setSelectedIndex(1);
			widthTextField.setText("5");
			heightTextField.setText("7");
		}
		else if(selection == " 3  2") {
			comboBoxWidth.setSelectedIndex(1);
			comboBoxHeight.setSelectedIndex(1);
			widthTextField.setText("3");
			heightTextField.setText("2");
		}
		else if(selection == " 6  4") {
			comboBoxWidth.setSelectedIndex(1);
			comboBoxHeight.setSelectedIndex(1);
			widthTextField.setText("6");
			heightTextField.setText("4");
		}
		else if(selection == " 7  5") {
			comboBoxWidth.setSelectedIndex(1);
			comboBoxHeight.setSelectedIndex(1);
			widthTextField.setText("7");
			heightTextField.setText("5");
		}
		else if(selection == " 640  480") {
			comboBoxWidth.setSelectedIndex(0);
			comboBoxHeight.setSelectedIndex(0);
			widthTextField.setText("640");
			heightTextField.setText("480");
		}
		else if(selection == " 800  600") {
			comboBoxWidth.setSelectedIndex(0);
			comboBoxHeight.setSelectedIndex(0);
			widthTextField.setText("800");
			heightTextField.setText("600");
		}
		else if(selection == " 1024  768") {
			comboBoxWidth.setSelectedIndex(0);
			comboBoxHeight.setSelectedIndex(0);
			widthTextField.setText("1024");
			heightTextField.setText("768");
		}
		else if(selection == " Letter") {
			comboBoxWidth.setSelectedIndex(1);
			comboBoxHeight.setSelectedIndex(1);
			widthTextField.setText("8.5");
			heightTextField.setText("11");
		}
		else if(selection == " Legal") {
			comboBoxWidth.setSelectedIndex(1);
			comboBoxHeight.setSelectedIndex(1);
			widthTextField.setText("8.5");
			heightTextField.setText("14");
		}
		else if(selection == " Tabloid") {
			comboBoxWidth.setSelectedIndex(1);
			comboBoxHeight.setSelectedIndex(1);
			widthTextField.setText("11");
			heightTextField.setText("17");
		}
		else if(selection == " Envelope") {
			comboBoxWidth.setSelectedIndex(1);
			comboBoxHeight.setSelectedIndex(1);
			widthTextField.setText("4.122");
			heightTextField.setText("9.5");
		}
		else if(selection == " A4") {
			comboBoxWidth.setSelectedIndex(1);
			comboBoxHeight.setSelectedIndex(1);
			widthTextField.setText("8.2677");
			heightTextField.setText("11.6929");
		}
		else if(selection == " A5") {
			comboBoxWidth.setSelectedIndex(1);
			comboBoxHeight.setSelectedIndex(1);
			widthTextField.setText("5.82677");
			heightTextField.setText("8.2677");
		}
		else if(selection == " B5") {
			comboBoxWidth.setSelectedIndex(1);
			comboBoxHeight.setSelectedIndex(1);
			widthTextField.setText("6.929");
			heightTextField.setText("9.843");
		}
	}

	private class NameTextFieldKeyListener implements KeyListener {

		public void keyPressed(KeyEvent e) {
			if(e.getKeyCode() == KeyEvent.VK_ENTER) {
				buttonOk_actionPerformed();
			}
		}

		public void keyReleased(KeyEvent arg0) {	}
		
		public void keyTyped(KeyEvent arg0) {	}
		
	}
	
	public void buttonOk_actionPerformed() {		
		if(comboBoxHeight.getSelectedIndex() == 0) {
			widthPixel = Integer.parseInt(widthTextField.getText());
			heightPixel = Integer.parseInt(heightTextField.getText());
		}
		else if(comboBoxHeight.getSelectedIndex() == 1) {
			widthPixel = Math.round(Float.parseFloat(widthTextField.getText()) * 72.0f);
			heightPixel = Math.round(Float.parseFloat(heightTextField.getText()) * 72.0f);
		}
		else if(comboBoxHeight.getSelectedIndex() == 2) {
			widthPixel = Math.round(Float.parseFloat(widthTextField.getText()) * 72.0f * 2.54f);
			heightPixel = Math.round(Float.parseFloat(heightTextField.getText()) * 72.0f * 2.54f);
		}
		
		MainWindow.getInstance().makeNewCanvas(
				nameTextField.getText(), 
				widthPixel, 
				heightPixel);
		dialog.dispose();
	}
	
	public void buttonCancel_actionPerformed() {
		dialog.dispose();
	}
	
	public int getWidth() {
		return widthPixel;
	}
	
	public int getHeight() {
		return heightPixel;
	}
}
