package com.sharppaint.graphicprocess;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

//import org.jvnet.substance.SubstanceLookAndFeel;

import com.sharppaint.MainWindow;
import com.sharppaint.drawtools.Element;
import com.sharppaint.toolbar.WestToolBox;

public class VectorColorPanel extends VectorBasicData {

	private JPanel colorPanel, centerPanel;

	private JLabel colorL, colorSpaceL, colorOpacityL, colorOpacityPerL;

	private JButton colorButton;

	private Color color;

	private int colorOpacity = 100;

	private JSlider colorOpacityS;

	private JFormattedTextField colorOpacityT;

	private static VectorColorPanel vectorColorPanel = null;

	public static VectorColorPanel getInstance(Element elem, int elemNum) {
		element = elem;
		elementNum = elemNum;
		if (vectorColorPanel == null)
			vectorColorPanel = new VectorColorPanel();
		return vectorColorPanel;
	}

	public static VectorColorPanel getInstance() {
		return vectorColorPanel;
	}

	public void setColorButonUI() {
		colorButton.setOpaque(true);
	}

	private VectorColorPanel() {
		centerPanel = new JPanel();
		colorPanel = new JPanel();
		colorPanel.setPreferredSize(new Dimension(PANEL_WIDTH, 150));
		colorPanel.setBorder(BorderFactory.createTitledBorder(loweredetched,
				" Color "));
		colorL = new JLabel("        Color: ", SwingConstants.RIGHT);
		colorL.setFont(font);
		colorButton = new JButton();
		colorButton.setPreferredSize(new Dimension(35, 18));
		//colorButton.putClientProperty(
		//		SubstanceLookAndFeel.PAINT_ACTIVE_PROPERTY, Boolean.TRUE);
		colorButton.setOpaque(true);
		colorSpaceL = new JLabel(
				"                                                    ");
		colorOpacityS = new JSlider(OPACITY_MIN, OPACITY_MAX, OPACITY_MAX);
		colorOpacityS.setPreferredSize(new Dimension(120, 18));
		colorOpacityS.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				colorOpacityS_stateChanged(e);
			}
		});
		formatter.setMinimum(new Integer(OPACITY_MIN));
		formatter.setMaximum(new Integer(OPACITY_MAX));
		colorOpacityT = new JFormattedTextField(formatter);
		colorOpacityT.setValue(new Integer(OPACITY_MAX));
		colorOpacityT.setColumns(3); // get some space
		colorOpacityT.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				colorOpacityT_propertyChange(e);
			}
		});
		if (element.getColorMode()) {
			color = element.getFillColor();
			//if (color != null) {
				colorButton.setBackground(color);
				colorOpacity = (int) element.getColorOpacityPercent();
				colorOpacityS.setValue(colorOpacity);
			//}
		}
		else {
			color = MainWindow.getInstance().getPanel().getFillColor();
			colorButton.setBackground(color);
		}/*
		color = element.getFillColor();
		if (color != null) {
			colorButton.setBackground(color);
			colorOpacity = (int) element.getColorOpacityPercent();
			colorOpacityS.setValue(colorOpacity);
		} else {
		}*/
		colorButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				colorButton_actionPerformed();
			}
		});
		colorOpacityL = new JLabel("    Opacity:", SwingConstants.RIGHT);
		colorOpacityPerL = new JLabel("%       ");
		colorL.setFont(font);
		colorOpacityL.setFont(font);
		colorOpacityPerL.setFont(font);
		colorKeyCheck();
		colorPanel.add(colorL);
		colorPanel.add(colorButton);
		colorPanel.add(colorSpaceL);
		colorPanel.add(colorOpacityL);
		colorPanel.add(colorOpacityS);
		colorPanel.add(colorOpacityT);
		colorPanel.add(colorOpacityPerL);
		centerPanel.add(colorPanel);
		// centerPanel.add(Box.createRigidArea(new Dimension(0, 140)));
		centerPanel.setBorder(BorderFactory.createTitledBorder(loweredetched,
				" Color Overlay "));
		element.setFillColor(color, colorOpacity, true);
		MainWindow.getInstance().getPanel().setFillColor(element,
				elementNum, color, colorOpacity, true);
	}

	public JPanel getPanel() {
		return centerPanel;
	}

	public void init() {
		if (element.getColorMode()) {
			color = element.getFillColor();
			colorButton.setBackground(color);
			colorOpacity = (int) element.getColorOpacityPercent();
			colorOpacityS.setValue(colorOpacity);
		}
		else {
			color = MainWindow.getInstance().getPanel().getFillColor();
			colorButton.setBackground(color);
		}
		colorOpacity = (int) element.getColorOpacityPercent();
		colorOpacityS.setValue(colorOpacity);
		element.setFillColor(color, colorOpacity, true);
		MainWindow.getInstance().getPanel().setFillColor(element,
				elementNum, color, colorOpacity, true);
		WestToolBox.getInstance().setFillColor(
				true, color);
		colorL.setEnabled(true);
		colorSpaceL.setEnabled(true);
		colorOpacityL.setEnabled(true);
		colorOpacityPerL.setEnabled(true);
		colorButton.setEnabled(true);
		colorOpacityS.setEnabled(true);
		colorOpacityT.setEnabled(true);
	}

	public void setDisable() {
		if (element != null) {
			element.setFillColor(color, colorOpacity, false);
			MainWindow.getInstance().getPanel().setFillColor(element,
					elementNum, color, colorOpacity, false);
			WestToolBox.getInstance().setFillColorMode(false);
		}
		colorL.setEnabled(false);
		colorSpaceL.setEnabled(false);
		colorOpacityL.setEnabled(false);
		colorOpacityPerL.setEnabled(false);
		colorButton.setEnabled(false);
		colorOpacityS.setEnabled(false);
		colorOpacityT.setEnabled(false);
	}

	private void colorOpacityS_stateChanged(ChangeEvent e) {
		JSlider source = (JSlider) e.getSource();
		colorOpacity = (int) source.getValue();
		if (!source.getValueIsAdjusting()) { // done adjusting
			colorOpacityT.setValue(colorOpacity);
		} else { // value is adjusting; just set the text
			colorOpacityT.setText(String.valueOf(colorOpacity));
		}
		element.setColorOpacityPercent(colorOpacity);
		MainWindow.getInstance().getPanel().setFillColor(element,
				elementNum, color, colorOpacity, true);
	}

	private void colorOpacityT_propertyChange(PropertyChangeEvent e) {
		if ("value".equals(e.getPropertyName())) {
			Number value = (Number) e.getNewValue();
			if (colorOpacityT != null && value != null) {
				colorOpacityS.setValue(value.intValue());
			}
		}
	}

	public void colorButton_actionPerformed() {
		Color tempcolor = JColorChooser.showDialog(
				MainWindow.getInstance().vectorLayerDialog, " ",
				Color.BLACK);
		if (tempcolor != null) {
			color = tempcolor;
			colorButton.setBackground(color);
			element.setFillColor(color); // patternOpacity
			MainWindow.getInstance().getPanel().setFillColor(element,
					elementNum, color, colorOpacity, true);
			WestToolBox.getInstance().setFillColor(
					true, color);
		}
	}

	private void colorKeyCheck() {
		colorOpacityT.getInputMap().put(
				KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0), "check");
		colorOpacityT.getActionMap().put("check", new AbstractAction() {
			private static final long serialVersionUID = -7379183096023417315L;

			public void actionPerformed(ActionEvent e) {
				if (!colorOpacityT.isEditValid()) { // The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					colorOpacityT.selectAll();
				} else
					try { // The text is valid,
						colorOpacityT.commitEdit(); // so use it.
					} catch (java.text.ParseException exc) {
					}
			}
		});
	}
}
