package com.sharppaint.graphicprocess;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.net.URL;

import javax.swing.*;
import javax.swing.event.*;

import com.sharppaint.Constants;
import com.sharppaint.MainWindow;
import com.sharppaint.drawtools.Element;

public class VectorPatternPanel extends VectorBasicData {

	//	pattern
	boolean firstReadPattern = true;

	private JPanel patternPanel, patternElemPanel, centerPanel;

	private JSlider patternScaleS, patternOpacityS;

	private JFormattedTextField patternScaleT, patternOpacityT;

	private JLabel patternL, patternScaleL;

	private JLabel patternOpPerL, patternPerL;

	private JLabel spaceLabel, patternOpacityL;

	private JButton patternSelButton;

	private int patternScale = 100, patternOpacity = 100;

	private String patternPath;

	private JScrollPane patternScroller;

	private static VectorPatternPanel vectorPatternPanel = null;

	public static VectorPatternPanel getInstance(Element elem, int elemNum) {
		element = elem;
		elementNum = elemNum;
		if (vectorPatternPanel == null)
			vectorPatternPanel = new VectorPatternPanel();
		return vectorPatternPanel;
	}

	public static VectorPatternPanel getInstance() {
		return vectorPatternPanel;
	}

	private VectorPatternPanel() {
		centerPanel = new JPanel();
		centerPanel.setLayout(new BoxLayout(centerPanel, BoxLayout.Y_AXIS));
		patternPanel = new JPanel();
		patternPanel.setBorder(BorderFactory.createTitledBorder(loweredetched,
				"   Pattern "));
		patternPanel.setPreferredSize(new Dimension(PANEL_WIDTH, 345));
		patternSelButton = new JButton();
		patternSelButton.setPreferredSize(new Dimension(48, 48));
		spaceLabel = new JLabel("                                           ");
		patternL = new JLabel("    Pattern:   ", SwingConstants.RIGHT);
		patternOpacityL = new JLabel("     Opacity:", SwingConstants.RIGHT);
		patternOpPerL = new JLabel("%      ");
		patternScaleL = new JLabel("        Scale:", SwingConstants.RIGHT);
		patternPerL = new JLabel("%      ");
		patternL.setFont(font);
		patternOpacityL.setFont(font);
		patternOpPerL.setFont(font);
		patternScaleL.setFont(font);
		patternPerL.setFont(font);
		patternOpacityS = new JSlider(OPACITY_MIN, OPACITY_MAX, OPACITY_MAX);
		patternOpacityS.setPreferredSize(new Dimension(120, 18));
		patternOpacityS.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				patternOpacityS_stateChanged(e);
			}
		});
		patternScaleS = new JSlider(PATTERNRESIZE_MIN, RESIZE_MAX, RESIZE_INIT);
		patternScaleS.setPreferredSize(new Dimension(120, 18));
		patternScaleS.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				patternScaleS_stateChanged(e);
			}
		});
		formatter.setMinimum(new Integer(OPACITY_MIN));
		formatter.setMaximum(new Integer(OPACITY_MAX));
		patternOpacityT = new JFormattedTextField(formatter);
		patternOpacityT.setValue(new Integer(OPACITY_MAX));
		patternOpacityT.setColumns(3); //get some space
		patternOpacityT.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				patternOpacityT_propertyChange(e);
			}
		});
		formatter.setMinimum(new Integer(PATTERNRESIZE_MIN));
		formatter.setMaximum(new Integer(RESIZE_MAX));
		patternScaleT = new JFormattedTextField(formatter);
		patternScaleT.setValue(new Integer(RESIZE_INIT));
		patternScaleT.setColumns(3); //get some space
		patternScaleT.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				patternScaleT_propertyChange(e);
			}
		});
		patternOpacityT.setPreferredSize(new Dimension(35, 18));
		patternScaleT.setPreferredSize(new Dimension(35, 18));
		patternElemPanel = new JPanel();
		patternElemPanel.setPreferredSize(new Dimension(251, 420));
		patternElemPanel.setLayout(new GridLayout(12, 7));
		patternScroller = new JScrollPane(patternElemPanel,
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		patternPath = element.getPatternPath();
		if (patternPath == null)
			patternPath = Constants.PATTERN_PATH + "pattern1.jpg";
		else {
			patternScale = Math.round(element.getPatternScalePercent());
			patternScaleS.setValue(patternScale);
			patternOpacity = Math.round(element.getPatternOpacityPercent());
			patternOpacityS.setValue(patternOpacity);
		}
		for (int i = 1; i < 85; i++) {
			String num = Integer.toString(i);
			patternElemPanel.add(makePatternButton("pattern" + num, num));
		}
		patternKeyCheck();

		patternPanel.add(patternL);
		patternPanel.add(patternSelButton);
		patternPanel.add(spaceLabel);
		patternPanel.add(patternScaleL);
		patternPanel.add(patternScaleS);
		patternPanel.add(patternScaleT);
		patternPanel.add(patternPerL);
		patternPanel.add(patternOpacityL);
		patternPanel.add(patternOpacityS);
		patternPanel.add(patternOpacityT);
		patternPanel.add(patternOpPerL);

		patternSelButton.setIcon(new ImageIcon(getClass().getResource(
				patternPath)));

		patternScroller.setPreferredSize(new Dimension(267, 192));

		patternPanel.add(patternScroller);
		centerPanel.add(patternPanel);
		centerPanel.setBorder(BorderFactory.createTitledBorder(loweredetched,
				" Pattern "));
		element
				.setPatternImage(patternPath, patternScale, patternOpacity,
						true);
		MainWindow.getInstance().getPanel().setPattern(element, elementNum,
				patternPath, patternScale, patternOpacity, true);
	}

	public JPanel getPanel() {
		return centerPanel;
	}

	public void init() {
		if (element != null) {
			patternPath = element.getPatternPath();
			if (patternPath == null) {
				patternPath = Constants.PATTERN_PATH + "pattern1.jpg";
				element.setPatternImage(patternPath, patternScale,
						patternOpacity, true);
				MainWindow.getInstance().getPanel().setPattern(element,
						elementNum, patternPath, patternScale, patternOpacity,
						true);
			} else {
				patternScale = Math.round(element.getPatternScalePercent());
				patternScaleS.setValue(patternScale);
				patternOpacity = Math.round(element.getPatternOpacityPercent());
				patternOpacityS.setValue(patternOpacity);
				element.setPatternImage(patternPath, patternScale,
						patternOpacity, true);
				MainWindow.getInstance().getPanel().setPattern(element,
						elementNum, patternPath, patternScale, patternOpacity,
						true);
			}
			patternSelButton.setIcon(new ImageIcon(getClass().getResource(
					patternPath)));
		}
		patternElemPanel.setVisible(true);
		patternScaleS.setEnabled(true);
		patternOpacityS.setEnabled(true);
		patternScaleT.setEnabled(true);
		patternOpacityT.setEnabled(true);
		patternL.setEnabled(true);
		patternScaleL.setEnabled(true);
		patternOpPerL.setEnabled(true);
		patternPerL.setEnabled(true);
		patternOpacityL.setEnabled(true);
		patternSelButton.setEnabled(true);
	}

	public void setDisable() {
		if (element != null) {
			element.setPatternImage(patternPath, patternScale, patternOpacity,
					false);
			MainWindow.getInstance().getPanel().setPattern(element, elementNum,
					patternPath, patternScale, patternOpacity, false);
		}
		patternElemPanel.setVisible(false);
		patternScaleS.setEnabled(false);
		patternOpacityS.setEnabled(false);
		patternScaleT.setEnabled(false);
		patternOpacityT.setEnabled(false);
		patternL.setEnabled(false);
		patternScaleL.setEnabled(false);
		patternOpPerL.setEnabled(false);
		patternPerL.setEnabled(false);
		patternOpacityL.setEnabled(false);
		patternSelButton.setEnabled(false);
	}

	private JButton makePatternButton(String patternName, String actionCommand) {
		//Look for the image.
		String imgLocation = Constants.PATTERNICON_PATH + patternName + ".jpg";
		URL imageURL = MainWindow.class.getResource(imgLocation);
		//Create and initialize the button.
		JButton button = new JButton();
		button.setActionCommand(actionCommand);
		button.addActionListener(new PatternButtonHandler());
		if (imageURL != null) { //image found
			button.setIcon(new ImageIcon(imageURL));
		} else { //no image found
			System.err.println("Resource not found: " + imgLocation);
		}
		return button;
	}

	private void patternOpacityS_stateChanged(ChangeEvent e) {
		JSlider source = (JSlider) e.getSource();
		patternOpacity = (int) source.getValue();
		if (!source.getValueIsAdjusting()) { //done adjusting
			patternOpacityT.setValue(patternOpacity);
		} else { //value is adjusting; just set the text
			patternOpacityT.setText(String.valueOf(patternOpacity));
		}
		element.setPatternOpacityPercent(patternOpacity);
		MainWindow.getInstance().getPanel().setPatternOpacity(element,
				elementNum, patternOpacity);
	}

	private void patternOpacityT_propertyChange(PropertyChangeEvent e) {
		if ("value".equals(e.getPropertyName())) {
			Number value = (Number) e.getNewValue();
			if (patternOpacityT != null && value != null) {
				patternOpacityS.setValue(value.intValue());
			}
		}
	}

	private void patternScaleS_stateChanged(ChangeEvent e) {
		JSlider source = (JSlider) e.getSource();
		patternScale = (int) source.getValue();
		if (!source.getValueIsAdjusting()) { //done adjusting
			patternScaleT.setValue(patternScale);
		} else { //value is adjusting; just set the text
			patternScaleT.setText(String.valueOf(patternScale));
		}
		element.setPatternScale(patternScale);
		MainWindow.getInstance().getPanel().setPatternScale(element,
				elementNum, patternScale);
	}

	private void patternScaleT_propertyChange(PropertyChangeEvent e) {
		if ("value".equals(e.getPropertyName())) {
			Number value = (Number) e.getNewValue();
			if (patternScaleT != null && value != null) {
				patternScaleS.setValue(value.intValue());
			}
		}
	}

	class PatternButtonHandler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			String cmd = e.getActionCommand();
			patternPath = Constants.PATTERN_PATH + "pattern" + cmd + ".jpg";
			patternSelButton.setIcon(new ImageIcon(getClass().getResource(
					patternPath)));
			element.setPatternImage(patternPath, patternScale, patternOpacity,
					true);
			MainWindow.getInstance().getPanel().setPattern(element, elementNum,
					patternPath, patternScale, patternOpacity, true);
		}
	}

	private void patternKeyCheck() {
		patternScaleT.getInputMap().put(
				KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0), "check");
		patternScaleT.getActionMap().put("check", new AbstractAction() {
			private static final long serialVersionUID = -4106454351992586508L;

			public void actionPerformed(ActionEvent e) {
				if (!patternScaleT.isEditValid()) { //The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					patternScaleT.selectAll();
				} else
					try { //The text is valid,
						patternScaleT.commitEdit(); //so use it.
					} catch (java.text.ParseException exc) {
					}
			}
		});
		patternOpacityT.getInputMap().put(
				KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0), "check");
		patternOpacityT.getActionMap().put("check", new AbstractAction() {
			private static final long serialVersionUID = -7343554735023286550L;

			public void actionPerformed(ActionEvent e) {
				if (!patternOpacityT.isEditValid()) { //The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					patternOpacityT.selectAll();
				} else
					try { //The text is valid,
						patternOpacityT.commitEdit(); //so use it.
					} catch (java.text.ParseException exc) {
					}
			}
		});
	}
}
