package com.sharppaint.graphicprocess;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

import com.sharppaint.MainWindow;
import com.sharppaint.drawtools.DrawToolConst;
import com.sharppaint.drawtools.Element;
import com.sharppaint.drawtools.GradientTool;
import com.sharppaint.drawtools.ImageTool;
import com.sharppaint.layermanager.LayerManagementDialog;
import com.sharppaint.toolbar.WestToolBox;

import java.util.*;

public class VectorProcessDialog extends JDialog {
	/**
	 * 
	 */
	private static final long serialVersionUID = -5603678835817354793L;

	private static VectorProcessDialog vectorProcessDialog = null;

	private JPanel westPanel, eastPanel;

	protected JPanel centerPanel;

	private JButton okButton, cancelButton;

	private JCheckBox viewChk;

	// process menu
	private JButton editB, colorB, gradientB, strokeB, patternB;

	private JCheckBox editC, colorC, gradientC, strokeC, patternC;

	// process menu (image filter button & checkbox)
	private JButton grayB, blurB, sharpenB, brightenB, edgeB, negativeB;

	private JCheckBox grayC, blurC, sharpenC, brightenC, edgeC, negativeC;

	private JLabel filterLabel;

	private boolean backupEditMode, backupColorMode;

	private boolean backupGradientMode, backupPatternMode;

	private boolean backupStrokeMode;

	private boolean backupGrayScale;

	private boolean backupBlur;

	private boolean backupSharpen;

	private boolean backupBrighten;

	private boolean backupEdge;

	private boolean backupNegative;

	private static Element element;

	private static int elementNum;

	protected boolean firstReadEdit = true;

	protected boolean firstReadGrad = true;

	protected boolean firstReadStroke = true;

	protected boolean firstReadColor = true;

	protected boolean firstReadPattern = true;

	// edit
	private int backupPercentX = 100, backupPercentY = 100, backupAngle = 0;

	// color
	private Color backupColor;

	private int backupColorOpacity;

	// gradient
	private float backupScaleGrad = 100.0f, backupAngleGrad = 0.0f;

	private int backupGradientOpacity = 100;

	private ArrayList<GradientTool> backupGradList;

	// stroke
	private int backupStrokeSize, backupStrokeOpacity;

	private int backupStrokePosition, backupStrokeFillMode;

	private int backupStrokePatternScale = 100;

	private String backupStrokePatternPath;

	// strokeGradient
	private ArrayList<GradientTool> backupStrokeGradList;

	private float backupStrokeScaleGrad = 100.0f, backupStrokeAngleGrad = 0.0f;

	// strokeColor
	private Color backupStrokeColor;

	// pattern
	private int backupPatternScale, backupPatternOpacity;

	private String backupPatternPath;

	// process panels
	private VectorTransformPanel vectorTransformPanel;

	private VectorColorPanel vectorColorPanel;

	private VectorGradientPanel vectorGradientPanel;

	private VectorPatternPanel vectorPatternPanel;

	private VectorStrokePanel vectorStrokePanel;

	public static VectorProcessDialog getInstance() {
		if (vectorProcessDialog == null)
			vectorProcessDialog = new VectorProcessDialog();
		return vectorProcessDialog;
	}
/*
	public static VectorProcessDialog getInstance() {
		return vectorProcessDialog;
	}*/

	private void init() {
		firstReadEdit = true;
		firstReadGrad = true;
		firstReadStroke = true;
		firstReadColor = true;
		firstReadPattern = true;
		westPanel.removeAll();
		westPanel.add(editB);
		westPanel.add(colorB);
		westPanel.add(gradientB);
		westPanel.add(strokeB);
		westPanel.add(patternB);
		editC.removeItemListener(editC.getItemListeners()[0]);
		colorC.removeItemListener(colorC.getItemListeners()[0]);
		gradientC.removeItemListener(gradientC.getItemListeners()[0]);
		strokeC.removeItemListener(strokeC.getItemListeners()[0]);
		patternC.removeItemListener(patternC.getItemListeners()[0]);

		editC.setSelected(false);
		colorC.setSelected(false);
		gradientC.setSelected(false);
		strokeC.setSelected(false);
		patternC.setSelected(false);
	}

	private void initImage() {
		init();
		westPanel.add(filterLabel);
		westPanel.add(grayB);
		westPanel.add(blurB);
		westPanel.add(sharpenB);
		westPanel.add(brightenB);
		westPanel.add(edgeB);
		westPanel.add(negativeB);
		grayC.removeItemListener(grayC.getItemListeners()[0]);
		blurC.removeItemListener(blurC.getItemListeners()[0]);
		sharpenC.removeItemListener(sharpenC.getItemListeners()[0]);
		brightenC.removeItemListener(brightenC.getItemListeners()[0]);
		edgeC.removeItemListener(edgeC.getItemListeners()[0]);
		negativeC.removeItemListener(negativeC.getItemListeners()[0]);
		grayC.setSelected(false);
		blurC.setSelected(false);
		sharpenC.setSelected(false);
		brightenC.setSelected(false);
		edgeC.setSelected(false);
		negativeC.setSelected(false);
	}

	private void initEvent() {
		editC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		colorC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		gradientC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		strokeC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		patternC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
	}

	private void initImageEvent() {
		initEvent();
		// if (grayC.getItemListeners() != null)
		grayC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		blurC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		sharpenC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		brightenC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		edgeC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		negativeC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
	}

	private VectorProcessDialog() {
		super(LayerManagementDialog.getInstance(), "Style Dialog", false);
		setLayout(new GridLayout(1, 3));
		
		okButton = new JButton("  OK  ");
		cancelButton = new JButton("Cancel");
		editB = new JButton("");
		colorB = new JButton("");
		gradientB = new JButton("");
		strokeB = new JButton("");
		patternB = new JButton("");
		editC = new JCheckBox("Transform");
		colorC = new JCheckBox("Color");
		gradientC = new JCheckBox("Gradient");
		strokeC = new JCheckBox("Stroke");
		patternC = new JCheckBox("Pattern");
		
		editB.setBackground(Color.LIGHT_GRAY);
		colorB.setBackground(Color.LIGHT_GRAY);
		gradientB.setBackground(Color.LIGHT_GRAY);
		strokeB.setBackground(Color.LIGHT_GRAY);
		patternB.setBackground(Color.LIGHT_GRAY);
		
		editC.setOpaque(false);
		colorC.setOpaque(false);
		gradientC.setOpaque(false);
		strokeC.setOpaque(false);
		patternC.setOpaque(false);
		
		editB.setBorder(BorderFactory.createRaisedBevelBorder());
		colorB.setBorder(BorderFactory.createRaisedBevelBorder());
		gradientB.setBorder(BorderFactory.createRaisedBevelBorder());
		strokeB.setBorder(BorderFactory.createRaisedBevelBorder());
		patternB.setBorder(BorderFactory.createRaisedBevelBorder());
		
		editB.addActionListener(new FuncButtonListener());
		colorB.addActionListener(new FuncButtonListener());
		gradientB.addActionListener(new FuncButtonListener());
		strokeB.addActionListener(new FuncButtonListener());
		patternB.addActionListener(new FuncButtonListener());

		editC.setName("transform");
		colorC.setName("color");
		gradientC.setName("gradient");
		strokeC.setName("stroke");
		patternC.setName("pattern");
		
		editC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		colorC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		gradientC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		strokeC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		patternC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		
		editB.add(editC);
		colorB.add(colorC);
		gradientB.add(gradientC);
		strokeB.add(strokeC);
		patternB.add(patternC);
		
		westPanel = new JPanel();
		centerPanel = new JPanel();
		eastPanel = new JPanel();
		westPanel.setPreferredSize(new Dimension(130, 360));
		centerPanel.setPreferredSize(new Dimension(290, 360));
		centerPanel.setLayout(new BoxLayout(centerPanel, BoxLayout.Y_AXIS));
		eastPanel.setPreferredSize(new Dimension(95, 360));
		
		westPanel.setLayout(new GridLayout(12, 1));
		westPanel.add(editB);
		westPanel.add(colorB);
		westPanel.add(gradientB);
		westPanel.add(strokeB);
		westPanel.add(patternB);

		grayB = new JButton("");
		grayB.setBackground(Color.LIGHT_GRAY);
		grayB.setBorder(BorderFactory.createRaisedBevelBorder());
		grayB.addActionListener(new FuncButtonListener());
		grayC = new JCheckBox("GrayScale");
		grayC.setBackground(Color.LIGHT_GRAY);
		grayC.setName("grayscale");

		blurB = new JButton("");
		blurB.setBackground(Color.LIGHT_GRAY);
		blurB.setBorder(BorderFactory.createRaisedBevelBorder());
		blurB.addActionListener(new FuncButtonListener());
		blurC = new JCheckBox("Blur");
		blurC.setBackground(Color.LIGHT_GRAY);
		blurC.setName("blur");

		sharpenB = new JButton("");
		sharpenB.setBackground(Color.LIGHT_GRAY);
		sharpenB.setBorder(BorderFactory.createRaisedBevelBorder());
		sharpenB.addActionListener(new FuncButtonListener());
		sharpenC = new JCheckBox("Sharpen");
		sharpenC.setBackground(Color.LIGHT_GRAY);
		sharpenC.setName("sharpen");

		brightenB = new JButton("");
		brightenB.setBackground(Color.LIGHT_GRAY);
		brightenB.setBorder(BorderFactory.createRaisedBevelBorder());
		brightenB.addActionListener(new FuncButtonListener());
		brightenC = new JCheckBox("Brighten");
		brightenC.setBackground(Color.LIGHT_GRAY);
		brightenC.setName("brighten");

		edgeB = new JButton("");
		edgeB.setBackground(Color.LIGHT_GRAY);
		edgeB.setBorder(BorderFactory.createRaisedBevelBorder());
		edgeB.addActionListener(new FuncButtonListener());
		edgeC = new JCheckBox("Edge");
		edgeC.setBackground(Color.LIGHT_GRAY);
		edgeC.setName("edge");

		negativeB = new JButton("");
		negativeB.setBackground(Color.LIGHT_GRAY);
		negativeB.setBorder(BorderFactory.createRaisedBevelBorder());
		negativeB.addActionListener(new FuncButtonListener());
		negativeC = new JCheckBox("Negative");
		negativeC.setBackground(Color.LIGHT_GRAY);
		negativeC.setName("negative");

		grayC.setOpaque(false);
		blurC.setOpaque(false);
		sharpenC.setOpaque(false);
		brightenC.setOpaque(false);
		edgeC.setOpaque(false);
		negativeC.setOpaque(false);
		
		grayB.add(grayC);
		blurB.add(blurC);
		sharpenB.add(sharpenC);
		brightenB.add(brightenC);
		edgeB.add(edgeC);
		negativeB.add(negativeC);
		
		filterLabel = new JLabel("ImageFilter", SwingConstants.CENTER);
		
		grayB.addActionListener(new FuncButtonListener());
		blurB.addActionListener(new FuncButtonListener());
		sharpenB.addActionListener(new FuncButtonListener());
		brightenB.addActionListener(new FuncButtonListener());
		edgeB.addActionListener(new FuncButtonListener());
		negativeB.addActionListener(new FuncButtonListener());
		
		grayC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		blurC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		sharpenC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		brightenC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		edgeC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		negativeC.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				checkButton_itemStateChange(e);
			}
		});
		/*
		if (toolShape == DrawToolConst.IMAGE) {
			westPanel.add(filterLabel);
			westPanel.add(grayB);
			westPanel.add(blurB);
			westPanel.add(sharpenB);
			westPanel.add(brightenB);
			westPanel.add(edgeB);
			westPanel.add(negativeB);
		}*/
		
		okButton.setPreferredSize(new Dimension(83, 18));
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				okButton_actionPerformed();
			}
		});		
		cancelButton.setPreferredSize(new Dimension(83, 18));
		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cancelButton_actionPerformed();
			}
		});
		
		eastPanel.add(okButton);
		eastPanel.add(Box.createRigidArea(new Dimension(90, 4)));
		eastPanel.add(cancelButton);
		westPanel.setBorder(
				BorderFactory.createBevelBorder(BevelBorder.RAISED));
		getContentPane().setLayout(new FlowLayout());
		getContentPane().add(westPanel);
		getContentPane().add(centerPanel);
		getContentPane().add(eastPanel);
		pack();
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.setLocation(screenSize.width / 3, screenSize.height / 3);
		setVisible(true);
		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		addWindowListener(new DialogDisposeHandler());
		this.setResizable(false);
	}

	private void changeCenterPanel(JPanel panel) {
		centerPanel.removeAll();
		centerPanel.add(panel);
		centerPanel.invalidate();
		centerPanel.validate();
		centerPanel.repaint();
	}
	
	public void setButtonUI() {
		editC.setOpaque(false);
		colorC.setOpaque(false);
		gradientC.setOpaque(false);
		strokeC.setOpaque(false);
		patternC.setOpaque(false);
		
		grayC.setOpaque(false);
		blurC.setOpaque(false);
		sharpenC.setOpaque(false);
		brightenC.setOpaque(false);
		edgeC.setOpaque(false);
		negativeC.setOpaque(false);
		
		editB.setOpaque(true);
		colorB.setOpaque(true);
		gradientB.setOpaque(true);
		strokeB.setOpaque(true);
		patternB.setOpaque(true);
				
		grayB.setOpaque(true);
		blurB.setOpaque(true);
		sharpenB.setOpaque(true);
		brightenB.setOpaque(true);
		edgeB.setOpaque(true);
		negativeB.setOpaque(true);
		
		editB.setBackground(Color.LIGHT_GRAY);
		colorB.setBackground(Color.LIGHT_GRAY);
		gradientB.setBackground(Color.LIGHT_GRAY);
		strokeB.setBackground(Color.LIGHT_GRAY);
		patternB.setBackground(Color.LIGHT_GRAY);
		
		grayB.setBackground(Color.LIGHT_GRAY);
		blurB.setBackground(Color.LIGHT_GRAY);
		sharpenB.setBackground(Color.LIGHT_GRAY);
		brightenB.setBackground(Color.LIGHT_GRAY);
		edgeB.setBackground(Color.LIGHT_GRAY);
		negativeB.setBackground(Color.LIGHT_GRAY);
	}

	class FuncButtonListener implements ActionListener { // help
		public void actionPerformed(ActionEvent e) {
			if (e.getSource().equals(editB)) {
				editC.setSelected(true); // õǾ   
				changeCenterPanel(vectorTransformPanel.getPanel());
			} else if (e.getSource().equals(colorB)) {
				colorC.setSelected(true);
				changeCenterPanel(vectorColorPanel.getPanel());
			} else if (e.getSource().equals(gradientB)) {
				gradientC.setSelected(true);
				changeCenterPanel(vectorGradientPanel.getPanel());
			} else if (e.getSource().equals(strokeB)) {
				strokeC.setSelected(true);
				changeCenterPanel(vectorStrokePanel.getPanel());
			} else if (e.getSource().equals(patternB)) {
				patternC.setSelected(true);
				changeCenterPanel(vectorPatternPanel.getPanel());
			} else if (e.getSource().equals(grayB)) {
				grayC.setSelected(true);
			} else if (e.getSource().equals(blurB)) {
				blurC.setSelected(true);
			} else if (e.getSource().equals(sharpenB)) {
				sharpenC.setSelected(true);
			} else if (e.getSource().equals(brightenB)) {
				brightenC.setSelected(true);
			} else if (e.getSource().equals(edgeB)) {
				edgeC.setSelected(true);
			} else if (e.getSource().equals(negativeB)) {
				negativeC.setSelected(true);
			}
		}
	}

	@SuppressWarnings("unchecked")
	private void checkButton_itemStateChange(ItemEvent e) {
		viewChk = (JCheckBox) e.getItem();
		String funcName = viewChk.getName();
		if (e.getStateChange() == ItemEvent.SELECTED) {
			if (funcName.equals("transform")) {
				if (!firstReadEdit) {
					vectorTransformPanel.init();
				} 
				else { // ó Ͻÿ  Ʈ 
					vectorTransformPanel = VectorTransformPanel.getInstance(
							element, elementNum);
					vectorTransformPanel.init();
					firstReadEdit = false;
				}
				changeCenterPanel(vectorTransformPanel.getPanel());
			} else if (funcName.equals("color")) {
				if (!firstReadColor) {
					vectorColorPanel.init();
				} 
				else {
					vectorColorPanel = VectorColorPanel.getInstance(element,
							elementNum);
					vectorColorPanel.init();
					firstReadColor = false;
				}
				changeCenterPanel(vectorColorPanel.getPanel());
			} else if (funcName.equals("gradient")) {
				if (!firstReadGrad) {
					vectorGradientPanel.init();
				} 
				else {
					vectorGradientPanel = VectorGradientPanel.getInstance(
							element, elementNum);
					vectorGradientPanel.init();
					firstReadGrad = false;
				}
				changeCenterPanel(vectorGradientPanel.getPanel());
			} else if (funcName.equals("pattern")) {
				if (!firstReadPattern) {
					vectorPatternPanel.init();
				} 
				else {
					vectorPatternPanel = VectorPatternPanel.getInstance(
							element, elementNum);
					vectorPatternPanel.init();
					firstReadPattern = false;
				}
				changeCenterPanel(vectorPatternPanel.getPanel());
			} else if (funcName.equals("stroke")) {
				if (!firstReadStroke) {
					vectorStrokePanel.init();
				} 
				else {
					vectorStrokePanel = VectorStrokePanel.getInstance(element,
							elementNum);
					vectorStrokePanel.init();
					firstReadStroke = false;
				}
				changeCenterPanel(vectorStrokePanel.getPanel());
			} else if (funcName.equals("grayscale")) {
				((ImageTool) element).setGrayScale(true);
				MainWindow.getInstance().getPanel().setElement(element,
						elementNum);
			} else if (funcName.equals("blur")) {
				((ImageTool) element).setBlur(true);
				MainWindow.getInstance().getPanel().setElement(element,
						elementNum);
				// StartDraw.panel.setBlur(element, elementNum);
			} else if (funcName.equals("sharpen")) {
				((ImageTool) element).setSharpen(true);
				MainWindow.getInstance().getPanel().setElement(element,
						elementNum);
				// StartDraw.panel.setSharpen(element, elementNum);
			} else if (funcName.equals("brighten")) {
				((ImageTool) element).setBrighten(true);
				MainWindow.getInstance().getPanel().setElement(element,
						elementNum);
				// StartDraw.panel.setBrighten(element, elementNum);
			} else if (funcName.equals("edge")) {
				((ImageTool) element).setEdge(true);
				MainWindow.getInstance().getPanel().setElement(element,
						elementNum);
			} else if (funcName.equals("negative")) {
				((ImageTool) element).setNegative(true);
				MainWindow.getInstance().getPanel().setElement(element,
						elementNum);
			}
		} else { // ش    ġ
			if (funcName.equals("transform")) {
				vectorTransformPanel.setDisable();
			} else if (funcName.equals("color")) {
				vectorColorPanel.setDisable();
			} else if (funcName.equals("gradient")) {
				vectorGradientPanel.setDisable();
			} else if (funcName.equals("pattern")) {
				vectorPatternPanel.setDisable();
			} else if (funcName.equals("stroke")) {
				vectorStrokePanel.setDisable();
			} else if (funcName.equals("grayscale")) {
				((ImageTool) element).setGrayScale(false);
				MainWindow.getInstance().getPanel().setElement(element,
						elementNum);
			} else if (funcName.equals("blur")) {
				((ImageTool) element).setBlur(false);
				MainWindow.getInstance().getPanel().setElement(element,
						elementNum);
				// StartDraw.panel.setBlur(element, elementNum);
			} else if (funcName.equals("sharpen")) {
				((ImageTool) element).setSharpen(false);
				MainWindow.getInstance().getPanel().setElement(element,
						elementNum);
			} else if (funcName.equals("brighten")) {
				((ImageTool) element).setBrighten(false);
				MainWindow.getInstance().getPanel().setElement(element,
						elementNum);
			} else if (funcName.equals("edge")) {
				((ImageTool) element).setEdge(false);
				MainWindow.getInstance().getPanel().setElement(element,
						elementNum);
			} else if (funcName.equals("negative")) {
				((ImageTool) element).setNegative(false);
				MainWindow.getInstance().getPanel().setElement(element,
						elementNum);
			}
		}
	}

	public void setElement(Element _elem, int _elemNum) {
		element = _elem;
		elementNum = _elemNum;
		if (element.getToolName() == DrawToolConst.IMAGE) {
			initImage();
			initImageEvent();
		} else {
			init();
			initEvent();
		}
		if (element.getRotateMode() == true || element.getScaleMode() == true) {
			backupEditMode = true;
			backupPercentX = (int) (element.getScaleX() * 100);
			backupPercentY = (int) (element.getScaleY() * 100);
			backupAngle = element.getRotateAngle();
			editC.setSelected(true);
		} else
			backupEditMode = false;
		if (element.getColorMode()) {
			backupColorMode = true;
			backupColor = element.getFillColor();
			backupColorOpacity = Math.round(element.getColorOpacityPercent());
			colorC.setSelected(true);
		} else
			backupColorMode = false;
		if (element.getGradientMode()) {
			backupGradientMode = true;
			backupGradList = element.getGradList();
			backupScaleGrad = element.getGradScalePercent();
			backupAngleGrad = element.getGradAngle();
			backupGradientOpacity = element.getGradOpacityPercent();
			gradientC.setSelected(true);
		} else
			backupGradientMode = false;
		if (element.getPatternMode()) {
			backupPatternMode = true;
			backupPatternPath = element.getPatternPath();
			backupPatternScale = Math.round(element.getPatternScalePercent());
			backupPatternOpacity = Math.round(element.getPatternOpacityPercent());
			patternC.setSelected(true);
		} else
			backupPatternMode = false;
		if (element.getStrokeMode()) {
			backupStrokeMode = true;
			backupStrokeSize = (int) element.getStrokeSize();
			backupStrokeOpacity = Math.round(element.getStrokeOpacityPercent());
			backupStrokePosition = element.getStrokePosition();
			backupStrokeFillMode = element.getStrokeFillMode();
			if (backupStrokeFillMode == 0) {
				backupStrokeColor = element.getStrokeColor();
			} else if (backupStrokeFillMode == 1) { // gradient
				backupStrokeGradList = element.getStrokeGradList();
				backupStrokeScaleGrad = element.getStrokeGradScalePercent();
				backupStrokeAngleGrad = element.getStrokeGradAngle();
			} else if (backupStrokeFillMode == 2) { // pattern
				backupStrokePatternPath = element.getStrokePatternPath();
				backupStrokePatternScale = Math.round(element
						.getStrokePatternScalePercent());
			}
			strokeC.setSelected(true);
		} else
			backupStrokeMode = false;

		if (element.getToolName() == DrawToolConst.IMAGE) {

			if (((ImageTool) element).getGrayScale()) {
				backupGrayScale = true;
				grayC.setSelected(true);
			} else
				backupGrayScale = false;

			if (((ImageTool) element).getBlur()) {
				backupBlur = true;
				blurC.setSelected(true);
			} else
				backupBlur = false;

			if (((ImageTool) element).getSharpen()) {
				backupSharpen = true;
				sharpenC.setSelected(true);
			} else
				backupSharpen = false;

			if (((ImageTool) element).getBrighten()) {
				backupBrighten = true;
				brightenC.setSelected(true);
			} else
				backupBrighten = false;

			if (((ImageTool) element).getEdge()) {
				backupEdge = true;
				edgeC.setSelected(true);
			} else
				backupEdge = false;

			if (((ImageTool) element).getNegative()) {
				backupNegative = true;
				negativeC.setSelected(true);
			} else
				backupNegative = false;

		}

	}

	private void okButton_actionPerformed() {
		MainWindow.getInstance().getPanel().setSelectDisable();
		MainWindow.getInstance().vectorLayerDialog.setFuncVector(
				element,
				elementNum);
		dispose();
	}

	private void cancelButton_actionPerformed() {
		if (backupEditMode) {
			MainWindow.getInstance().getPanel().setBackupEdit(element,
					elementNum, backupPercentX, backupPercentY, backupAngle);
		} else {
			
		}
		if (backupColorMode) {
			element.setFillColor(backupColor, backupColorOpacity, true);
			MainWindow.getInstance().getPanel().setFillColor(element,
					elementNum, backupColor, backupColorOpacity, true);
			WestToolBox.getInstance().setFillColor(
					true, backupColor);
		} else {
			element.setColorMode(false);
			MainWindow.getInstance().getPanel().setFillColor(element,
					elementNum, false);
			WestToolBox.getInstance().setFillColorMode(false);
		}
		if (backupGradientMode) {
			element.setGradient(backupGradList, backupGradientOpacity, true);
			element.setGradScalePercent(backupScaleGrad);
			element.setGradAngle(backupAngleGrad);
			MainWindow.getInstance().getPanel().setGradient(element,
					elementNum, backupScaleGrad, backupAngleGrad,
					backupGradientOpacity, true);
		} else {
			element.setGradientMode(false);
			MainWindow.getInstance().getPanel().setGradient(element,
					elementNum, false);
		}
		if (backupPatternMode) {
			element.setPatternImage(backupPatternPath, backupPatternScale,
					backupPatternOpacity, true);
			MainWindow.getInstance().getPanel().setPattern(element, elementNum,
					backupPatternPath, backupPatternScale,
					backupPatternOpacity, true);
			// patternPath, patternScale, patternOpacity, true);
		} else {
			element.setPatternMode(false);
			MainWindow.getInstance().getPanel().setPattern(element, elementNum,
					false);
		}
		if (backupStrokeMode) {
			element.setStroke(backupStrokeSize, backupStrokeOpacity,
					backupStrokePosition, backupStrokeFillMode, true);
			MainWindow.getInstance().getPanel().setStroke(element, elementNum,
					backupStrokeSize, backupStrokeOpacity,
					backupStrokePosition, backupStrokeFillMode, true);
			if (backupStrokeFillMode == 0) {
				element.setStrokeColor(backupStrokeColor);
				MainWindow.getInstance().getPanel().setStrokeColor(element,
						elementNum, backupStrokeColor);
				WestToolBox.getInstance().setStrokeColor(
						true, backupStrokeColor);
			} else if (backupStrokeFillMode == 1) { // gradient
				element.setStrokeGradient(backupStrokeGradList);
				element.setStrokeGradScale(backupStrokeScaleGrad);
				element.setStrokeGradAngle(backupStrokeAngleGrad);
				MainWindow.getInstance().getPanel().setStrokeGradient(element,
						elementNum, backupStrokeScaleGrad,
						backupStrokeAngleGrad);
				WestToolBox.getInstance().setStrokeColorMode(false);
			} else if (backupStrokeFillMode == 2) { // pattern
				element.setStrokePatternImage(backupStrokePatternPath,
						backupStrokePatternScale);
				MainWindow.getInstance().getPanel().setStrokePattern(element,
						elementNum, backupStrokePatternPath,
						backupStrokePatternScale);
				WestToolBox.getInstance().setStrokeColorMode(false);
			}
			// strokeC.setSelected(true);
		} else {
			element.setStrokeMode(false);
			MainWindow.getInstance().getPanel().setStroke(element, elementNum,
					false);
		}

		if (element.getToolName() == DrawToolConst.IMAGE) {
			if (backupGrayScale)
				((ImageTool) element).setGrayScale(true);
			else
				((ImageTool) element).setGrayScale(false);

			if (backupBlur)
				((ImageTool) element).setBlur(true);
			else
				((ImageTool) element).setBlur(false);

			if (backupSharpen)
				((ImageTool) element).setSharpen(true);
			else
				((ImageTool) element).setSharpen(false);

			if (backupBrighten)
				((ImageTool) element).setBrighten(true);
			else
				((ImageTool) element).setBrighten(false);

			if (backupEdge)
				((ImageTool) element).setEdge(true);
			else
				((ImageTool) element).setEdge(false);

			if (backupNegative)
				((ImageTool) element).setNegative(true);
			else
				((ImageTool) element).setNegative(false);

			MainWindow.getInstance().getPanel().setElement(
					element, elementNum);
		}

		MainWindow.getInstance().getPanel().setSelectDisable();
		dispose();
	}

	class DialogDisposeHandler extends WindowAdapter {
		public void windowClosing(WindowEvent arg0) {
			cancelButton_actionPerformed();
		}
	}
}