package com.sharppaint.graphicprocess;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridLayout;
import java.awt.LinearGradientPaint;
import java.awt.MultipleGradientPaint;
import java.awt.Toolkit;
import java.awt.event.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.net.URL;
import java.util.ArrayList;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

//import org.jvnet.substance.SubstanceLookAndFeel;

import com.sharppaint.Constants;
import com.sharppaint.MainWindow;
import com.sharppaint.drawtools.DrawToolConst;
import com.sharppaint.drawtools.Element;
import com.sharppaint.drawtools.GradientTool;
import com.sharppaint.toolbar.WestToolBox;

public class VectorStrokePanel extends VectorBasicData {
	private boolean match = false;

	private Color gradButtonColor = Color.WHITE;

	// stroke
	private JPanel strokeP, fillTypePanel, strokePatternsPanel, strokePanel;

	private JSlider strokeSizeS, strokeOpacityS;

	private JFormattedTextField strokeSizeT, strokeOpacityT;

	private JComboBox strokePositionC, strokeFillC;

	private JLabel strokeSizeL, strokeSizePxL, strokePositionL;

	private JLabel strokeOpacityL, strokeOpPerL, strokeFillL;

	private String[] strokePositionList = { "Outside", "Inside", "Center" };

	private String[] strokeFillList = { "Color", "Gradient", "Pattern" };

	private int strokeSize = 1, strokeOpacity = 100;

	private int strokeFillMode = 0, strokePosition = 0;

	protected boolean firstReadCStroke = true;

	protected boolean firstReadPStroke = true;

	protected boolean firstReadGStroke = true;

	// strokePattern
	private int strokePatternScale = 100;

	private String strokePatternPath;

	private JSlider strokePatternScaleS;

	private JLabel strokePatternL, strokePatternScaleL, strokePatternPerL;

	private JFormattedTextField strokePatternScaleT;

	private JButton strokePatternSelButton;

	private JScrollPane strokeScroller;

	// strokeGradient
	private JSlider strokeGradScaleS, strokeGradAngleS;

	private JFormattedTextField strokeGradScaleT, strokeGradAngleT;

	private JLabel strokeGradScaleL, strokeGradAngleL;

	private JLabel strokeGradPerL, strokeGradRadL;

	private StrokeGradPanel sGradPanel;

	private StrokeGradClickPanel strokeGradClickPanel;

	private ArrayList<GradientTool> strokeGradList, posStrokeGradList;

	private GradientTool gradRect, paintRect, tempRect;

	private float strokeScaleGrad = 100.0f, strokeAngleGrad = 0.0f;

	private int x1, y1, x2;

	private Color tempColor;

	private Color[] gradColors;
	
	private float[] gradDist;
	
	private int gradListSize;

	// strokeColor
	private JLabel strokeColorL, strokeSpace;

	private JButton strokeColorButton;

	private Color strokeColor;

	private static VectorStrokePanel vectorStrokePanel = null;

	public static VectorStrokePanel getInstance(Element elem, int elemNum) {
		element = elem;
		elementNum = elemNum;
		if (vectorStrokePanel == null)
			vectorStrokePanel = new VectorStrokePanel();
		return vectorStrokePanel;
	}

	public static VectorStrokePanel getInstance() {
		return vectorStrokePanel;
	}

	private VectorStrokePanel() {
		strokePanel = new JPanel();
		strokePanel.setLayout(new BoxLayout(strokePanel, BoxLayout.Y_AXIS));
		strokeP = new JPanel();
		strokeP.setBorder(BorderFactory.createTitledBorder(loweredetched,
				" Stroke "));
		strokeP.setPreferredSize(new Dimension(280, 105));
		strokeSizeL = new JLabel("         Size:", SwingConstants.RIGHT);
		strokeSizePxL = new JLabel("px   ");
		strokePositionL = new JLabel("   Position: ", SwingConstants.RIGHT);
		strokeOpacityL = new JLabel("    Opacity:", SwingConstants.RIGHT);
		strokeOpPerL = new JLabel("%     ");
		strokeFillL = new JLabel("   Fill Type: ", SwingConstants.RIGHT);
		strokeSizeL.setFont(font);
		strokeSizePxL.setFont(font);
		strokePositionL.setFont(font);
		strokeOpacityL.setFont(font);
		strokeOpPerL.setFont(font);
		strokeFillL.setFont(font);
		strokeSizeS = new JSlider(1, OPACITY_MAX, 1);
		strokeSizeS.setPreferredSize(new Dimension(120, 18));
		strokeSizeS.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				strokeSizeS_stateChanged(e);
			}
		});
		strokeOpacityS = new JSlider(OPACITY_MIN, OPACITY_MAX, OPACITY_MAX);
		strokeOpacityS.setPreferredSize(new Dimension(120, 18));
		strokeOpacityS.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				strokeOpacityS_stateChanged(e);
			}
		});
		formatter.setMinimum(new Integer(1));
		formatter.setMaximum(new Integer(OPACITY_MAX));
		strokeSizeT = new JFormattedTextField(formatter);
		strokeSizeT.setValue(new Integer(1));
		strokeSizeT.setColumns(3); // get some space
		strokeSizeT.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				strokeSizeT_propertyChange(e);
			}
		});
		formatter.setMinimum(new Integer(OPACITY_MIN));
		formatter.setMaximum(new Integer(OPACITY_MAX));
		strokeOpacityT = new JFormattedTextField(formatter);
		strokeOpacityT.setValue(new Integer(OPACITY_MAX));
		strokeOpacityT.setColumns(3); // get some space
		strokeOpacityT.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				strokeOpacityT_propertyChange(e);
			}
		});
		strokeSizeT.setPreferredSize(new Dimension(35, 18));
		strokeOpacityT.setPreferredSize(new Dimension(35, 18));
		strokePositionC = new JComboBox(strokePositionList);
		strokePositionC.setPreferredSize(new Dimension(90, 18));
		strokePositionC.setFont(font);
		strokeFillC = new JComboBox(strokeFillList);
		strokeFillC.setFont(font);
		strokeFillC.setPreferredSize(new Dimension(90, 18));
		strokePositionC.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				strokePositionC_actionPerformed(e);
			}
		});
		strokeFillC.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				strokeFillC_actionPerformed(e);
			}
		});
		fillTypePanel = new JPanel();
		fillTypePanel.setBorder(BorderFactory.createLoweredBevelBorder());
		fillTypePanel.setPreferredSize(new Dimension(270, 170));

		strokeSize = (int) element.getStrokeSize();
		strokeSizeS.setValue(strokeSize);
		strokeOpacity = Math.round(element.getStrokeOpacityPercent());
		strokeOpacityS.setValue(strokeOpacity);
		strokePosition = element.getStrokePosition();
		strokeFillMode = element.getStrokeFillMode();
		strokeKeyCheck();

		strokePositionC.setSelectedIndex(strokePosition);
		strokeFillC.setSelectedIndex(strokeFillMode);
		strokeP.add(strokeSizeL);
		strokeP.add(strokeSizeS);
		strokeP.add(strokeSizeT);
		strokeP.add(strokeSizePxL);
		strokeP.add(strokeOpacityL);
		strokeP.add(strokeOpacityS);
		strokeP.add(strokeOpacityT);
		strokeP.add(strokeOpPerL);
		strokeP.add(strokePositionL);
		strokeP.add(strokePositionC);
		strokeP.add(new JLabel("                                "));
		strokeP.add(strokeFillL);
		strokeP.add(strokeFillC);
		strokeP.add(new JLabel("                                "));
		strokePanel.add(strokeP);
		// strokePanel.add(Box.createRigidArea(new Dimension(0, 10)));
		strokePanel.add(fillTypePanel);
		strokePanel.setBorder(BorderFactory.createTitledBorder(loweredetched,
				" Stroke "));
		element.setStroke(strokeSize, strokeOpacity, strokePosition,
				strokeFillMode, true);
		MainWindow.getInstance().getPanel()
				.setStroke(element, elementNum, strokeSize, strokeOpacity,
						strokePosition, strokeFillMode, true);
	}

	public JPanel getPanel() {
		return strokePanel;
	}

	public void init() {
		if (element != null) {
			strokeSize = (int) element.getStrokeSize();
			strokeSizeS.setValue(strokeSize);
			strokeOpacity = Math.round(element.getStrokeOpacityPercent());
			strokeOpacityS.setValue(strokeOpacity);
			strokePosition = element.getStrokePosition();
			strokeFillMode = element.getStrokeFillMode();
			if (strokeFillMode == 0) { //
				// strokeColor = element.getStrokeColor();

				strokeFillC.setSelectedIndex(0);
			} 
			else if (strokeFillMode == 1) { // gradient
				strokeGradList = element.getStrokeGradList();
				if (strokeGradList == null) {
					strokeGradList = new ArrayList<GradientTool>();
					gradRect = new GradientTool(0, Color.BLACK);
					strokeGradList.add(gradRect);
					gradRect = new GradientTool(200, Color.WHITE);
					strokeGradList.add(gradRect);
					if (strokeGradScaleS != null)
						strokeGradScaleS.setValue(Math.round(strokeScaleGrad));
					if (strokeGradAngleS != null)
						strokeGradAngleS.setValue(Math.round(strokeAngleGrad));
					/*
					* if(strokeGradList.size()>1)
					* element.setStrokeGradient(strokeGradList);
					* MainWindow.getInstance().getPanel().setStrokeGradient(
					* element,
					* elementNum,
					* strokeScaleGrad,
					* strokeAngleGrad);
					*/
				} 
				else {
					strokeScaleGrad = element.getStrokeGradScalePercent();
					strokeAngleGrad = element.getStrokeGradAngle();
					if (strokeGradScaleS != null)
						strokeGradScaleS.setValue(Math.round(strokeScaleGrad));
					if (strokeGradAngleS != null)
						strokeGradAngleT.setValue(Math.round(strokeAngleGrad));
				}
				if (strokeGradClickPanel != null)
					strokeGradClickPanel.repaint();
				strokeFillC.setSelectedIndex(1);
				
			} 
			else if (strokeFillMode == 2) { // pattern
				strokePatternPath = element.getStrokePatternPath();
				if (strokePatternPath == null) {
					strokePatternPath = Constants.PATTERN_PATH + "pattern1.jpg";
					element.setStrokePatternImage(strokePatternPath,
							strokePatternScale);
					MainWindow.getInstance().getPanel().setStrokePattern(
							element, elementNum, strokePatternPath,
							strokePatternScale);
				} 
				else {
					strokePatternScale = Math.round(element
							.getStrokePatternScalePercent());
					if(strokePatternScaleS != null)
						strokePatternScaleS.setValue(strokePatternScale);
				}
				if (strokeFillC != null)
					strokeFillC.setSelectedIndex(2);
			}
			element.setStroke(strokeSize, strokeOpacity, strokePosition,
					strokeFillMode, true);
			MainWindow.getInstance().getPanel().setStroke(element, elementNum,
					strokeSize, strokeOpacity, strokePosition, strokeFillMode,
					true);
		}
		/*
		 * element.setStroke( strokeSize, strokeOpacity, strokePosition,
		 * strokeFillMode, true); MainWindow.getInstance().getPanel().setStroke(
		 * element, elementNum, strokeSize, strokeOpacity, strokePosition,
		 * strokeFillMode, true); if(strokeFillMode == 0) {
		 * element.setStrokeColor(strokeColor);
		 * MainWindow.getInstance().getPanel().setStrokeColor( element,
		 * elementNum, strokeColor); } else if(strokeFillMode == 1) { //gradient }
		 * else if(strokeFillMode == 2) { //pattern }
		 */
		/*
		 * firstReadCStroke = true; firstReadPStroke = true; firstReadGStroke =
		 * true;
		 */
		strokeSizeS.setEnabled(true);
		strokeOpacityS.setEnabled(true);
		strokeSizeT.setEnabled(true);
		strokeOpacityT.setEnabled(true);
		strokePositionC.setEnabled(true);
		strokeFillC.setEnabled(true);
		strokeSizeL.setEnabled(true);
		strokeSizePxL.setEnabled(true);
		strokePositionL.setEnabled(true);
		strokeOpacityL.setEnabled(true);
		strokeOpPerL.setEnabled(true);
		strokeFillL.setEnabled(true);
		fillTypePanel.setVisible(true);
	}

	public void setDisable() {
		strokeSizeS.setEnabled(false);
		strokeOpacityS.setEnabled(false);
		strokeSizeT.setEnabled(false);
		strokeOpacityT.setEnabled(false);
		strokePositionC.setEnabled(false);
		strokeFillC.setEnabled(false);
		strokeSizeL.setEnabled(false);
		strokeSizePxL.setEnabled(false);
		strokePositionL.setEnabled(false);
		strokeOpacityL.setEnabled(false);
		strokeOpPerL.setEnabled(false);
		strokeFillL.setEnabled(false);
		fillTypePanel.setVisible(false);
		//System.out.println(element.getShape());
		if (element != null) {
			if (strokeFillMode == 0) {
				element.setStrokeColor(strokeColor);
				MainWindow.getInstance().getPanel().setStrokeColor(element,
						elementNum, strokeColor);
			} else if (strokeFillMode == 1) { // gradient
				element.setStrokeGradient(strokeGradList);
				MainWindow.getInstance().getPanel().setStrokeGradient(element,
						elementNum, strokeScaleGrad, strokeAngleGrad);
			} else if (strokeFillMode == 2) { // pattern
				element.setStrokePatternImage(strokePatternPath,
						strokePatternScale);
				MainWindow.getInstance().getPanel().setStrokePattern(element,
						elementNum, strokePatternPath, strokePatternScale);
			}
			element.setStroke(strokeSize, strokeOpacity, strokePosition,
					strokeFillMode, false);
			WestToolBox.getInstance().setStrokeColorMode(false);
			MainWindow.getInstance().getPanel().setStroke(element, elementNum,
					strokeSize, strokeOpacity, strokePosition, strokeFillMode,
					false);
		}
	}

	private void strokeSizeS_stateChanged(ChangeEvent e) {
		JSlider source = (JSlider) e.getSource();
		strokeSize = (int) source.getValue();
		if (!source.getValueIsAdjusting()) { // done adjusting
			strokeSizeT.setValue(strokeSize);
		} else { // value is adjusting; just set the text
			strokeSizeT.setText(String.valueOf(strokeSize));
		}
		element.setStrokeSize(strokeSize);
		MainWindow.getInstance().getPanel().setFuncStrokeSize(element,
				elementNum, strokeSize);
	}

	private void strokeSizeT_propertyChange(PropertyChangeEvent e) {
		if ("value".equals(e.getPropertyName())) {
			Number value = (Number) e.getNewValue();
			if (strokeSizeT != null && value != null) {
				strokeSizeS.setValue(value.intValue());
			}
		}
	}

	private void strokeOpacityS_stateChanged(ChangeEvent e) {
		JSlider source = (JSlider) e.getSource();
		strokeOpacity = (int) source.getValue();
		if (!source.getValueIsAdjusting()) { // done adjusting
			strokeOpacityT.setValue(strokeOpacity);
		} else { // value is adjusting; just set the text
			strokeOpacityT.setText(String.valueOf(strokeOpacity));
		}
		element.setStrokeOpacityPercent(strokeOpacity);
		MainWindow.getInstance().getPanel().setStrokeOpacity(element,
				elementNum, strokeOpacity);
	}

	private void strokeOpacityT_propertyChange(PropertyChangeEvent e) {
		if ("value".equals(e.getPropertyName())) {
			Number value = (Number) e.getNewValue();
			if (strokeOpacityT != null && value != null) {
				strokeOpacityS.setValue(value.intValue());
			}
		}
	}

	private void strokePositionC_actionPerformed(ActionEvent e) {
		JComboBox cb = (JComboBox) e.getSource();
		String newSelection = (String) cb.getSelectedItem();
		if (newSelection == "Outside") {
			strokePosition = 0;
		} else if (newSelection == "Inside") { // comboBoxHeight.setSelectedItem("cm");
			strokePosition = 1;
		} else if (newSelection == "Center") {
			strokePosition = 2;
		}
		element.setStrokePosition(strokePosition);
		MainWindow.getInstance().getPanel().setStrokePosition(element,
				elementNum, strokePosition);
	}

	private void strokeColorButton_actionPerformed() {
		strokeColor = JColorChooser.showDialog(
				MainWindow.getInstance().vectorLayerDialog, " ",
				Color.BLACK);
		if (strokeColor != null) {
			strokeColorButton.setBackground(strokeColor);
			element.setStrokeColor(strokeColor); // patternOpacity
			MainWindow.getInstance().getPanel().setStrokeColor(element,
					elementNum, strokeColor);
			WestToolBox.getInstance().setStrokeColor(
					true, strokeColor);
		} else {
			strokeColor = strokeColorButton.getBackground();
		}
	}

	JLabel strokeGradStyleL;
	JRadioButton strokeGradLinearR;
	JRadioButton strokeGradRadialR;
	StrokeGradStyleRadioListener strokeGradStyleRadioListener;	

	JLabel strokeGradCycleL;
	JRadioButton strokeGradNoCycleR;
	JRadioButton strokeGradRepeatR;
	StrokeGradCycleRadioListener strokeGradCycleRadioListener;
	
	private void strokeFillC_actionPerformed(ActionEvent e) {
		JComboBox cb = (JComboBox) e.getSource();
		String newSelection = (String) cb.getSelectedItem();
		if (newSelection.equals("Color")) {
			strokeFillMode = 0;
			fillTypePanel.removeAll();
			if (firstReadCStroke) {
				strokeColorL = new JLabel("         Color: ",
						SwingConstants.RIGHT);
				strokeColorL.setFont(font);
				strokeColorButton = new JButton();
				strokeColorButton.setPreferredSize(new Dimension(35, 18));
				//strokeColorButton.putClientProperty(
				//		SubstanceLookAndFeel.PAINT_ACTIVE_PROPERTY,
				//		Boolean.TRUE);
				strokeColorButton.setOpaque(true);
				strokeSpace = new JLabel(
						"                                                   ");

				strokeColor = element.getStrokeColor();				
				if (strokeColor != null)
					strokeColorButton.setBackground(strokeColor);
				else {
					strokeColor = MainWindow.getInstance().getPanel()
							.getStrokeColor();
					strokeColorButton.setBackground(strokeColor);
				}
				strokeColorButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						strokeColorButton_actionPerformed();
					}
				});
			}
			fillTypePanel.add(strokeColorL);
			fillTypePanel.add(strokeColorButton);
			fillTypePanel.add(strokeSpace);
			element.setStrokeColor(strokeColor);
			MainWindow.getInstance().getPanel().setStrokeColor(element,
					elementNum, strokeColor);
			WestToolBox.getInstance().setStrokeColor(
					true, strokeColor);
			fillTypePanel.invalidate();
			fillTypePanel.validate();
			fillTypePanel.repaint();
		} else if (newSelection.equals("Gradient")) {
			strokeFillMode = 1;
			fillTypePanel.removeAll();
			if (firstReadGStroke) {
				strokeGradScaleS = new JSlider(RESIZE_MIN, GRADSCALE_MAX,
						GRADSCALE_INIT);
				strokeGradScaleS.setPreferredSize(new Dimension(120, 18));
				strokeGradScaleS.addChangeListener(new ChangeListener() {
					public void stateChanged(ChangeEvent e) {
						strokeGradScaleS_stateChanged(e);
					}
				});
				strokeGradAngleS = new JSlider(GRADROTATE_MIN, GRADROTATE_MAX, ZERO);
				strokeGradAngleS.setPreferredSize(new Dimension(120, 18));
				strokeGradAngleS.addChangeListener(new ChangeListener() {
					public void stateChanged(ChangeEvent e) {
						strokeGradAngleS_stateChanged(e);
					}
				});
				formatter.setMinimum(new Integer(RESIZE_MIN));
				formatter.setMaximum(new Integer(GRADSCALE_MAX));
				strokeGradScaleT = new JFormattedTextField(formatter);
				strokeGradScaleT.setValue(new Integer(GRADSCALE_INIT));
				strokeGradScaleT.setColumns(3); // get some space
				strokeGradScaleT.addPropertyChangeListener(
						new PropertyChangeListener() {
							public void propertyChange(PropertyChangeEvent e) {
								strokeGradScaleT_propertyChange(e);
							}
						});
				formatterRotate.setMinimum(new Integer(GRADROTATE_MIN));
				formatterRotate.setMaximum(new Integer(GRADROTATE_MAX));
				strokeGradAngleT = new JFormattedTextField(formatterRotate);
				strokeGradAngleT.setValue(new Integer(ZERO));
				strokeGradAngleT.setColumns(3); // get some space
				strokeGradAngleT.addPropertyChangeListener(
						new PropertyChangeListener() {
							public void propertyChange(PropertyChangeEvent e) {
								strokeGradAngleT_propertyChange(e);
							}
						});
				strokeGradScaleL = new JLabel("         Scale:",
						SwingConstants.RIGHT);
				strokeGradAngleL = new JLabel("         Angle:",
						SwingConstants.RIGHT);
				strokeGradPerL = new JLabel("%      ");
				strokeGradRadL = new JLabel("        ");
				strokeGradScaleL.setFont(font);
				strokeGradAngleL.setFont(font);
				strokeGradPerL.setFont(font);
				strokeGradRadL.setFont(font);
				strokeGradList = element.getStrokeGradList();
				if (strokeGradList == null || strokeGradList.size()<2) {
					strokeGradList = new ArrayList<GradientTool>();
					gradRect = new GradientTool(0, Color.BLACK);
					strokeGradList.add(gradRect);
					gradRect = new GradientTool(200, Color.WHITE);
					strokeGradList.add(gradRect);
				} else {
					strokeScaleGrad = element.getStrokeGradScalePercent();
					strokeAngleGrad = element.getStrokeGradAngle();
					strokeGradScaleS.setValue(Math.round(strokeScaleGrad));
					strokeGradAngleT.setValue(Math.round(strokeAngleGrad));
				}
				sGradPanel = new StrokeGradPanel();
				strokeGradClickPanel = new StrokeGradClickPanel();
				sGradPanel.setPreferredSize(new Dimension(200, 35));
				strokeGradClickPanel.setPreferredSize(new Dimension(210, 13));
				strokeGradClickPanel.setBackground(Color.GRAY);
				strokeGradClickPanel.addMouseListener(new SMouseListener());
				strokeGradClickPanel.addMouseMotionListener(
						new SMouseMotionListener());
				// sGradPanel.repaint();
				
				strokeGradStyleL = new JLabel("         Style:", SwingConstants.RIGHT);
				strokeGradStyleRadioListener = new StrokeGradStyleRadioListener();
				strokeGradLinearR = new JRadioButton("Linear");
				strokeGradLinearR.setActionCommand("Linear");
				strokeGradRadialR = new JRadioButton("Radial");
				strokeGradRadialR.setActionCommand("Radial");
				strokeGradLinearR.addActionListener(strokeGradStyleRadioListener);
				strokeGradRadialR.addActionListener(strokeGradStyleRadioListener);
				strokeGradStyleL.setFont(font);
				strokeGradLinearR.setFont(font);
				strokeGradRadialR.setFont(font);
			    ButtonGroup gradStyleGroup = new ButtonGroup();
			    gradStyleGroup.add(strokeGradLinearR);
			    gradStyleGroup.add(strokeGradRadialR);
			    
			    strokeGradCycleL = new JLabel("         Cycle:", SwingConstants.RIGHT);
			    strokeGradCycleRadioListener = new StrokeGradCycleRadioListener();
			    strokeGradNoCycleR = new JRadioButton("No_Cycle");
			    strokeGradNoCycleR.setActionCommand("No_Cycle");
			    strokeGradNoCycleR.addActionListener(strokeGradCycleRadioListener);
			    strokeGradRepeatR = new JRadioButton("Repeat");
			    strokeGradRepeatR.setActionCommand("Repeat");
			    strokeGradRepeatR.addActionListener(strokeGradCycleRadioListener);
			    strokeGradCycleL.setFont(font);
			    strokeGradNoCycleR.setFont(font);
			    strokeGradRepeatR.setFont(font);
			    ButtonGroup gradCycleGroup = new ButtonGroup();
			    gradCycleGroup.add(strokeGradNoCycleR);
			    gradCycleGroup.add(strokeGradRepeatR);
			    
				firstReadGStroke = false;
			}
			strokeGradClickPanel.repaint();
			fillTypePanel.add(Box.createRigidArea(new Dimension(190, 10)));
			fillTypePanel.add(sGradPanel);
			fillTypePanel.add(strokeGradClickPanel);
			fillTypePanel.add(strokeGradScaleL);
			fillTypePanel.add(strokeGradScaleS);
			fillTypePanel.add(strokeGradScaleT);
			fillTypePanel.add(strokeGradPerL);
			fillTypePanel.add(strokeGradAngleL);
			fillTypePanel.add(strokeGradAngleS);
			fillTypePanel.add(strokeGradAngleT);
			fillTypePanel.add(strokeGradRadL);
			fillTypePanel.add(strokeGradStyleL);
			fillTypePanel.add(strokeGradLinearR);
			fillTypePanel.add(strokeGradRadialR);
			fillTypePanel.add(new JLabel("                    "));
			fillTypePanel.add(strokeGradCycleL);
			fillTypePanel.add(strokeGradNoCycleR);
			fillTypePanel.add(strokeGradRepeatR);
			fillTypePanel.add(new JLabel("              "));
			if(element.getStrokeGradStyle() == DrawToolConst.LINEAR_GRAD) {
				strokeGradLinearR.setSelected(true);
			} else {
				strokeGradRadialR.setSelected(true);
			}
			if(element.isStrokeGradCycle()) {
				strokeGradRepeatR.setSelected(true);
			} else {
				strokeGradNoCycleR.setSelected(true);
			}
			fillTypePanel.invalidate();
			fillTypePanel.validate();
			fillTypePanel.repaint();
			strokeGradKeyCheck();
		} 
		else if (newSelection.equals("Pattern")) {
			strokeFillMode = 2;
			fillTypePanel.removeAll();
			if (firstReadPStroke) {
				strokePatternsPanel = new JPanel();
				strokePatternsPanel.setPreferredSize(new Dimension(251, 420));
				strokePatternsPanel.setLayout(new GridLayout(12, 7));
				strokeScroller = new JScrollPane(strokePatternsPanel,
						JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
						JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
				strokeScroller.setPreferredSize(new Dimension(267, 160));
				strokePatternSelButton = new JButton();
				strokePatternSelButton.setPreferredSize(new Dimension(30, 30));
				strokePatternL = new JLabel("Pattern:", SwingConstants.RIGHT);
				strokePatternScaleL = new JLabel("   Scale:",
						SwingConstants.RIGHT);
				strokePatternPerL = new JLabel("%");
				strokePatternL.setFont(font);
				strokePatternScaleL.setFont(font);
				strokePatternPerL.setFont(font);
				strokePatternScaleS = new JSlider(PATTERNRESIZE_MIN,
						RESIZE_MAX, RESIZE_INIT);
				strokePatternScaleS.setPreferredSize(new Dimension(120, 18));
				strokePatternScaleS.addChangeListener(new ChangeListener() {
					public void stateChanged(ChangeEvent e) {
						strokePatternScaleS_stateChanged(e);
					}
				});
				strokePatternScaleS.setPreferredSize(new Dimension(68, 20));
				formatter.setMinimum(new Integer(PATTERNRESIZE_MIN));
				formatter.setMaximum(new Integer(RESIZE_MAX));
				strokePatternScaleT = new JFormattedTextField(formatter);
				strokePatternScaleT.setValue(new Integer(RESIZE_INIT));
				strokePatternScaleT.setColumns(3); // get some space
				strokePatternScaleT
						.addPropertyChangeListener(new PropertyChangeListener() {
							public void propertyChange(PropertyChangeEvent e) {
								strokePatternScaleT_propertyChange(e);
							}
						});
				strokePatternScaleT.setPreferredSize(new Dimension(35, 18));

				for (int i = 1; i < 85; i++) {
					String num = Integer.toString(i);
					strokePatternsPanel.add(makeStrokePatternButton2("pattern"
							+ num, num));
				}

				strokePatternPath = element.getStrokePatternPath();
				if (strokePatternPath == null)
					strokePatternPath = Constants.PATTERN_PATH + "pattern1.jpg";
				else {
					strokePatternScale = Math.round(element
							.getStrokePatternScalePercent());
					strokePatternScaleS.setValue(strokePatternScale);
				}
				firstReadPStroke = false;
			}
			fillTypePanel.add(strokePatternL);
			fillTypePanel.add(strokePatternSelButton);
			fillTypePanel.add(strokePatternScaleL);
			fillTypePanel.add(strokePatternScaleS);
			fillTypePanel.add(strokePatternScaleT);
			fillTypePanel.add(strokePatternPerL);
			fillTypePanel.add(strokeScroller);
			strokePatternSelButton.setIcon(new ImageIcon(getClass()
					.getResource(strokePatternPath)));
			element
					.setStrokePatternImage(strokePatternPath,
							strokePatternScale);
			MainWindow.getInstance().getPanel().setStrokePattern(element,
					elementNum, strokePatternPath, strokePatternScale);
			strokePatternKeyCheck();
			fillTypePanel.invalidate();
			fillTypePanel.validate();
			fillTypePanel.repaint();
		}
		element.setStrokeFillMode(strokeFillMode);
		MainWindow.getInstance().getPanel().setStrokeFillMode(element,
				elementNum, strokeFillMode);
	}

	private void strokeGradScaleS_stateChanged(ChangeEvent e) {
		JSlider source = (JSlider) e.getSource();
		strokeScaleGrad = (int) source.getValue();
		if (!source.getValueIsAdjusting()) { // done adjusting
			strokeGradScaleT.setValue(new Integer(Math.round(strokeScaleGrad)));
		} else { // value is adjusting; just set the text
			strokeGradScaleT.setText(String.valueOf(strokeScaleGrad));
		}
		element.setStrokeGradScale(strokeScaleGrad);
		if (sGradPanel != null)
			sGradPanel.repaint();
		// StartDraw.panel.setResizeX(element, elementNum, percent);
	}

	private void strokeGradAngleS_stateChanged(ChangeEvent e) {
		JSlider source = (JSlider) e.getSource();
		strokeAngleGrad = (int) source.getValue();
		if (!source.getValueIsAdjusting()) { // done adjusting
			strokeGradAngleT.setValue(new Integer(Math.round(strokeAngleGrad)));
		} else { // value is adjusting; just set the text
			strokeGradAngleT.setText(String.valueOf(strokeAngleGrad));
		}
		element.setStrokeGradAngle(strokeAngleGrad);
		if (sGradPanel != null)
			sGradPanel.repaint();
	}

	private void strokeGradScaleT_propertyChange(PropertyChangeEvent e) {
		if ("value".equals(e.getPropertyName())) {
			Number value = (Number) e.getNewValue();
			if (strokeGradScaleT != null && value != null) {
				strokeGradScaleS.setValue(value.intValue());
			}
		}
	}

	private void strokeGradAngleT_propertyChange(PropertyChangeEvent e) {
		if ("value".equals(e.getPropertyName())) {
			Number value = (Number) e.getNewValue();
			if (strokeGradAngleT != null && value != null) {
				strokeGradAngleS.setValue(value.intValue());
			}
		}
	}

	private void strokePatternScaleS_stateChanged(ChangeEvent e) {
		JSlider source = (JSlider) e.getSource();
		strokePatternScale = (int) source.getValue();
		if (!source.getValueIsAdjusting()) { // done adjusting
			strokePatternScaleT.setValue(strokePatternScale);
		} else { // value is adjusting; just set the text
			strokePatternScaleT.setText(String.valueOf(strokePatternScale));
		}
		element.setStrokePatternScale(strokePatternScale);
		MainWindow.getInstance().getPanel().setStrokePatternScale(element,
				elementNum, strokePatternScale);
	}

	private void strokePatternScaleT_propertyChange(PropertyChangeEvent e) {
		if ("value".equals(e.getPropertyName())) {
			Number value = (Number) e.getNewValue();
			if (strokePatternScaleT != null && value != null) {
				strokePatternScaleS.setValue(value.intValue());
			}
		}
	}

	private JButton makeStrokePatternButton2(String patternName,
			String actionCommand) {
		// Look for the image.
		String imgLocation = Constants.PATTERNICON_PATH + patternName + ".jpg";
		URL imageURL = MainWindow.class.getResource(imgLocation);
		// Create and initialize the button.
		JButton button = new JButton();
		button.setActionCommand(actionCommand);
		button.addActionListener(new StrokePatternButtonHandler());
		if (imageURL != null) { // image found
			button.setIcon(new ImageIcon(imageURL));
		} else { // no image found
			System.err.println("Resource not found: " + imgLocation);
		}
		return button;
	}

	class StrokePatternButtonHandler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			String cmd = e.getActionCommand();
			strokePatternPath = Constants.PATTERN_PATH + "pattern" + cmd + ".jpg";
			strokePatternSelButton.setIcon(new ImageIcon(getClass()
					.getResource(strokePatternPath)));
			element
					.setStrokePatternImage(strokePatternPath,
							strokePatternScale);
			MainWindow.getInstance().getPanel().setStrokePattern(element,
					elementNum, strokePatternPath, strokePatternScale);
		}
	}
	
	class StrokeGradStyleRadioListener implements ActionListener { 
        public void actionPerformed(ActionEvent e) {
        	if(e.getActionCommand().equals("Linear")) {
        		element.setStrokeGradStyle(DrawToolConst.LINEAR_GRAD);        		
        		MainWindow.getInstance().getPanel().setStrokeGradStyle(
        				element, elementNum,
        				DrawToolConst.LINEAR_GRAD);
        	} else {
        		element.setStrokeGradStyle(DrawToolConst.RADIAL_GRAD);     		
        		MainWindow.getInstance().getPanel().setStrokeGradStyle(
        				element, elementNum,
        				DrawToolConst.RADIAL_GRAD);        		
        	}
        }
    }
	
	class StrokeGradCycleRadioListener implements ActionListener { 
        public void actionPerformed(ActionEvent e) {
        	if(e.getActionCommand().equals("Repeat")) {
        		element.setStrokeGradCycle(true);        		
        		MainWindow.getInstance().getPanel().setStrokeGradCycle(
        				element, elementNum, true);
        	} else {
        		element.setStrokeGradCycle(false);        		
        		MainWindow.getInstance().getPanel().setStrokeGradCycle(
        				element, elementNum, false);		
        	}
        }
    }

	class StrokeGradPanel extends JPanel {
		private static final long serialVersionUID = -3905598386617673145L;

		@SuppressWarnings("unchecked")
		public void paintComponent(Graphics g) { //  drawVector ׸
			super.paintComponent(g);
			Graphics2D g2d = (Graphics2D) g;
			posStrokeGradList = (ArrayList<GradientTool>) strokeGradList.clone();

			for (int pick = 1; pick < posStrokeGradList.size(); pick++) {
				int current = pick;
				paintRect = posStrokeGradList.get(pick);
				for (; (current > 0)
						&&posStrokeGradList.get(current - 1).getX() > paintRect.getX(); 
						current--) {
					posStrokeGradList.set(current, posStrokeGradList.get(current - 1));
				}
				posStrokeGradList.set(current, paintRect);
			}
			for(int i=0; i<posStrokeGradList.size()-1; i++) {
				if(posStrokeGradList.get(i).getX() >= posStrokeGradList.get(i+1).getX()) {					
					if(posStrokeGradList.size()>2) {
						posStrokeGradList.remove(i);
						i--;
					}
					else {
						GradientTool tempGRect = posStrokeGradList.get(i);
						if(tempGRect.getX()<95)
							posStrokeGradList.get(i+1).setX(tempGRect.getX()+1);
						else {
							posStrokeGradList.get(i).setX(posStrokeGradList.get(i+1).getX()-1);
						}
					}
				}
			}
			boolean isGradListMistaken = false;
			for(int i=0; i<posStrokeGradList.size()-1; i++) {
				if(posStrokeGradList.get(i).getX() >= posStrokeGradList.get(i+1).getX()) {
					isGradListMistaken = true;
					break;
				}
			}
			if (posStrokeGradList != null && posStrokeGradList.size()>1
					&& !isGradListMistaken) {
				element.setStrokeGradient(posStrokeGradList);
				MainWindow.getInstance().getPanel().setStrokeGradient(
						element, elementNum, 
						strokeScaleGrad, strokeAngleGrad);
				
				gradListSize = posStrokeGradList.size();
				gradColors = new Color[gradListSize];
				gradDist = new float[gradListSize];
				
				for(int i=0; i<posStrokeGradList.size(); i++) {
					tempRect = posStrokeGradList.get(i);	
					gradColors[i] = tempRect.getColor();
					gradDist[i] = tempRect.getDist();
				}				
				g2d.setPaint(new LinearGradientPaint(
						0, 
						0, 
						198, 
						0, 
						gradDist, gradColors, 
						MultipleGradientPaint.CycleMethod.NO_CYCLE));
				g2d.fillRect(0, 0, 198, 35);
				g2d.setColor(Color.BLACK);
				g2d.drawRect(0, 0, 199, 34);
				g2d.setColor(Color.WHITE);
				g2d.drawRect(1, 1, 197, 32);
				g.dispose();
			}			
		}
	}

	class StrokeGradClickPanel extends JPanel {
		private static final long serialVersionUID = -2154284699452227193L;

		public void paintComponent(Graphics g) { //  drawVector ׸
			super.paintComponent(g); // panel paintComponent
			for (int i = 0; i < strokeGradList.size(); i++) {
				tempRect = strokeGradList.get(i);
				tempRect.draw(g);
			}
			g.dispose();
		}
	}

	class SMouseListener extends MouseAdapter {
		public void mousePressed(MouseEvent e) {
			x1 = e.getX();
			y1 = e.getY();
			for (int index = 0; index < strokeGradList.size(); index++) {
				gradRect = strokeGradList.get(index);
				match = gradRect.match(x1, y1);
				if (match == true) {
					break;
				} else {
					gradRect.setSelected(false);
				}
			}
			if (match == true) {
				gradRect.setSelected(true);
				// Ŭ ι Color
				if (e.getButton() == 1 && e.getClickCount() == 2) {
					tempColor = gradButtonColor;
					gradButtonColor = JColorChooser.showDialog(
							MainWindow.getInstance().getPanel(),
							" ", gradButtonColor);
					if (gradButtonColor == null)
						gradButtonColor = tempColor;
					else {
						gradRect.setColor(gradButtonColor);
						//gradVector.removeElementAt(index);		
						//gradVector.add(rect);
						sGradPanel.repaint();
						strokeGradClickPanel.repaint();
					}
				}
				// Ŭ ι 
				else if (e.getButton() == 3 && e.getClickCount() == 2) {
					if(strokeGradList.size()>2) {
						strokeGradList.remove(gradRect);
						sGradPanel.repaint();
						strokeGradClickPanel.repaint();
					}
				} 
				// Ŭ ƴҽ ̵ 
				//else 
				//	firstMove = true;
			} 
			else { //match   ο point
				if (e.getButton() == 1) {
					if(x1 >= 5 && x1 <= 205) {
						gradRect = new GradientTool(x1 - 5, Color.LIGHT_GRAY);
					}
					else if(x1 < 5) {
						gradRect = new GradientTool(0, Color.LIGHT_GRAY);
					}
					else if(x1 > 205) {
						gradRect = new GradientTool(200, Color.LIGHT_GRAY);
					}
					strokeGradList.add(gradRect);
					sGradPanel.repaint();
					strokeGradClickPanel.repaint();
				}
			}			
		}

		public void mouseReleased(MouseEvent e) { // ư released
			sGradPanel.repaint();
			strokeGradClickPanel.repaint();
		}
	}

	class SMouseMotionListener extends MouseMotionAdapter {
		public void mouseDragged(MouseEvent e) {
			x2 = e.getX();
			if (match == true) {
				if (x2 >= 5 && x2 <= 205) { //    5 205					
					gradRect.translate(x1, x2);
				}
				else {
					// ̵
					if(x2 < x1) {
						if(x2 < 5) {
							gradRect.setX(0);
						}							
					}
					// ̵
					else {
						if(x2 > 205) {
							gradRect.setX(200);	
						}			
					}
				}
				x1 = x2;
			}
			strokeGradClickPanel.repaint();
		}
		
		public void mouseMoved(MouseEvent e) {
			for (int index = 0; index < strokeGradList.size(); index++) {
				gradRect = strokeGradList.get(index);
				match = gradRect.match(e.getX(), e.getY());
				if (match == true) {
					break;
				}
				gradRect.setSelected(false);
			}
			if (match == true) {
				gradRect.setSelected(true);
			}
			strokeGradClickPanel.repaint();
		}
	}

	@SuppressWarnings("serial")
	private void strokeKeyCheck() {
		strokeSizeT.getInputMap().put(
				KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0), "check");
		strokeSizeT.getActionMap().put("check", new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (!strokeSizeT.isEditValid()) { // The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					strokeSizeT.selectAll();
				} else
					try { // The text is valid,
						strokeSizeT.commitEdit(); // so use it.
					} catch (java.text.ParseException exc) {
					}
			}
		});
		strokeOpacityT.getInputMap().put(
				KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0), "check");
		strokeOpacityT.getActionMap().put("check", new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (!strokeOpacityT.isEditValid()) { // The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					strokeOpacityT.selectAll();
				} else
					try { // The text is valid,
						strokeOpacityT.commitEdit(); // so use it.
					} catch (java.text.ParseException exc) {
					}
			}
		});
	}

	@SuppressWarnings("serial")
	private void strokePatternKeyCheck() {
		strokePatternScaleT.getInputMap().put(
				KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0), "check");
		strokePatternScaleT.getActionMap().put("check", new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (!strokePatternScaleT.isEditValid()) { // The text is
															// invalid.
					Toolkit.getDefaultToolkit().beep();
					strokePatternScaleT.selectAll();
				} else
					try { // The text is valid,
						strokePatternScaleT.commitEdit(); // so use it.
					} catch (java.text.ParseException exc) {
					}
			}
		});
	}

	@SuppressWarnings("serial")
	private void strokeGradKeyCheck() {
		strokeGradScaleT.getInputMap().put(
				KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0), "check");
		strokeGradScaleT.getActionMap().put("check", new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (!strokeGradScaleT.isEditValid()) { // The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					strokeGradScaleT.selectAll();
				} else
					try { // The text is valid,
						strokeGradScaleT.commitEdit(); // so use it.
					} catch (java.text.ParseException exc) {
					}
			}
		});
		strokeGradAngleT.getInputMap().put(
				KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0), "check");
		strokeGradAngleT.getActionMap().put("check", new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (!strokeGradAngleT.isEditValid()) { // The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					strokeGradAngleT.selectAll();
				} else
					try { // The text is valid,
						strokeGradAngleT.commitEdit(); // so use it.
					} catch (java.text.ParseException exc) {
					}
			}
		});
	}
}
