package com.sharppaint.graphicprocess;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import com.sharppaint.MainWindow;
import com.sharppaint.drawtools.Element;

public class VectorTransformPanel extends VectorBasicData {
	/**
	 * 
	 */
	private static final long serialVersionUID = 6090202864280952323L;

	// edit
	private JPanel resizeP, rotateP, transfromPanel;

	private JLabel angleL, widthL, heightL;

	private JSlider widthS, heightS, angleS;

	private JFormattedTextField widthT, heightT, angleT;

	private int percentX, percentY, angle;

	private static VectorTransformPanel vectorTransformPanel = null;

	public static VectorTransformPanel getInstance(Element elem, int elemNum) {
		element = elem;
		elementNum = elemNum;
		if (vectorTransformPanel == null)
			vectorTransformPanel = new VectorTransformPanel();
		return vectorTransformPanel;
	}

	public static VectorTransformPanel getInstance() {
		return vectorTransformPanel;
	}

	private VectorTransformPanel() {
		transfromPanel = new JPanel();
		resizeP = new JPanel();
		rotateP = new JPanel();
		transfromPanel
				.setLayout(new BoxLayout(transfromPanel, BoxLayout.Y_AXIS));
		resizeP.setBorder(BorderFactory.createTitledBorder(loweredetched,
				" Resize "));
		resizeP.setPreferredSize(new Dimension(PANEL_WIDTH, 92));
		rotateP.setPreferredSize(new Dimension(PANEL_WIDTH, 68));
		rotateP.setBorder(BorderFactory.createTitledBorder(loweredetched,
				" Rotate "));

		widthS = new JSlider(RESIZE_MIN, RESIZE_MAX, RESIZE_INIT);
		heightS = new JSlider(RESIZE_MIN, RESIZE_MAX, RESIZE_INIT);
		angleS = new JSlider(ZERO, ROTATE_MAX, ZERO);
		heightS.addChangeListener(new SliderListener());
		widthS.addChangeListener(new SliderListener());
		angleS.addChangeListener(new SliderListener());
		widthS.setPreferredSize(new Dimension(120, 18));
		heightS.setPreferredSize(new Dimension(120, 18));
		angleS.setPreferredSize(new Dimension(120, 18));
		formatter.setMinimum(new Integer(RESIZE_MIN));
		formatter.setMaximum(new Integer(RESIZE_MAX));
		widthT = new JFormattedTextField(formatter);
		widthT.setValue(new Integer(RESIZE_INIT));
		widthT.setColumns(3); // get some space
		widthT.addPropertyChangeListener(new TextListener());
		heightT = new JFormattedTextField(formatter);
		heightT.setValue(new Integer(RESIZE_INIT));
		heightT.setColumns(3); // get some space
		heightT.addPropertyChangeListener(new TextListener());
		formatterRotate.setMinimum(new Integer(ZERO));
		formatterRotate.setMaximum(new Integer(ROTATE_MAX));
		angleT = new JFormattedTextField(formatterRotate);
		angleT.setValue(new Integer(ZERO));
		angleT.setColumns(3); // get some space
		angleT.addPropertyChangeListener(new TextListener());
		// percentL = new JLabel("%");
		widthL = new JLabel("     Width:", SwingConstants.RIGHT);
		heightL = new JLabel("     Height:", SwingConstants.RIGHT);
		angleL = new JLabel("     Angle:", SwingConstants.RIGHT);
		widthL.setFont(font);
		heightL.setFont(font);
		angleL.setFont(font);

		// edit   ̵ ϰ  
		if (element.getRotateMode() == true || element.getScaleMode() == true) {
			percentX = (int) (element.getScaleX() * 100);
			percentY = (int) (element.getScaleY() * 100);
			angle = element.getRotateAngle();
			widthS.setValue(percentX);
			heightS.setValue(percentY);
			angleS.setValue(angle);
		} else { // editѹ ȵǾ   
			widthS.setValue(RESIZE_INIT);
			heightS.setValue(RESIZE_INIT);
			angleS.setValue(ZERO);
			percentX = RESIZE_INIT;
			percentY = RESIZE_INIT;
			angle = ZERO;
		}
		editKeyCheck();

		resizeP.add(widthL);
		resizeP.add(widthS);
		resizeP.add(widthT);
		JLabel temp1 = new JLabel("%     ");
		JLabel temp2 = new JLabel("%     ");
		JLabel temp3 = new JLabel("     ");
		temp1.setFont(font);
		temp2.setFont(font);
		temp3.setFont(font);
		resizeP.add(temp1);
		resizeP.add(heightL);
		resizeP.add(heightS);
		resizeP.add(heightT);
		resizeP.add(temp2);
		rotateP.add(angleL);
		rotateP.add(angleS);
		rotateP.add(angleT);
		rotateP.add(temp3);
		transfromPanel.add(resizeP);
		transfromPanel.add(Box.createRigidArea(new Dimension(0, 25)));
		transfromPanel.add(rotateP);
		transfromPanel.add(Box.createRigidArea(new Dimension(0, 140)));
		transfromPanel.setBorder(BorderFactory.createTitledBorder(
				loweredetched, " Transform "));
	}

	public JPanel getPanel() {
		return transfromPanel;
	}

	public void init() {
			percentX = (int) (element.getScaleX() * 100);
			percentY = (int) (element.getScaleY() * 100);
			angle = element.getRotateAngle();
			widthS.setValue(percentX);
			heightS.setValue(percentY);
			angleS.setValue(angle);
			
		MainWindow.getInstance().getPanel().setResizeX( element,
				 elementNum, percentX);
		MainWindow.getInstance().getPanel().setResizeY( element,
				 elementNum, percentY);
		MainWindow.getInstance().getPanel().setRotate( element,
				 elementNum, angle);
		
		widthL.setEnabled(true);
		heightL.setEnabled(true);
		angleL.setEnabled(true);
		widthS.setEnabled(true);
		heightS.setEnabled(true);
		angleS.setEnabled(true);
		widthT.setEnabled(true);
		heightT.setEnabled(true);
		angleT.setEnabled(true);
	}

	public void setDisable() {
		MainWindow.getInstance().getPanel()
				.setResizeX(element, elementNum, 100);
		MainWindow.getInstance().getPanel()
				.setResizeY(element, elementNum, 100);
		MainWindow.getInstance().getPanel().setRotate(element, elementNum, 0);
		widthL.setEnabled(false);
		heightL.setEnabled(false);
		angleL.setEnabled(false);
		widthS.setEnabled(false);
		heightS.setEnabled(false);
		angleS.setEnabled(false);
		widthT.setEnabled(false);
		heightT.setEnabled(false);
		angleT.setEnabled(false);
	}

	class TextListener implements PropertyChangeListener { // formattedTextField
		// event
		public void propertyChange(PropertyChangeEvent e) {
			if ("value".equals(e.getPropertyName())) {
				if (widthT.equals(e.getSource())) {
					Number value = (Number) e.getNewValue();
					if (widthT != null && value != null) {
						widthS.setValue(value.intValue());
					}
				} else if (heightT.equals(e.getSource())) {
					Number value = (Number) e.getNewValue();
					if (heightT != null && value != null) {
						heightS.setValue(value.intValue());
					}
				} else if (angleT.equals(e.getSource())) {
					Number value = (Number) e.getNewValue();
					if (angleT != null && value != null) {
						angleS.setValue(value.intValue());
					}
				}
			}
		}
	}

	class SliderListener implements ChangeListener { // slider Event
		public void stateChanged(ChangeEvent e) {
			if (e.getSource() == widthS) {
				JSlider source = (JSlider) e.getSource();
				int percent = (int) source.getValue();
				if (!source.getValueIsAdjusting()) { // done adjusting
					widthT.setValue(new Integer(percent));
				} else { // value is adjusting; just set the text
					widthT.setText(String.valueOf(percent));
				}
				if((percentX == 100 && percent != 100)
						|| (percentX != 100 && percent == 100))
						element.setFirstPatternMode();
				percentX = percent;
				MainWindow.getInstance().getPanel().setResizeX(element,
						elementNum, percentX);
			} else if (e.getSource() == heightS) {
				JSlider source = (JSlider) e.getSource();
				int percent = (int) source.getValue();
				if (!source.getValueIsAdjusting()) { // done adjusting
					heightT.setValue(new Integer(percent));
				} else { // value is adjusting; just set the text
					heightT.setText(String.valueOf(percent));
				}
				if((percentY == 100 && percent != 100)
						|| (percentY != 100 && percent == 100))
						element.setFirstPatternMode();
				percentY = percent;
				MainWindow.getInstance().getPanel().setResizeY(element,
						elementNum, percentY);
			} else if (e.getSource() == angleS) {
				JSlider source = (JSlider) e.getSource();
				int _angle = (int) source.getValue();
				if (!source.getValueIsAdjusting()) { // done adjusting
					angleT.setValue(new Integer(_angle));
				} else { // value is adjusting; just set the text
					angleT.setText(String.valueOf(_angle));
				}
				if((angle == 0 && _angle != 0)
						|| (angle != 0 && _angle == 0))
						element.setFirstPatternMode();
				angle = _angle;
				MainWindow.getInstance().getPanel().setRotate(element,
						elementNum, angle);
			}
		}
	}

	private void editKeyCheck() {
		widthT.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0),
				"check");
		widthT.getActionMap().put("check", new AbstractAction() {
			private static final long serialVersionUID = -7385437385108685532L;

			public void actionPerformed(ActionEvent e) {
				if (!widthT.isEditValid()) { // The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					widthT.selectAll();
				} else
					try { // The text is valid,
						widthT.commitEdit(); // so use it.
						// heightT.requestFocusInWindow();
					} catch (java.text.ParseException exc) {
					}
			}
		});
		heightT.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0),
				"check");
		heightT.getActionMap().put("check", new AbstractAction() {
			private static final long serialVersionUID = 2256921507544573404L;

			public void actionPerformed(ActionEvent e) {
				if (!heightT.isEditValid()) { // The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					heightT.selectAll();
				} else
					try { // The text is valid,
						heightT.commitEdit(); // so use it.
					} catch (java.text.ParseException exc) {
					}
			}
		});
		angleT.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0),
				"check");
		angleT.getActionMap().put("check", new AbstractAction() {
			private static final long serialVersionUID = -7793346364912142982L;

			public void actionPerformed(ActionEvent e) {
				if (!angleT.isEditValid()) { // The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					angleT.selectAll();
				} else
					try { // The text is valid,
						angleT.commitEdit(); // so use it.
					} catch (java.text.ParseException exc) {
					}
			}
		});
	}
}
