package com.sharppaint.layermanager;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.VolatileImage;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.*;

import com.sharppaint.*;
import com.sharppaint.drawtools.DrawToolConst;
import com.sharppaint.drawtools.Element;
import com.sharppaint.drawtools.GradientTool;
import com.sharppaint.drawtools.Layer;
import com.sharppaint.drawtools.TextTool;
//import com.sharppaint.graphicprocess.VectorGradientPanel;
import com.sharppaint.graphicprocess.VectorProcessDialog;
import com.sharppaint.toolbar.UpperToolBox;
import com.sharppaint.toolbar.WestToolBox;

public class LayerManagementDialog extends JDialog {
	/**
	 * 
	 */
	private static final long serialVersionUID = -365933214081355690L;

	private Vector<Element> arrVector;

	//center Panel
	private JPanel centerPanel;
	private JPanel viewPanel, layerPanel;
	
	//layerComponents
	private JButton layerButton;
	private JButton selLayerButton;
	private JButton viewChkButton;
	private JPanel viewChkPanel;	
	private JButton foldButton;	
	private JPanel emptyPanel;
	private ImageIcon foldingIcon, unFoldingIcon, viewIcon;
	public JPanel outDrawPanel;
	public SLayerDrawPanel sLayerDrawPanel;
	public SDrawPanel sDrawPanel;
	public int sDrawPanelWidth, sDrawPanelHeight;
	private JLabel layerNumLabel;

	//south Panel
	private JPanel southPanel;
	private JButton upBtn, downBtn;
	private JButton newLayer, newChildLayer;
	private JButton vectorProcessBtn, deleteBtn;	
	private float sDrawPanelScaleValue;
	
	private Element element, destElement;
	private VectorProcessDialog funcDialog;
	private JScrollPane scroller;
	

	//func Panel
	public int layoutCount, destLayoutCount;
	public int funcNum, destNum;
	private String funcName, destName, selectText;	
	private boolean isCopyStyle, antiMode;
	
	private JPanel funcPanel, destPanel;	
	private JLabel defaultLabel, editLabel, colorLabel;	
	private JLabel gradLabel, patternLabel;
	private JLabel strokeLabel, selectLabel, spaceLabel, spaceLabel2;
	
	private ArrayList<GradientTool> gradList;
	private ImageIcon funcIcon, eraserIcon, upIcon, downIcon, newLayerIcon, newChildLayerIcon;
	private ArrayList<GradientTool> strokeGradList;
	private ArrayList<GradientTool> tempGradList, tempStrokeGradList;

	private Insets inset;
	boolean simpleDraw = true;
	private Font font;

	private boolean layerSelection;
	//layer Number
	protected int layerNum;
	//element Number in Layer
	protected int elementNum;
	//parent Layer Number
	protected int parentLayerNum;
	//parent Layer Depth
	protected int parentLayerDepth;
	//int selLayerNum;

	private Element currentElem;
	private Element destElem;
	private Color componentColor;
	private int btnCompIndex;
	private int currentLayerNum;
	private int elementIndex;
	
	private VolatileImage bimg;
	private MouseListener mouseViewListener;
	private MouseListener mouseViewButtonListener;
	boolean viewPanelClickFlag = false;
	boolean isViewPanel = false;

	public final static int DIALOG_WIDTH = 255;
	final static int EMPTYPANEL_WIDTH = 30; //24
	final static int FOLD_BUTTON_WIDTH = 18;
	final static int FUNC_SCROLLER_WIDTH = 82;
	final static int FUNC_INNERPANEL_HEIGHT = 13;	
	final static int INSET = 1;
	final static int ICONBTNSIZE = 22;
	final static int SMALL_BTN_SIZE = 20;
	final static int SCROLLER_HEIGHT = 340;
	final static int LAYER_BUTTON_WIDTH = 130;
	final static int LAYER_BUTTON_HEIGHT = 32;
	final static int LAYER_INBTN_HEIGHT = 28;
	final static int SDRAWPANEL_WIDTH = 34;
	final static int VIEWCHK_BUTTON_WIDTH = 16;
	final static String LAYER_STRING = "Layer ";

	private static LayerManagementDialog layerManagementDialog = null;

	public static LayerManagementDialog getInstance(JFrame f) {
		if (layerManagementDialog == null)
			layerManagementDialog = new LayerManagementDialog(f);
		return layerManagementDialog;
	}
	
	public static LayerManagementDialog getInstance() {
		if (layerManagementDialog == null)
			layerManagementDialog = new LayerManagementDialog(
					MainWindow.getInstance());
		return layerManagementDialog;
	}

	private LayerManagementDialog(JFrame f) {
		super(f, "Layer Dialog", false);
		arrVector = new Vector<Element>();
		this.setLayout(new BorderLayout());
		this.setMinimumSize(new Dimension(220, 250));
		//sDrawPanelWidth = 32;
		//sDrawPanelHeight = 28;
		//layerColor = new Color(238, 238, 238);
		componentColor = new Color(238, 238, 238);
		makeCenterGUI();
		makeSouthGUI();
		mouseViewListener = new ViewListener();
		mouseViewButtonListener = new ViewButtonListener();
		//mouseMotionListener = new ViewMotionListener();
		font = new Font("arial", Font.BOLD, 11);
		inset = new java.awt.Insets(INSET, INSET, INSET, INSET);
		antiMode = true;
		this.pack();
		setVisible(true);
	}

	private void makeCenterGUI() {
		centerPanel = new JPanel();
		centerPanel.setDoubleBuffered(true);
		//centerPanel.setLayout(new BoxLayout(centerPanel, BoxLayout.LINE_AXIS));
		centerPanel.setLayout(new BorderLayout());
		viewPanel = new JPanel();
		viewPanel.setLayout(new BoxLayout(viewPanel, BoxLayout.PAGE_AXIS));
		//viewPanel.setBorder(BorderFactory.createLoweredBevelBorder());
		//viewPanel.setPreferredSize(new Dimension(20, SCROLLER_HEIGHT));
		layerPanel = new JPanel();
		layerPanel.setLayout(new BoxLayout(layerPanel, BoxLayout.PAGE_AXIS));
		//layerPanel.setPreferredSize(new Dimension(DIALOG_WIDTH-20, SCROLLER_HEIGHT));
		centerPanel.add(viewPanel, BorderLayout.WEST);
		centerPanel.add(layerPanel, BorderLayout.CENTER);
		JScrollPane scroller = new JScrollPane(centerPanel,
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scroller.setPreferredSize(new Dimension(DIALOG_WIDTH, SCROLLER_HEIGHT));
		//scroller.addComponentListener()
		//scroller.isWheelScrollingEnabled()			
		foldingIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "folding.gif"));
		unFoldingIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "unfolding.gif"));
		viewIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "eye.gif"));
		this.add(scroller, BorderLayout.CENTER);
		//this.add(scroller, BorderLayout.PAGE_END);
	}
	
	private void makeSouthGUI() {
		southPanel = new JPanel();
		southPanel.setPreferredSize(new Dimension(DIALOG_WIDTH, 25));	
		upBtn = new JButton();
		downBtn = new JButton();	
		spaceLabel = new JLabel("  ");
		spaceLabel2 = new JLabel("  ");
		vectorProcessBtn = new JButton();
		deleteBtn = new JButton();
		newLayer = new JButton();
		newChildLayer = new JButton();
		vectorProcessBtn.setPreferredSize(new Dimension(ICONBTNSIZE, ICONBTNSIZE));
		deleteBtn.setPreferredSize(new Dimension(ICONBTNSIZE, ICONBTNSIZE));
		upBtn.setPreferredSize(new Dimension(ICONBTNSIZE, ICONBTNSIZE));
		downBtn.setPreferredSize(new Dimension(ICONBTNSIZE, ICONBTNSIZE));
		newLayer.setPreferredSize(new Dimension(ICONBTNSIZE, ICONBTNSIZE));
		newChildLayer.setPreferredSize(new Dimension(ICONBTNSIZE, ICONBTNSIZE));
		vectorProcessBtn.addActionListener(new FuncListener());
		deleteBtn.addActionListener(new EraserListener());
		upBtn.addActionListener(new UpListener());
		downBtn.addActionListener(new DownListener());
		newLayer.addActionListener(new NewLayerListener());
		newChildLayer.addActionListener(new NewChildLayerListener());
		vectorProcessBtn.setMargin(inset);
		deleteBtn.setMargin(inset);
		upBtn.setMargin(inset);
		downBtn.setMargin(inset);
		newLayer.setMargin(inset);
		newChildLayer.setMargin(inset);
		vectorProcessBtn.setToolTipText("");
		deleteBtn.setToolTipText("");
		upBtn.setToolTipText("up");
		downBtn.setToolTipText("down");
		newLayer.setToolTipText("New Layer");
		newChildLayer.setToolTipText("New Child Layer");		
		funcIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "function.gif"));
		eraserIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "delete.gif"));
		upIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "up.gif"));
		downIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "down.gif"));
		newLayerIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "layer.gif"));
		newChildLayerIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "underlayer.gif"));
		vectorProcessBtn.setIcon(funcIcon);
		deleteBtn.setIcon(eraserIcon);
		upBtn.setIcon(upIcon);
		downBtn.setIcon(downIcon);
		newLayer.setIcon(newLayerIcon);
		newChildLayer.setIcon(newChildLayerIcon);
		//southPanel.setLayout(new GridLayout(1, 8));
		//southPanel.add(new JLabel("   "));
		southPanel.setLayout(new FlowLayout(
				FlowLayout.RIGHT, 4,1));
		southPanel.add(upBtn);
		southPanel.add(downBtn);
		southPanel.add(spaceLabel);
		southPanel.add(newLayer);
		southPanel.add(newChildLayer);
		southPanel.add(spaceLabel2);
		southPanel.add(vectorProcessBtn);
		southPanel.add(deleteBtn);
		this.add(southPanel, BorderLayout.SOUTH);
	}
	
	public void setAntiMode(boolean _anti) {
		antiMode = _anti;
		repaint();
	}

	public void setSimpleDrawMode(boolean _drawMode) {
		simpleDraw = _drawMode;
		this.validate();
		this.repaint();
	}

	public void initVectorDialog() {
		arrVector = null;
		viewPanel.removeAll();
		layerPanel.removeAll();
		this.invalidate();
		this.validate();
		this.repaint();
	}
	
	public void addLayer(int btnIndex, boolean folding) {
		String btnStringIndex = Integer.toString(btnIndex);
		if (element.getHide()) {
			viewChkButton = new JButton("");
		} 
		else {
			viewChkButton = new JButton(viewIcon);
		}    
		viewChkButton.setBackground(componentColor);
		//viewChkButton.setOpaque(false);
		viewChkButton.setBorderPainted(false);
		viewChkButton.setPreferredSize(
				new Dimension(VIEWCHK_BUTTON_WIDTH, VIEWCHK_BUTTON_WIDTH));
		viewChkButton.setName(btnStringIndex);

		viewChkPanel = new JPanel();
		viewChkPanel.setName(btnStringIndex);
		viewChkPanel.setPreferredSize(
				new Dimension(20, LAYER_BUTTON_HEIGHT));
		viewChkPanel.setMaximumSize(
				new Dimension(20, LAYER_BUTTON_HEIGHT));
		viewChkPanel.setMinimumSize(
				new Dimension(20, LAYER_BUTTON_HEIGHT));
		//viewChkPanel.setDoubleBuffered(true);
		//viewChkPanel.
		//Graphics g = viewChkPanel.getGraphics();
		//g.drawImage(0, 0, 15, 15, viewIcon);
		viewChkPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		viewChkPanel.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		viewChkPanel.add(viewChkButton);
		viewChkPanel.addMouseListener(mouseViewListener);
		viewChkButton.addMouseListener(mouseViewButtonListener);
		//viewChkPanel.addMouseMotionListener(mouseMotionListener);
		
		emptyPanel = new JPanel();
		
		foldButton = new JButton();
		foldButton.setName(btnStringIndex);
		//foldButton.setIcon(unFoldingIcon);
		foldButton.setBackground(componentColor);
		foldButton.setOpaque(false);
		foldButton.setBorderPainted(false);
		foldButton.setRolloverEnabled(false);
		foldButton.addActionListener(new FoldButtonListener());
		foldButton.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		//foldButton.addActionListener(new FoldButtonListener());
		
		//small drawPanel
		outDrawPanel = new JPanel();
		outDrawPanel.setLayout(null);
		outDrawPanel.setOpaque(false);
		sLayerDrawPanel = new SLayerDrawPanel(element);
		//sDrawPanel.setPreferredSize(new Dimension(sDrawPanelWidth, sDrawPanelHeight));
		//sDrawPanel.setBackground(Color.gray);
		sLayerDrawPanel.setBounds(
				Math.round((SDRAWPANEL_WIDTH-sDrawPanelWidth)/2.0f), 
				Math.round((LAYER_INBTN_HEIGHT-sDrawPanelHeight)/2.0f),
				sDrawPanelWidth, sDrawPanelHeight);
		outDrawPanel.add(sLayerDrawPanel);
						
		layerNumLabel = new JLabel(LAYER_STRING + element.getLayerNum());
		
		layerButton = new JButton();
		//layerButton.setMargin(inset);
		layerButton.setBorder(BorderFactory.createRaisedBevelBorder());
		layerButton.setName(btnStringIndex);
		layerButton.setBackground(componentColor);
		layerButton.addActionListener(new LayerListener());
		layerButton.setLayout(null);
		
		layerButton.setPreferredSize(new Dimension(
				LAYER_BUTTON_WIDTH, LAYER_BUTTON_HEIGHT));
		layerButton.setMaximumSize(new Dimension(
				LAYER_BUTTON_WIDTH*7, LAYER_BUTTON_HEIGHT));
		layerButton.setMinimumSize(new Dimension(
				LAYER_BUTTON_WIDTH, LAYER_BUTTON_HEIGHT));
		//inButton setBound
		emptyPanel.setBounds(0, 0, 
				EMPTYPANEL_WIDTH*(parentLayerDepth)+1, LAYER_BUTTON_HEIGHT-2);
		foldButton.setBounds(EMPTYPANEL_WIDTH*(parentLayerDepth)+1, 0, 
				FOLD_BUTTON_WIDTH-1, LAYER_BUTTON_HEIGHT-2);
		outDrawPanel.setBounds(
				EMPTYPANEL_WIDTH*(parentLayerDepth)+ 1 + FOLD_BUTTON_WIDTH, 2,
				SDRAWPANEL_WIDTH, LAYER_INBTN_HEIGHT);
		layerNumLabel.setBounds(EMPTYPANEL_WIDTH*(parentLayerDepth) + 1 + 
				FOLD_BUTTON_WIDTH + SDRAWPANEL_WIDTH, 4, 
				FUNC_SCROLLER_WIDTH, 
				LAYER_INBTN_HEIGHT-8);
				
		layerButton.add(emptyPanel);
		layerButton.add(foldButton);
		layerButton.add(outDrawPanel);
		layerButton.add(layerNumLabel);
		
		if(folding) {
			viewChkPanel.setVisible(false);
			layerButton.setVisible(false);
		}

		//System.out.println("L:"+btnIndex);
		viewPanel.add(viewChkPanel, btnIndex);
		layerPanel.add(layerButton, btnIndex);
		// layerButton.setSelected(true);
		//layerPanel.getComponentCount()
	}
		
	public void addElement(int btnIndex, boolean folding) {
		String btnStringIndex = Integer.toString(btnIndex);
		if (element.getHide()) {
			viewChkButton = new JButton("");
		} else {
			viewChkButton = new JButton(viewIcon);
		}
		viewChkButton.setBackground(componentColor);
		viewChkButton.setBorderPainted(false);
		viewChkButton.setPreferredSize(
				new Dimension(VIEWCHK_BUTTON_WIDTH, VIEWCHK_BUTTON_WIDTH));
		viewChkButton.setName(btnStringIndex);
		viewChkPanel = new JPanel();
		viewChkPanel.setName(btnStringIndex);
		viewChkPanel.setPreferredSize(
				new Dimension(20, LAYER_BUTTON_HEIGHT));
		viewChkPanel.setMaximumSize(
				new Dimension(20, LAYER_BUTTON_HEIGHT));
		viewChkPanel.setMinimumSize(
				new Dimension(20, LAYER_BUTTON_HEIGHT));
		viewChkPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		viewChkPanel.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		viewChkPanel.add(viewChkButton);
		viewChkPanel.addMouseListener(mouseViewListener);
		viewChkButton.addMouseListener(mouseViewButtonListener);
		//viewChkPanel.addMouseMotionListener(mouseMotionListener);
				
		emptyPanel = new JPanel();
		//emptyPanel.setOpaque(false);
		//small drawPanel
		outDrawPanel = new JPanel();
		outDrawPanel.setLayout(null);
		outDrawPanel.setOpaque(false);
		sDrawPanel = new SDrawPanel(element);
		//sDrawPanel.setPreferredSize(new Dimension(sDrawPanelWidth, sDrawPanelHeight));
		//sDrawPanel.setBackground(Color.gray);
		sDrawPanel.setBounds(
				Math.round((SDRAWPANEL_WIDTH-sDrawPanelWidth)/2.0f), 
				Math.round((LAYER_INBTN_HEIGHT-sDrawPanelHeight)/2.0f),
				sDrawPanelWidth, sDrawPanelHeight);
		outDrawPanel.add(sDrawPanel);
				
		//sDrawPanel.setLocation(
		//		Math.round((SDRAWPANEL_WIDTH-sDrawPanelWidth)/2.0f), 
		//		Math.round((LAYER_INBTN_HEIGHT-sDrawPanelHeight)/2.0f));
			
		layerButton = new JButton();
		//layerButton.setMargin(inset);
		layerButton.setBorder(BorderFactory.createRaisedBevelBorder());
		layerButton.setName(btnStringIndex);
		layerButton.setBackground(Color.WHITE);
		layerButton.addActionListener(new LayerListener());
		layerButton.setLayout(null);		
		
		funcPanel = new JPanel();
		//funcPanel.setPreferredSize(new Dimension(50, 26));
		funcPanel.setLayout(new GridLayout(1, 1));
		funcPanel.setBackground(Color.WHITE);
		funcPanel.setName(btnStringIndex);
		funcPanel.addMouseListener(new MouseHandler());
		scroller = new JScrollPane(funcPanel,
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scroller.getVerticalScrollBar().addAdjustmentListener(
				new FuncScrollAdjust());
	    
		layoutCount = 0;
		if (element.getTransformMode())
			layoutCount++;
		if (element.getColorMode())
			layoutCount++;
		if (element.getGradientMode())
			layoutCount++;
		if (element.getPatternMode())
			layoutCount++;
		if (element.getStrokeMode())
			layoutCount++;
		if (layoutCount != 0) {
			funcPanel.removeAll();
			funcPanel.setPreferredSize(new Dimension(
					60, FUNC_INNERPANEL_HEIGHT * layoutCount));
			funcPanel.setLayout(new GridLayout(layoutCount, 1));
		} else {
			funcPanel.removeAll();
			funcPanel.setLayout(new GridLayout(1, 1));
			defaultLabel = new JLabel("Nothing", SwingConstants.CENTER);
			defaultLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			defaultLabel.setFont(font);
			funcPanel.add(defaultLabel);
		}
		if (element.getTransformMode()) {
			editLabel = new JLabel("Transform", SwingConstants.CENTER);
			editLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			editLabel.setFont(font);
			funcPanel.add(editLabel);
		}
		if (element.getColorMode() == true) {
			colorLabel = new JLabel("Color", SwingConstants.CENTER);
			colorLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			colorLabel.setFont(font);
			funcPanel.add(colorLabel);
		}
		if (element.getGradientMode() == true) {
			gradLabel = new JLabel("Gradient", SwingConstants.CENTER);
			gradLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			gradLabel.setFont(font);
			funcPanel.add(gradLabel);
		}
		if (element.getPatternMode()) {
			patternLabel = new JLabel("Pattern", SwingConstants.CENTER);
			patternLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			patternLabel.setFont(font);
			funcPanel.add(patternLabel);
		}
		if (element.getStrokeMode()) {
			strokeLabel = new JLabel("Stroke", SwingConstants.CENTER);
			strokeLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			strokeLabel.setFont(font);
			funcPanel.add(strokeLabel);
		}
		scroller.validate();
		layerButton.setPreferredSize(new Dimension(
				LAYER_BUTTON_WIDTH, LAYER_BUTTON_HEIGHT));
		layerButton.setMaximumSize(new Dimension(
				LAYER_BUTTON_WIDTH*7, LAYER_BUTTON_HEIGHT));
		layerButton.setMinimumSize(new Dimension(
				LAYER_BUTTON_WIDTH, LAYER_BUTTON_HEIGHT));
		
		//inButton setBound
		emptyPanel.setBounds(0, 0, 
				EMPTYPANEL_WIDTH*(parentLayerDepth+1)+1, LAYER_BUTTON_HEIGHT-2);
		outDrawPanel.setBounds(EMPTYPANEL_WIDTH*(parentLayerDepth+1)+2, 2, 
				SDRAWPANEL_WIDTH, LAYER_INBTN_HEIGHT);
		scroller.setBounds(
				EMPTYPANEL_WIDTH*(parentLayerDepth+1)+SDRAWPANEL_WIDTH+2, 2, 
				FUNC_SCROLLER_WIDTH, 
				LAYER_INBTN_HEIGHT);
				
		layerButton.add(emptyPanel);
		layerButton.add(outDrawPanel);
		layerButton.add(scroller);

		if(folding) {
			viewChkPanel.setVisible(false);
			layerButton.setVisible(false);
		}
		viewPanel.add(viewChkPanel, btnIndex);
		layerPanel.add(layerButton, btnIndex);
		// layerButton.setSelected(true);
		//layerPanel.getComponentCount()
	}

	public void setStyle(int elementIndex) {
		Element tempElement = arrVector.get(elementIndex);
		int tempCompIndex = arrVector.size()-elementIndex-1;
		layerButton = (JButton) layerPanel.getComponent(tempCompIndex);
		scroller = (JScrollPane) layerButton.getComponent(2);
		JViewport tempViewPort = (JViewport)scroller.getComponent(0);
		funcPanel = (JPanel) tempViewPort.getComponent(0);
		layoutCount = 0;
		if (tempElement.getTransformMode())
			layoutCount++;
		if (tempElement.getColorMode())
			layoutCount++;
		if (tempElement.getGradientMode())
			layoutCount++;
		if (tempElement.getPatternMode())
			layoutCount++;
		if (tempElement.getStrokeMode())
			layoutCount++;
		if (layoutCount != 0) {
			funcPanel.removeAll();
			funcPanel.setPreferredSize(new Dimension(
					60, FUNC_INNERPANEL_HEIGHT * layoutCount));
			funcPanel.setLayout(new GridLayout(layoutCount, 1));
		} else {
			funcPanel.removeAll();
			funcPanel.setLayout(new GridLayout(1, 1));
			defaultLabel = new JLabel("Nothing", SwingConstants.CENTER);
			defaultLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			defaultLabel.setFont(font);
			funcPanel.add(defaultLabel);
		}
		if (tempElement.getTransformMode()) {
			editLabel = new JLabel("Transform", SwingConstants.CENTER);
			editLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			editLabel.setFont(font);
			funcPanel.add(editLabel);
		}
		if (tempElement.getColorMode() == true) {
			colorLabel = new JLabel("Color", SwingConstants.CENTER);
			colorLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			colorLabel.setFont(font);
			funcPanel.add(colorLabel);
		}
		if (tempElement.getGradientMode() == true) {
			gradLabel = new JLabel("Gradient", SwingConstants.CENTER);
			gradLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			gradLabel.setFont(font);
			funcPanel.add(gradLabel);
		}
		if (tempElement.getPatternMode()) {
			patternLabel = new JLabel("Pattern", SwingConstants.CENTER);
			patternLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			patternLabel.setFont(font);
			funcPanel.add(patternLabel);
		}
		if (tempElement.getStrokeMode()) {
			strokeLabel = new JLabel("Stroke", SwingConstants.CENTER);
			strokeLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			strokeLabel.setFont(font);
			funcPanel.add(strokeLabel);
		}
		scroller.validate();
	}
	public void initFirstLayer(Element _element) {
		btnCompIndex = 0;
		layerNum = 1;
		parentLayerNum = 0;
		parentLayerDepth = 0;
		currentLayerNum = layerNum;
		element = _element;
		addLayer(0, false);
		layerButton.setBackground(Color.CYAN);
		selLayerButton = layerButton;
		layerSelection = true;
	}

	class FoldButtonListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			foldButton = (JButton) e.getSource();
			int foldIndex = Integer.parseInt(foldButton.getName());
			int arrIndex = arrVector.size() - 1 - foldIndex;

			//unsetLayerSelect(foldIndex);
			unsetLayerSelect();
			//  ɴ
			if(arrVector.get(arrIndex).isLayerFolding()) {
				foldButton.setIcon(unFoldingIcon);
				foldingRealignment(arrIndex, foldIndex);
				arrVector.get(arrIndex).setLayerFolding(false);
			}
			//´
			else {
				foldButton.setIcon(foldingIcon);
				foldingRealignment(arrIndex, foldIndex);
				arrVector.get(arrIndex).setLayerFolding(true);
			}
			setLayerSelect(foldIndex);
		}		
	}
	
	public void foldingRealignment(int _elementIndex, int _foldIndex) {
		if (selectLabel != null) {
			selectLabel.setForeground(Color.BLACK);
			isCopyStyle = false;
		}
		int elementIndex = _elementIndex;
		int foldIndex = _foldIndex;
		//int layerNum = arrVector.get(arrVectorSize).getLayerNum();
		Element tempElement = arrVector.get(elementIndex);
		int elementCount=tempElement.getElementNum();
		//for (int idx = 0; idx < elementCount; idx++) {
			//´
			if(!tempElement.isLayerFolding()) {
				elementCount = tempElement.getElementNum();
				arrVector.get(elementIndex).setLayerFolding(true);
				for(int i=foldIndex; i<foldIndex+elementCount; i++) {
					viewPanel.getComponent(i+1).setVisible(false);
					layerPanel.getComponent(i+1).setVisible(false);
				}
			}
			//ɴ
			else {
				int arrSize = arrVector.size()-1;
				elementCount = tempElement.getElementNum();
				arrVector.get(elementIndex).setLayerFolding(false);
				for(int i=foldIndex; i<foldIndex+elementCount; i++) {
					//System.out.println(arrVector.get(arrSize-i-1).getShape());
					viewPanel.getComponent(i+1).setVisible(true);
					layerPanel.getComponent(i+1).setVisible(true);
					if(arrVector.get(arrSize-i-1).isLayerFolding()) {
						//System.out.println(arrVector.get(arrSize-i-1).getShape() + " comIdx:"  + i);
						//viewPanel.getComponent(i+1).setVisible(true);
						//layerPanel.getComponent(i+1).setVisible(true);
						i = i+arrVector.get(arrSize-i-1).getElementNum();	
					}
					else {
					}
				}
			}
				/*
			if(vectorIdx == arrVectorSize) {
				if(layerButton != null) {
					layerButton.setBackground(Color.CYAN);
					selLayerButton = layerButton;
				}
			}*/
		//}
		this.invalidate();
		this.validate();
		this.repaint();
	}
	
	public void layerRealignment(int _alignCompNumber) {
		if (selectLabel != null) {
			selectLabel.setForeground(Color.BLACK);
			isCopyStyle = false;
		}
		int arrVectorSize = arrVector.size()-1;
		int alignCompNumber = _alignCompNumber;
		for (int compNum = alignCompNumber; compNum <= arrVectorSize; compNum++) {
			String idx = Integer.toString(compNum);
			try {
				viewChkPanel = (JPanel) viewPanel.getComponent(compNum);
				layerButton = (JButton) layerPanel.getComponent(compNum);
				viewChkButton = (JButton) viewChkPanel.getComponent(0);
				viewChkPanel.setName(idx);
				layerButton.setName(idx);
				viewChkButton.setName(idx);
				//System.out.println(arrVector.get(arrVectorSize-compNum).getShape() + " Shape");
				if(arrVector.get(arrVectorSize-compNum).getToolName() != DrawToolConst.LAYER) {
					scroller = (JScrollPane) layerButton.getComponent(2);
					JViewport j = (JViewport) scroller.getComponent(0);
					funcPanel = (JPanel) j.getComponent(0);
					funcPanel.setName(idx);
				}
				//layer̸ 
				else {
					//System.out.println("shape must layer: " + arrVector.get(arrVector.size()-1-compNum).getShape());
					foldButton = (JButton) layerButton.getComponent(1);
					foldButton.setName(idx);
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	public void addVector(Element _element) {
		element = _element;		//buttonIndex = _elementIndex;
		
		//layer õǾ 
		int arrVectorSize = arrVector.size()-1;
		if(layerSelection) {
			for (int vectorIdx = arrVectorSize; vectorIdx >= 0; vectorIdx--) {
				Element tempElement = arrVector.get(vectorIdx);
				
				// layerȣ layer component
				if(tempElement.getLayerNum() == currentLayerNum) {
					//element count increase
					arrVector.get(vectorIdx).addElementNum();
					//element count increase in parent Layers
					int elemIndex = vectorIdx;
					for(int i=0; i<arrVector.get(vectorIdx).getParentLayerDepth(); i++) {
						int parentLayerNum = 
							arrVector.get(elemIndex).getParentLayerNum();
						if(parentLayerNum == 0) {
							break;
						}
						for (int idx = arrVectorSize; idx >= 0; idx--) {
							if(arrVector.get(idx).getLayerNum() == parentLayerNum) {
									//== arrVector.get(vectorIdx).getParentLayerNum()) {
								arrVector.get(idx).addElementNum();
								elemIndex = idx;
								break;
							}
						}
					}

					JButton tempLayerButton = 
						(JButton)layerPanel.getComponent(
								arrVectorSize-vectorIdx);
					JButton tempFoldButton =
						(JButton)tempLayerButton.getComponent(1);
					if(arrVector.get(vectorIdx).getElementNum() == 1)
						tempFoldButton.setIcon(unFoldingIcon);
					
					//element folding mode
					if(tempElement.isLayerFolding()) {
						addElement(arrVectorSize - vectorIdx + 1, true);
					}
					else {
						addElement(arrVectorSize - vectorIdx + 1, false);
						setLayerSelect(arrVectorSize - vectorIdx+1);
					}
					layerRealignment(arrVectorSize - vectorIdx + 2);
					MainWindow.getInstance().getPanel().setCurrentElementIndex(vectorIdx-1);
					break;
				}
			}
		}
		//layer ƴ element õǾ 
		else {
			for (int vectorIdx = arrVectorSize; vectorIdx >= 0; vectorIdx--) {
				Element tempElement = arrVector.get(vectorIdx);				
				// layerȣ layer component
				if(tempElement.getLayerNum() == currentLayerNum) {
					arrVector.get(vectorIdx).addElementNum();
					//element count increase in parent Layers
					int elemIndex = vectorIdx;
					for(int i=0; i<arrVector.get(vectorIdx).getParentLayerDepth(); i++) {
						int parentLayerNum = 
							arrVector.get(elemIndex).getParentLayerNum();
						if(parentLayerNum == 0) {
							break;
						}
						for (int idx = arrVectorSize; idx >= 0; idx--) {
							if(arrVector.get(idx).getLayerNum() == parentLayerNum) {
								arrVector.get(idx).addElementNum();
								elemIndex = idx;
								break;
							}
						}						
					}
					break;
				}
			}
			//btnCompIndex = Integer.parseInt(selLayerButton.getName());
			addElement(btnCompIndex, false);
			layerRealignment(btnCompIndex + 1);
			setLayerSelect(btnCompIndex);
			MainWindow.getInstance().getPanel().setCurrentElementIndex(
					arrVector.size()-1-btnCompIndex);
		}/*
		for(int i=arrVector.size()-1; i>=0; i-- ) {
			Element temp = arrVector.get(i);
			System.out.println(temp.getShape() + " layer: " + temp.getLayerNum()+
					" elemNum: " + temp.getElementNum() + " index: " + i + 
					" parentLayer: " + temp.getParentLayerNum() + 
					" parentDepth: " + temp.getParentLayerDepth());
		}
		System.out.println("");*/
		if (selectLabel != null) {
			selectLabel.setForeground(Color.BLACK);
			isCopyStyle = false;
		}
	}
		
	class NewLayerListener implements ActionListener { 
		public void actionPerformed(ActionEvent e) {
			JButton tempButton;
			int compIndex;
			//õ ư ε ȣ 
			for (compIndex = 0; compIndex < layerPanel.getComponentCount(); compIndex++) {
				try {
					tempButton = (JButton) layerPanel.getComponent(compIndex);
					if(tempButton.getBackground() == Color.CYAN) {
						btnCompIndex = compIndex;
						break;
					}
				} 
				catch (Exception ex) {
					ex.printStackTrace();
				}
			}
			//(layer  Ʈ ȣ оִ´)
			//  layer element̸
			if(arrVector.get(arrVector.size()-1-compIndex).getToolName()
					== DrawToolConst.LAYER) {
				//System.out.println("layer");
				increaseParentLayersElementNum(true);
				parentLayerNum = element.getParentLayerNum();
				parentLayerDepth = element.getParentLayerDepth();
				layerNum++;
				currentLayerNum = layerNum;
				element = new Layer(layerNum, parentLayerNum, parentLayerDepth);
				unsetLayerSelect(compIndex);
				//unsetLayerSelect();
				arrVector.add(arrVector.size()-compIndex, element);
				addLayer(compIndex, false);
				layerRealignment(compIndex+1);
				setLayerSelect(compIndex);
				//̾ ȣ, Ʈ ȣ 
				MainWindow.getInstance().getPanel().setCurrentElementIndex(arrVector.size()-1-compIndex);
				MainWindow.getInstance().getPanel().setLayerNum(layerNum);
				MainWindow.getInstance().getPanel().setParentLayerNum(parentLayerNum);
				MainWindow.getInstance().getPanel().setParentLayerDepth(parentLayerDepth);
			}
			//   element̸
			//ڽ layer  Ͱ 
			else {
				//System.out.println("");
				increaseParentLayersElementNum(false);
				parentLayerNum = element.getLayerNum();
				parentLayerDepth = element.getParentLayerDepth()+1;
				//System.out.println("pDepth"+parentLayerDepth);
				layerNum++;
				currentLayerNum = layerNum;
				element = new Layer(layerNum, parentLayerNum, parentLayerDepth);
				unsetLayerSelect(compIndex);
				//unsetLayerSelect();
				arrVector.add(arrVector.size()-compIndex, element);
				addLayer(compIndex, false);
				layerRealignment(compIndex+1);
				setLayerSelect(compIndex);
				//̾ ȣ, Ʈ ȣ 
				MainWindow.getInstance().getPanel().setCurrentElementIndex(arrVector.size()-1-compIndex);
				MainWindow.getInstance().getPanel().setLayerNum(layerNum);
				MainWindow.getInstance().getPanel().setParentLayerNum(parentLayerNum);	
				MainWindow.getInstance().getPanel().setParentLayerDepth(parentLayerDepth);			
			}			
			vectorToolBarRepaint();
		}
	}
	
	public void increaseParentLayersElementNum(boolean isCurrentLayer) {
		int arrVectorSize = arrVector.size()-1;
		for (int vectorIdx = arrVectorSize; vectorIdx >= 0; vectorIdx--) {
			Element tempElement = arrVector.get(vectorIdx);
			
			// layerȣ layer component
			if(tempElement.getLayerNum() == currentLayerNum) {
				if(!isCurrentLayer)
					arrVector.get(vectorIdx).addElementNum();
				//element count increase in parent Layers
				int elemIndex = vectorIdx;
				//System.out.println("kk" + layerNum + " k " + arrVector.get(vectorIdx).getParentLayerDepth());
				for(int i=0; i<arrVector.get(vectorIdx).getParentLayerDepth(); i++) {
					int parentLayerNum = 
						arrVector.get(elemIndex).getParentLayerNum();
					if(parentLayerNum == 0) {
						break;
					}
					for (int idx = arrVectorSize; idx >= 0; idx--) {
						if(arrVector.get(idx).getLayerNum() == parentLayerNum) {
								//== arrVector.get(vectorIdx).getParentLayerNum()) {
							arrVector.get(idx).addElementNum();
							elemIndex = idx;
							break;
						}
					}						
				}
				break;
			}
		}
	}
	
	class NewChildLayerListener implements ActionListener { 
		public void actionPerformed(ActionEvent e) {
			JButton tempButton = null;
			int compIndex;
			//õ ư ε ȣ 
			for (compIndex = 0; compIndex < layerPanel.getComponentCount(); compIndex++) {
				try {
					tempButton = (JButton) layerPanel.getComponent(compIndex);
					if(tempButton.getBackground() == Color.CYAN) {
						btnCompIndex = compIndex;
						break;
					}
				} 
				catch (Exception ex) {
					ex.printStackTrace();
				}
			}
			//element  ̹ ..?
			//element = arrVector.get(arrVector.size()-1-compIndex);
			//layerNum = element.getLayerNum() + 1;
			
			//child layer  Ʈ  ȣ оִ´.
			//  layer element̸
			if(arrVector.get(arrVector.size()-1-compIndex).getToolName()
					== DrawToolConst.LAYER) {
				increaseParentLayersElementNum(false);
				
				
				JButton tempFoldButton =
					(JButton)tempButton.getComponent(1);
				tempFoldButton.setIcon(unFoldingIcon);
				
				parentLayerNum = element.getLayerNum();
				parentLayerDepth = element.getParentLayerDepth()+1;
				//layerNum = element.getLayerNum() + 1;
				layerNum++;
				currentLayerNum = layerNum;
				element = new Layer(layerNum, parentLayerNum, parentLayerDepth);
				unsetLayerSelect(compIndex);
				//unsetLayerSelect();
				arrVector.add(arrVector.size()-1-compIndex, element);
				addLayer(compIndex+1, false);
				layerRealignment(compIndex+2);
				setLayerSelect(compIndex+1);
				//̾ ȣ, Ʈ ȣ 
				MainWindow.getInstance().getPanel().setCurrentElementIndex(arrVector.size()-2-compIndex);
				MainWindow.getInstance().getPanel().setLayerNum(layerNum);
				MainWindow.getInstance().getPanel().setParentLayerNum(parentLayerNum);
				MainWindow.getInstance().getPanel().setParentLayerDepth(parentLayerDepth);
				vectorToolBarRepaint();
			}
		}
	}

	public void setVector(Vector<Element> _vector) {
		arrVector = _vector; 
		int arrVectorSize = arrVector.size()-1;
		
		//if (arrVectorSize >= 0) {
			viewPanel.removeAll();
			layerPanel.removeAll();
			for (int vectorIdx = arrVectorSize; vectorIdx >= 0; vectorIdx--) {
				//fold
				element = arrVector.get(vectorIdx);
				if(element.isLayerFolding() == true) {	// && element.getShape().equals("Layer")
					element = arrVector.get(vectorIdx);
					parentLayerDepth = element.getParentLayerDepth();
					if(element.getToolName() != DrawToolConst.LAYER) {
						addElement(arrVectorSize-vectorIdx, false);	
						System.out.println("Ұ element 925line");
					}
					else {
						addLayer(arrVectorSize-vectorIdx, false);
						foldButton.setIcon(foldingIcon);
					}
					int elemCount = element.getElementNum();
					//vectorIdx--;
					for(int i=1; i<=elemCount; i++) {
						vectorIdx--;
						element = arrVector.get(vectorIdx);
						parentLayerDepth = element.getParentLayerDepth();
						if(element.getToolName() != DrawToolConst.LAYER) {
							addElement(arrVectorSize-vectorIdx, true);	
						}
						else {
							addLayer(arrVectorSize-vectorIdx, true);
							foldButton.setIcon(foldingIcon);
						}
					}
				}
				//
				else {
					//θ  
					parentLayerDepth = element.getParentLayerDepth();
					if(element.getToolName() != DrawToolConst.LAYER) {
						addElement(arrVectorSize-vectorIdx, false);	
					}
					else {
						addLayer(arrVectorSize-vectorIdx, false);
						if(element.getElementNum() != 0) {
							foldButton.setIcon(unFoldingIcon);
						}
					}
				}/*
				//ó ư
				if(vectorIdx == arrVectorSize) {
					if(layerButton != null) {
						layerButton.setBackground(Color.CYAN);
						selLayerButton = layerButton;
					}
				}*/
			}
			for(int i=arrVector.size()-1; i>=0; i-- ) {
				Element temp = arrVector.get(i);
				System.out.println(temp.getToolName() + " layer: " + temp.getLayerNum()+
						" elemNum: " + temp.getElementNum() + " index: " + i + 
						" parentLayer: " + temp.getParentLayerNum() + 
						" parentDepth: " + temp.getParentLayerDepth());
			}
			System.out.println("");
			this.invalidate();
			this.validate();
			this.repaint();
		//}
	}
	
	public void setLayerSelectByElemNum(int elemNum) {
		setLayerSelect(arrVector.size()-1-elemNum);
	}
	
	public void unsetLayerSelect(int compNum) {
		if (selLayerButton != null) {
			selLayerButton.setSelected(false);
			
			if(arrVector.get(arrVector.size()-1-compNum).getToolName()
					!= DrawToolConst.LAYER)
				selLayerButton.setBackground(Color.WHITE);
			else
				selLayerButton.setBackground(componentColor);
			selLayerButton = null;
		}		
	}
	
	public void unsetLayerSelect() {
		if (selLayerButton != null) {
			selLayerButton.setSelected(false);
			
			if(arrVector.get(arrVector.size()-1-Integer.parseInt(
					selLayerButton.getName())).getToolName()
					!= DrawToolConst.LAYER)
				selLayerButton.setBackground(Color.WHITE);
			else
				selLayerButton.setBackground(componentColor);
			selLayerButton = null;
		}		
	}
	
	public void setLayerSelect(int compNum) {
		if (selectLabel != null) {
			selectLabel.setForeground(Color.BLACK);
			isCopyStyle = false;
		}
		if (selLayerButton != null) {
			int selLayerNum = Integer.parseInt(selLayerButton.getName());
			selLayerButton.setSelected(false);
			if(arrVector.get(arrVector.size()-1-selLayerNum).getToolName()
					!= DrawToolConst.LAYER)
				selLayerButton.setBackground(Color.WHITE);
			else
				selLayerButton.setBackground(componentColor);
		}
		selLayerButton = (JButton) layerPanel.getComponent(compNum);
		selLayerButton.setSelected(true);
		selLayerButton.setBackground(Color.CYAN);
		selLayerButton.validate();
		btnCompIndex = Integer.parseInt(selLayerButton.getName());
		elementIndex = arrVector.size()-1-compNum;
		//System.out.println(elementIndex);
		currentLayerNum = arrVector.get(elementIndex).getLayerNum();
		element = arrVector.get(elementIndex);

		if(element.getToolName() == DrawToolConst.LAYER) {
			//System.out.println("Layer");
			MainWindow.getInstance().getPanel().setLayerSelection(true);
			layerSelection = true;
		}
		else {
			//System.out.println("Elem");
			MainWindow.getInstance().getPanel().setLayerSelection(false);
			layerSelection = false;
		}
		parentLayerNum = element.getParentLayerNum();
		parentLayerDepth = element.getParentLayerDepth();
		MainWindow.getInstance().getPanel().setParentLayerNum(parentLayerNum);
		MainWindow.getInstance().getPanel().setParentLayerDepth(parentLayerDepth);
		MainWindow.getInstance().getPanel().setLayerNum(currentLayerNum);
		//MainWindow.getInstance().getPanel().setElementIndex(elementIndex);
		MainWindow.getInstance().getPanel().setSelect(
				element, elementIndex);
		//element = arrVector.get(compNum);		
		//MainWindow.getInstance().getPanel().repaint();
	}
	
	//layer button Event
	class LayerListener implements ActionListener { 
		public void actionPerformed(ActionEvent e) {
			if (selectLabel != null) {
				selectLabel.setForeground(Color.BLACK);
				isCopyStyle = false;
			}
			if (selLayerButton != null) {
				int tempBtnCompIndex = Integer.parseInt(selLayerButton.getName());
				selLayerButton.setSelected(false);
				if(arrVector.get(arrVector.size()-1-tempBtnCompIndex).getToolName()
						!= DrawToolConst.LAYER)
					selLayerButton.setBackground(Color.WHITE);
				else
					selLayerButton.setBackground(componentColor);
			}
			selLayerButton = (JButton) e.getSource();
			btnCompIndex = Integer.parseInt(selLayerButton.getName());
			elementIndex = arrVector.size()-1-btnCompIndex;
			//System.out.println("comp Name " + btnCompIndex + "eleIn" + elementIndex);
			selLayerButton.setSelected(true);
			selLayerButton.setBackground(Color.CYAN);
			selLayerButton.validate();
			currentLayerNum = arrVector.get(elementIndex).getLayerNum();
			element = arrVector.get(elementIndex);
			if(element.getToolName() == DrawToolConst.LAYER) {
				MainWindow.getInstance().getPanel().setLayerSelection(true);
				layerSelection = true;
			}
			else {
				MainWindow.getInstance().getPanel().setLayerSelection(false);
				layerSelection = false;
			}

			parentLayerNum = element.getParentLayerNum();
			parentLayerDepth = element.getParentLayerDepth();
			MainWindow.getInstance().getPanel().setParentLayerNum(parentLayerNum);
			MainWindow.getInstance().getPanel().setParentLayerDepth(parentLayerDepth);
			MainWindow.getInstance().getPanel().setLayerNum(currentLayerNum);
			//MainWindow.getInstance().getPanel().setElementIndex(elementIndex);			
			MainWindow.getInstance().getPanel().setSelect(
					element, elementIndex);
			MainWindow.getInstance().getPanel().repaintAll();
		}
	}
	
	public void setFuncVector(Element _element, int index) {
		//..
		//index = arr
		layerButton = (JButton) layerPanel.getComponent(
				arrVector.size()-1-index);
		scroller = (JScrollPane) layerButton.getComponent(2);
		JViewport j = (JViewport) scroller.getComponent(0);
		funcPanel = (JPanel) j.getComponent(0);
		element = _element;
		layoutCount = 0;
		if (element.getTransformMode())
			layoutCount++;
		if (element.getColorMode())
			layoutCount++;
		if (element.getGradientMode())
			layoutCount++;
		if (element.getPatternMode())
			layoutCount++;
		if (element.getStrokeMode())
			layoutCount++;
		if (layoutCount != 0) {
			funcPanel.removeAll();
			funcPanel.setPreferredSize(new Dimension(
					FUNC_SCROLLER_WIDTH-22, 
					FUNC_INNERPANEL_HEIGHT * layoutCount));
			funcPanel.setLayout(new GridLayout(layoutCount, 1));
		} 
		else {
			funcPanel.removeAll();
			funcPanel.setLayout(new GridLayout(1, 1));
			defaultLabel = new JLabel("Nothing", SwingConstants.CENTER);
			defaultLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			defaultLabel.setFont(font);
			funcPanel.add(defaultLabel);
		}
		if (element.getTransformMode()) {
			editLabel = new JLabel("Transform", SwingConstants.CENTER);
			editLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			editLabel.setFont(font);
			funcPanel.add(editLabel);
		}
		if (element.getColorMode() == true) {
			colorLabel = new JLabel("Color", SwingConstants.CENTER);
			colorLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			colorLabel.setFont(font);
			funcPanel.add(colorLabel);
		}
		if (element.getGradientMode() == true) {
			gradLabel = new JLabel("Gradient", SwingConstants.CENTER);
			gradLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			gradLabel.setFont(font);
			funcPanel.add(gradLabel);
		}
		if (element.getPatternMode()) {
			patternLabel = new JLabel("Pattern", SwingConstants.CENTER);
			patternLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			patternLabel.setFont(font);
			funcPanel.add(patternLabel);
		}
		if (element.getStrokeMode()) {
			strokeLabel = new JLabel("Stroke", SwingConstants.CENTER);
			strokeLabel.setBorder(BorderFactory.createRaisedBevelBorder());
			strokeLabel.setFont(font);
			funcPanel.add(strokeLabel);
		}
		scroller.validate();
	}

	public void vectorToolBarRepaint() {
		this.invalidate();
		this.validate();
		this.repaint();
	}

	public void setPanelSize(float _width, float _height) {
		if (_width * 28.0f / 32.0f > _height) {
			sDrawPanelWidth = 32;
			sDrawPanelScaleValue = 32.0f / _width;
			sDrawPanelHeight = Math.round(_height * sDrawPanelScaleValue);
		} else {
			sDrawPanelHeight = 28;
			sDrawPanelScaleValue = 28.0f / _height;
			sDrawPanelWidth = Math.round(_width * sDrawPanelScaleValue);
		}
		if (arrVector != null) {
			for (int i = 0; i < arrVector.size(); i++) {
				if (element != null && element.getToolName() == DrawToolConst.TEXT)
					((TextTool) element).initSmallPanelSize();
			}
		}
	}

	class FuncListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (selLayerButton != null) {
				funcNum = Integer.parseInt(selLayerButton.getName());
				elementNum = arrVector.size()-1-funcNum;
				if (elementNum < arrVector.size()) {
					element = arrVector.get(elementNum);
					element.setSelected(false);
					//setLayerSelect(funcNum);
					funcDialog = VectorProcessDialog.getInstance();
					funcDialog.setElement(element, elementNum);
					funcDialog.setVisible(true);
					// MainWindow.panel.setSelect(element, funcNum);
					MainWindow.getInstance().getPanel().repaintAll();
				}
			}
			if (selectLabel != null) { // function copy cancel
				selectLabel.setForeground(Color.BLACK);
				isCopyStyle = false;
			}
		}
	}

	public void removeElement() {
		int arrVectorSize = arrVector.size()-1;
		if (arrVectorSize>0 && selLayerButton != null) {
			funcNum = Integer.parseInt(selLayerButton.getName());
			elementNum = arrVectorSize-funcNum;
			
			if(arrVector.get(elementNum).getToolName() != DrawToolConst.LAYER) {
				if(arrVector.get(elementNum).getToolName() == DrawToolConst.PEN) {
					MainWindow.getInstance().getPanel().setDrawingTool(DrawToolConst.PEN);
				}
				unsetLayerSelect(funcNum);
				MainWindow.getInstance().getPanel().addUndoVector(
						element,
						elementNum);
				
				//ش layer subElementNum
				for (int vectorIdx = arrVectorSize; vectorIdx >= 0; vectorIdx--) {
					Element tempElement = arrVector.get(vectorIdx);				
					// layerȣ layer component
					if(tempElement.getLayerNum() == currentLayerNum) {
						arrVector.get(vectorIdx).subElementNum();
						//elementCount 0 Ǹ fold icon null
						if(arrVector.get(vectorIdx).getElementNum() == 0) {
							JButton tempLayerButton = 
								(JButton)layerPanel.getComponent(
										arrVector.size()-1-vectorIdx);
							JButton tempFoldButton =
								(JButton)tempLayerButton.getComponent(1);
							tempFoldButton.setIcon(null);
							//break; delete 09.10/11:38 success
						}
						//element count decrease in parent Layers
						int elemIndex = vectorIdx;
						for(int i=0; i<arrVector.get(vectorIdx).getParentLayerDepth(); i++) {
							int parentLayerNum = 
								arrVector.get(elemIndex).getParentLayerNum();
							if(parentLayerNum == 0) {
								break;
							}
							for (int idx = arrVectorSize; idx >= 0; idx--) {
								if(arrVector.get(idx).getLayerNum() == parentLayerNum) {
										//== arrVector.get(vectorIdx).getParentLayerNum()) {
									arrVector.get(idx).subElementNum();
									elemIndex = idx;
									break;
								}
							}						
						}
						break;
					}
				}						
				
				arrVector.remove(elementNum);
				viewPanel.remove(funcNum);
				layerPanel.remove(funcNum);
				// ȣ  Ʈ  ų ũ  
				if(funcNum < layerPanel.getComponentCount())
					layerRealignment(funcNum);
				
				//   layer  select			
				if(funcNum == layerPanel.getComponentCount()) {
					setLayerSelect(funcNum-1);
				}
				else
					setLayerSelect(funcNum);
			}			
			MainWindow.getInstance().getPanel().repaintAll();
			vectorToolBarRepaint();					
		}
		if (selectLabel != null) {
			selectLabel.setForeground(Color.BLACK);
			isCopyStyle = false;
		}
	}
	//   ̾/Ʈ (dialog  Ʒ)
	class EraserListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			int arrVectorSize = arrVector.size()-1;
			if (arrVectorSize>0 && selLayerButton != null) {
				funcNum = Integer.parseInt(selLayerButton.getName());
				elementNum = arrVectorSize-funcNum;
				
				if(arrVector.get(elementNum).getToolName() != DrawToolConst.LAYER) {
					if(arrVector.get(elementNum).getToolName() == DrawToolConst.PEN) {
						MainWindow.getInstance().getPanel().setDrawingTool(DrawToolConst.PEN);
					}
					unsetLayerSelect(funcNum);
					MainWindow.getInstance().getPanel().addUndoVector(
							element,
							elementNum);
					
					//ش layer subElementNum
					for (int vectorIdx = arrVectorSize; vectorIdx >= 0; vectorIdx--) {
						Element tempElement = arrVector.get(vectorIdx);				
						// layerȣ layer component
						if(tempElement.getLayerNum() == currentLayerNum) {
							arrVector.get(vectorIdx).subElementNum();
							//elementCount 0 Ǹ fold icon null
							if(arrVector.get(vectorIdx).getElementNum() == 0) {
								JButton tempLayerButton = 
									(JButton)layerPanel.getComponent(
											arrVector.size()-1-vectorIdx);
								JButton tempFoldButton =
									(JButton)tempLayerButton.getComponent(1);
								tempFoldButton.setIcon(null);
								//break; delete 09.10/11:38 success
							}
							//element count decrease in parent Layers
							int elemIndex = vectorIdx;
							for(int i=0; i<arrVector.get(vectorIdx).getParentLayerDepth(); i++) {
								int parentLayerNum = 
									arrVector.get(elemIndex).getParentLayerNum();
								if(parentLayerNum == 0) {
									break;
								}
								for (int idx = arrVectorSize; idx >= 0; idx--) {
									if(arrVector.get(idx).getLayerNum() == parentLayerNum) {
											//== arrVector.get(vectorIdx).getParentLayerNum()) {
										arrVector.get(idx).subElementNum();
										elemIndex = idx;
										break;
									}
								}						
							}
							break;
						}
					}						
					
					arrVector.remove(elementNum);
					viewPanel.remove(funcNum);
					layerPanel.remove(funcNum);
					// ȣ  Ʈ  ų ũ  
					if(funcNum < layerPanel.getComponentCount())
						layerRealignment(funcNum);
					
					//   layer  select			
					if(funcNum == layerPanel.getComponentCount()) {
						setLayerSelect(funcNum-1);
					}
					else
						setLayerSelect(funcNum);
				}
				//layer  ڽ  
				//Layer elementCountŭ  
				else {					
					int layerCount = 0;
					//
					if(arrVector.get(elementNum).getParentLayerNum() == 0) {
						for (int vectorIdx = arrVectorSize; vectorIdx >= 0; vectorIdx--) {							
							if(arrVector.get(vectorIdx).getToolName() == DrawToolConst.LAYER
									&& arrVector.get(vectorIdx).getParentLayerNum()==0) {
								layerCount++;
							}
						}
					} else {
						layerCount = 2;
					}
					
					if(layerCount>1) {
						unsetLayerSelect(funcNum);
						
						//ش layer subElementNum
						int elementCount = arrVector.get(elementNum).getElementNum()+1;
						//element count decrease in parent Layers
						int elemIndex = elementNum;
						for(int i=0; i<arrVector.get(elementNum).getParentLayerDepth(); i++) {
							int parentLayerNum = 
								arrVector.get(elemIndex).getParentLayerNum();
							if(parentLayerNum == 0) {
								break;
							}
							for (int idx = arrVectorSize; idx >= 0; idx--) {
								if(arrVector.get(idx).getLayerNum() == parentLayerNum) {
										//== arrVector.get(vectorIdx).getParentLayerNum()) {
									arrVector.get(idx).subElementNum(elementCount);
									elemIndex = idx;
									break;
								}
							}						
						}

						for(int i=elementNum; i>elementNum-elementCount; i--) {
							arrVector.remove(i);
						}
						
						for(int idx=funcNum; idx<funcNum+elementCount; idx++) {
							viewPanel.remove(funcNum);
							layerPanel.remove(funcNum);
						}
						// ȣ  Ʈ  ų ũ  
						if(funcNum < layerPanel.getComponentCount())
							layerRealignment(funcNum);
						
						//   layer  select			
						//if (layerPanel.getComponentCount()>1) {
						if(funcNum == layerPanel.getComponentCount()) {
							setLayerSelect(funcNum-1);
						} else
							setLayerSelect(funcNum);
						//System.out.println(funcNum + " total:" + layerPanel.getComponentCount());
					}					
				}
				MainWindow.getInstance().getPanel().repaintAll();
				vectorToolBarRepaint();					
			}
			// function copy cancel
			if (selectLabel != null) {
				selectLabel.setForeground(Color.BLACK);
				isCopyStyle = false;
			}
		}
	}
	
	//layer Ʈ θ,   
	// layer  depth  isDestLayerDeep trueҴ, ƴϸ false
	private void inLayerValueSet(boolean isDestLayerDeep) {
		int originalCurrentElementDepth = currentElem.getParentLayerDepth();
		int elemCount = currentElem.getElementNum();
		int tempLayerNum = currentElem.getLayerNum();
		if(isDestLayerDeep) {
			int depthInterval = destElem.getParentLayerDepth() - originalCurrentElementDepth; 
			for(int i=elementNum; i>=elementNum-elemCount; i--) {
				if(tempLayerNum == arrVector.get(i).getLayerNum()) {
					arrVector.get(i).setParentLayerNum(destElem.getParentLayerNum());
					arrVector.get(i).setParentLayerDepth(destElem.getParentLayerDepth());
				}
				else {
					arrVector.get(i).addParentLayerDepth(depthInterval);
				}
			}
		}
		else {
			for(int i=elementNum; i>=elementNum-elemCount; i--) {
				if(tempLayerNum == arrVector.get(i).getLayerNum()) {
					arrVector.get(i).setParentLayerNum(destElem.getParentLayerNum());
					arrVector.get(i).setParentLayerDepth(destElem.getParentLayerDepth());
				}
				else {
					arrVector.get(i).subParentLayerDepth();
				}
			}
		}
	}
	
	private void innerLayerValueSetInDown() {
		int originalCurrentElementDepth = currentElem.getParentLayerDepth();
		int currentElementCount = currentElem.getElementNum();
		int currentLayerNum = currentElem.getLayerNum();
		destElem = arrVector.get(elementNum-currentElementCount-1);
		int depthInterval = destElem.getParentLayerDepth() + 1
				- originalCurrentElementDepth; 
		for(int i=elementNum; i>=elementNum-currentElementCount; i--) {
			if(currentLayerNum == arrVector.get(i).getLayerNum()) {
				arrVector.get(i).setParentLayerNum(destElem.getLayerNum());
				arrVector.get(i).setParentLayerDepth(destElem.getParentLayerDepth()+1);
			}
			else {
				arrVector.get(i).addParentLayerDepth(depthInterval);
			}
		}
	}
	
	private void innerElementValueSetInDown() {
		int currentElementCount = currentElem.getElementNum();
		
		destElem = arrVector.get(elementNum-currentElementCount-1);
		arrVector.get(elementNum).setLayerNum(
				destElem.getLayerNum());
		arrVector.get(elementNum).setParentLayerNum(
				destElem.getParentLayerNum());
		arrVector.get(elementNum).setParentLayerDepth(
				destElem.getParentLayerDepth());
	}
	
	private void elementValueSet(boolean isDestLayer) {

		if(isDestLayer) {
			if(destElem.getParentLayerNum()!=0) {
				arrVector.get(elementNum).setLayerNum(destElem.getParentLayerNum());
				arrVector.get(elementNum).setParentLayerDepth(destElem.getParentLayerDepth()-1);
				int arrSize = arrVector.size()-1;
				int destLayerNum = destElem.getParentLayerNum();
				for(int i=arrSize; i>elementNum; i--) {
					if(arrVector.get(i).getLayerNum() == destLayerNum) {
						arrVector.get(elementNum).setParentLayerNum(arrVector.get(i).getParentLayerNum());
						break;
					}
				}
			} 
			//θ ̾  ̾ ̵ÿ
			//   ̾ ȣ 
			else {	
				int arrSize = arrVector.size()-1;
				for(int i=elementNum+2; i<=arrSize; i++) {
					Element tempElement = arrVector.get(i);
					if(tempElement.getParentLayerNum() == 0
							&& tempElement.getToolName() == DrawToolConst.LAYER) {
						arrVector.get(i).addElementNum();
						arrVector.get(elementNum).setLayerNum(tempElement.getLayerNum());
						arrVector.get(elementNum).setParentLayerNum(0);
						arrVector.get(elementNum).setParentLayerDepth(0);
					}
				}
			}
		} else {
			arrVector.get(elementNum).setLayerNum(destElem.getLayerNum());
			arrVector.get(elementNum).setParentLayerNum(destElem.getParentLayerNum());
			arrVector.get(elementNum).setParentLayerDepth(destElem.getParentLayerDepth());
		}
	}

	private void inLayerValueSetIfDestIsElement() {
		//int elementNum = _elementNum;
		//Element currentElem = arrVector.get(elementNum);
		//Element destElem = arrVector.get(elementNum+1);
		int originalCurrentElementDepth = currentElem.getParentLayerDepth();
		int elemCount = currentElem.getElementNum();
		int tempLayerNum = currentElem.getLayerNum();
		//if(isDestLayerDeep) {
		int depthInterval = destElem.getParentLayerDepth() + 1 
						- originalCurrentElementDepth; 
		for(int i=elementNum; i>=elementNum-elemCount; i--) {
			if(tempLayerNum == arrVector.get(i).getLayerNum()) {
				arrVector.get(i).setParentLayerNum(destElem.getLayerNum());
				arrVector.get(i).setParentLayerDepth(destElem.getParentLayerDepth()+1);
			} else {
				arrVector.get(i).addParentLayerDepth(depthInterval);
			}
		}
	}
	
	private void parentsElementCountIncrease(boolean isDestLayer) {		
		int originalParentLayerNum = currentElem.getParentLayerNum();
		int originalElementCount = currentElem.getElementNum()+1;
		int arrVectorSize = arrVector.size()-1;
		
		for(int i=elementNum+2; i<=arrVectorSize; i++) {	//1 2 
			Element tempElement = arrVector.get(i);
			if(tempElement.getToolName() == DrawToolConst.LAYER) {
				if(isDestLayer) {
					if(tempElement.getParentLayerDepth() < destElem.getParentLayerDepth()) {
						arrVector.get(i).setElementNum(
								tempElement.getElementNum()+originalElementCount);
					}
				}
				else {
					//System.out.println(arrVector.get(i).getParentLayerNum() + 
					//"on" + originalParentLayerNum + " oc:" + originalElementCount);
					if(tempElement.getParentLayerDepth() < destElem.getParentLayerDepth()+1) {
						arrVector.get(i).setElementNum(
								tempElement.getElementNum()+originalElementCount);
					}					
				}
				if(arrVector.get(i).getParentLayerNum() == originalParentLayerNum) {
					break;
				}
			}
		}				
	}
	
	private void previousParentsElementCountDecrease(boolean currentIsLayer) {		
		//int originalParentLayerNum = currentElem.getParentLayerNum();
		int originalElementCount = currentElem.getElementNum()+1;
		int arrVectorSize = arrVector.size()-1;
		int destParentLayerNum;
		if(destElem.getToolName() == DrawToolConst.LAYER) {
			destParentLayerNum = destElem.getParentLayerNum();
		} else {
			destParentLayerNum = destElem.getLayerNum();
		}

		int tempParentLayerNum;
		if(currentIsLayer) {
			tempParentLayerNum = currentElem.getParentLayerNum();
		} else {
			tempParentLayerNum = currentElem.getLayerNum();
		}		
		for(int i=elementNum+1; i<=arrVectorSize; i++) {	//1 2 
			Element tempElement = arrVector.get(i);
			if(tempElement.getToolName() == DrawToolConst.LAYER) {
				if(currentIsLayer) {
					if(tempElement.getLayerNum() == tempParentLayerNum) {
						arrVector.get(i).setElementNum(
								tempElement.getElementNum()-originalElementCount);
						tempParentLayerNum = tempElement.getParentLayerNum();
					}
				}
				else {
					if(tempElement.getLayerNum() == tempParentLayerNum) {
						arrVector.get(i).setElementNum(
								tempElement.getElementNum()-originalElementCount);
						tempParentLayerNum = tempElement.getParentLayerNum();
					}
				}
				if(tempElement.getParentLayerNum() == destParentLayerNum) {
					break;
				}
			}
		}
		// layer̸ elementCount ش
		int destIndex = elementNum-currentElem.getElementNum()-1;
		if(arrVector.get(destIndex).getToolName() == DrawToolConst.LAYER) {
			arrVector.get(destIndex).addElementNum(currentElem.getElementNum()+1);
			//System.out.println("current" + currentElem.getElementNum()+1);
		}
	}
	
	private void parentsElementCountIncreaseOneStep(boolean isDestLayer) {		
		int originalLayerNum = currentElem.getLayerNum();
		int arrVectorSize = arrVector.size()-1;
		
		for(int i=elementNum+2; i<=arrVectorSize; i++) {	//1 2 
			Element tempElement = arrVector.get(i);
			if(tempElement.getToolName() == DrawToolConst.LAYER) {
				if(isDestLayer) {
					if(tempElement.getParentLayerDepth() < destElem.getParentLayerDepth()) {
						arrVector.get(i).setElementNum(
								tempElement.getElementNum()+1);
					}
				} else {
					if(tempElement.getParentLayerDepth() < destElem.getParentLayerDepth()+1) {
						arrVector.get(i).setElementNum(
								tempElement.getElementNum()+1);
					}					
				}
				if(arrVector.get(i).getParentLayerNum() == originalLayerNum) {
					break;
				}
			}
		}
	}
		
	/*private void parentsElementCountDecreaseAndIncreaseOneStep() {		
		int originalLayerNum = currentElem.getLayerNum();
		int arrVectorSize = arrVector.size()-1;

		//
		arrVector.get(elementNum+1).subElementNum();	
		if(destElem.getParentLayerNum()!=0) {
		}
		//decrease ⺻ θ ̾  ̾ ̵ÿ
		//   ̾ ڽ  Ƽ̼  ȴ.
		else {
			arrVector.get(elementNum+1).subElementNum();
			for(int i=elementNum+2; i<=arrVectorSize; i++) {	//1 2 
				Element tempElement = arrVector.get(i);
				if(tempElement.getShape().equals("Layer")) {
					if(isDestLayer) {
						if(tempElement.getParentLayerDepth() < destElem.getParentLayerDepth()) {
							arrVector.get(i).setElementNum(
									tempElement.getElementNum()+1);
						}
					} else {
						if(tempElement.getParentLayerDepth() < destElem.getParentLayerDepth()+1) {
							arrVector.get(i).setElementNum(
									tempElement.getElementNum()+1);
						}					
					}
					if(arrVector.get(i).getParentLayerNum() == originalLayerNum) {
						break;
					}
				}
			}			
		}
	}*/
	
	private void parentElementCountDecreaseOneStep() {
		arrVector.get(elementNum+1).subElementNum();		
	}
	
	private void parentElementCountDecrease() {
		//int elementNum = _elementNum;
		//Element currentElem = arrVector.get(elementNum);		
		int elementCount = currentElem.getElementNum()+1;
		arrVector.get(elementNum+1).setElementNum(
				arrVector.get(elementNum+1).getElementNum()-elementCount);		
	}
	
	private void layerMoveUp() {
		int elemCount = currentElem.getElementNum();
		arrVector.add(elementNum-elemCount, destElem);			
		arrVector.remove(elementNum+2);	
		setVector(arrVector);	
		setLayerSelect(arrVector.size()-elementNum-2);
	}
		
	private void layersMoveDown() {
		int currentElementCount = currentElem.getElementNum();
		if(elementNum-currentElementCount>0) {			
			Element tempDestElem = arrVector.get(elementNum-currentElementCount-1);
			destElem = tempDestElem;
			if(tempDestElem.getToolName() == DrawToolConst.LAYER) {
				if(tempDestElem.getParentLayerDepth()
						== currentElem.getParentLayerDepth()) { 
					int destIndex = elementNum-currentElementCount-1-tempDestElem.getElementNum();					
					for(int i=elementNum; i>=elementNum-currentElementCount; i--) {
						Element tempElem = arrVector.get(elementNum);
						arrVector.remove(elementNum);
						arrVector.add(destIndex, tempElem);
						//System.out.println(arrVector.size() + "arrVector.size()");
					}
					setVector(arrVector);
					setLayerSelect(arrVector.size()-1-(destIndex+currentElementCount));
				} else { //ǥ ̰    
					previousParentsElementCountDecrease(true);
					innerLayerValueSetInDown();
					int destIndex = elementNum-currentElementCount-1;					
					for(int i=elementNum; i>=elementNum-currentElementCount; i--) {
						Element tempElem = arrVector.get(elementNum);
						arrVector.remove(elementNum);
						arrVector.add(destIndex, tempElem);
						//System.out.println(arrVector.size() + "arrVector.size()");
					}
					setVector(arrVector);
					setLayerSelect(arrVector.size()-1-(destIndex+currentElementCount));
				}
			} else {	//ǥ  element 
				if(tempDestElem.getParentLayerDepth()
						== currentElem.getParentLayerDepth()-1) { 
					
				}
				if(tempDestElem.getLayerNum()
						== currentElem.getParentLayerNum()) { 
					
				} else {
					previousParentsElementCountDecrease(true);
					innerLayerValueSetInDown();					
				}
				int destIndex = elementNum-currentElementCount-1;
				Element tempElem = arrVector.get(destIndex);
				arrVector.remove(destIndex);
				arrVector.add(elementNum, tempElem);				
				setVector(arrVector);
				setLayerSelect(arrVector.size()-1-(destIndex+currentElementCount));
			}
		}
		//setLayerSelect(arrVector.size()-1-(elementNum-currentElementCount-1));
	}
	
	private void layerMoveDown() { 
		//same as elementMoveDown
		if(elementNum>0) {
			arrVector.add(elementNum+1, destElem);
			arrVector.remove(elementNum-1);	
			setVector(arrVector);
			setLayerSelect(arrVector.size()-elementNum);
		}
	}
		
	private void layerMoveDownDestIsLayer() { 
		//destElem = arrVectordestElem.getElementNum()-1;
		int destIndex = elementNum-1-destElem.getElementNum();				
		arrVector.add(destIndex, currentElem);
		arrVector.remove(elementNum+1);	
		setVector(arrVector);
		setLayerSelect(arrVector.size()-1-destIndex);
	}
	
	private void elementMoveUp() {
		//int elemCount = currentElem.getElementNum();
		arrVector.add(elementNum, destElem);
		arrVector.remove(elementNum+2);	
		setVector(arrVector);
		setLayerSelect(arrVector.size()-elementNum-2);
	}
		
	private void elementMoveDown() {
		if(elementNum>0) {
			arrVector.add(elementNum+1, destElem);
			arrVector.remove(elementNum-1);	
			setVector(arrVector);
			setLayerSelect(arrVector.size()-elementNum);
		}
	}
	
	class UpListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (selLayerButton != null && !selLayerButton.getName().equals("0")) {
				funcNum = Integer.parseInt(selLayerButton.getName());
				elementNum = arrVector.size()-1-funcNum;
				currentElem = arrVector.get(elementNum);
				destElem = arrVector.get(elementNum+1);
				
				if(currentElem.getToolName() == DrawToolConst.LAYER) {
					// layer, θ layer 
					if(destElem.getToolName() == DrawToolConst.LAYER) {
						if(destElem.getParentLayerNum() == currentElem.getParentLayerNum()) {
							layerMoveUp();
						} else if(destElem.getParentLayerDepth()
								> currentElem.getParentLayerDepth()) {
							//parent layer is deep			
							parentsElementCountIncrease(true);				
							inLayerValueSet(true);				
							//if (elementNum+1 < arrVector.size()-1) {
							//}
							//argue is isDestLayer
							layerMoveUp();
						} else {	//parent layer isn't deep		
							parentElementCountDecrease();						
							inLayerValueSet(false);		
							layerMoveUp();
						}
					} 
					// layer, θ   
					else {
						if(destElem.getLayerNum() == currentElem.getParentLayerNum()) {
							layerMoveUp();
						} else if(destElem.getParentLayerDepth() >= currentElem.getParentLayerDepth()) {
							//parent layer is deep
							parentsElementCountIncrease(false);
							inLayerValueSetIfDestIsElement();
							layerMoveUp();
						} else {
							System.out.println("ڽ layer, θ /Ұ");						
						}
					}
				} else {	
					//  , θ layer 
					if(destElem.getToolName() == DrawToolConst.LAYER) {
						if(destElem.getParentLayerNum() == currentElem.getLayerNum()) {
							elementMoveUp();
						} else if(destElem.getParentLayerDepth()-1 > currentElem.getParentLayerDepth()) {
							//parent layer is deep
							parentsElementCountIncreaseOneStep(true);
							elementValueSet(true);
							elementMoveUp();
						} else {
							if (elementNum+1 < arrVector.size()-1) {
								parentElementCountDecreaseOneStep();
								elementValueSet(true);
								elementMoveUp();
							}
						}			
					}
					// , θ  
					else {
						if(destElem.getLayerNum() == currentElem.getLayerNum()) {
							elementMoveUp();
						} else if(destElem.getParentLayerDepth() > currentElem.getParentLayerDepth()) {
							//parent layer is deep
							parentsElementCountIncreaseOneStep(false);
							elementValueSet(false);
							elementMoveUp();
						} else {
							System.out.println("ڽ layer, θ /Ұ");						
						}
					}					
				}/*
				for(int i=arrVector.size()-1; i>=0; i-- ) {
					Element temp = arrVector.get(i);
					System.out.println(temp.getShape() + " layer: " + temp.getLayerNum()+
							" elemNum: " + temp.getElementNum() + " index: " + i + 
							" parentLayer: " + temp.getParentLayerNum() + 
							" parentDepth: " + temp.getParentLayerDepth());
				}
				System.out.println("up up up");*/
				MainWindow.getInstance().getPanel().repaintAll();
				vectorToolBarRepaint();

				if (selectLabel != null) { // function copy cancel
					selectLabel.setForeground(Color.BLACK);
					isCopyStyle = false;
				}
			}
		}
	}

	class DownListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			funcNum = Integer.parseInt(selLayerButton.getName());
			if (selLayerButton != null && arrVector.size()-1-funcNum > 0) {
				elementNum = arrVector.size()-1-funcNum;
				currentElem = arrVector.get(elementNum);
				destElem = arrVector.get(elementNum-1);
				
				if(currentElem.getToolName() == DrawToolConst.LAYER) {
					//destElem = arrVector.get(elementNum-currentElem.getElementNum()-1);
					// layer,  layer 
					if(destElem.getToolName() == DrawToolConst.LAYER) {
						if(destElem.getParentLayerNum()
								== currentElem.getParentLayerNum()) {
							layerMoveDownDestIsLayer();
						} else if(destElem.getParentLayerDepth()
								> currentElem.getParentLayerDepth()) {	
							layersMoveDown();
						} else {	//parent layer isn't deep		
							previousParentsElementCountDecrease(true);
							innerLayerValueSetInDown();
							layerMoveDown();
						}
					} 
					// layer,    
					else {
						if(destElem.getLayerNum() == currentElem.getParentLayerNum()) {
							layerMoveDown();
						} else if(destElem.getLayerNum() == currentElem.getLayerNum()) {						
							layersMoveDown();
						} else {		
							previousParentsElementCountDecrease(true);
							innerLayerValueSetInDown();
							layerMoveDown();			
						}
					}
				} else {
					//  ,  layer 
					if(destElem.getToolName() == DrawToolConst.LAYER) {
						if(destElem.getParentLayerNum() == currentElem.getLayerNum()) {
							layerMoveDownDestIsLayer();
						} else if(destElem.getParentLayerDepth() <= currentElem.getParentLayerDepth()) {
							previousParentsElementCountDecrease(false);		
							innerElementValueSetInDown();
							elementMoveDown();
						} else {
							System.out.println(" layer,  /Ұ");	
						}			
					}
					// ,   
					else {
						if(destElem.getLayerNum() == currentElem.getLayerNum()) {
							elementMoveDown();
						} else if(destElem.getParentLayerDepth() < currentElem.getParentLayerDepth()) {
							previousParentsElementCountDecrease(false);
							innerElementValueSetInDown();
							elementMoveDown();
						} else {
							System.out.println(" ,  /Ұ");						
						}
					}					
				}/*
				for(int i=arrVector.size()-1; i>=0; i-- ) {
					Element temp = arrVector.get(i);
					System.out.println(temp.getShape() + " layer: " + temp.getLayerNum()+
							" elemNum: " + temp.getElementNum() + " index: " + i + 
							" parentLayer: " + temp.getParentLayerNum() + 
							" parentDepth: " + temp.getParentLayerDepth());
				}
				System.out.println("");*/
				MainWindow.getInstance().getPanel().repaintAll();
				vectorToolBarRepaint();

				if (selectLabel != null) { // function copy cancel
					selectLabel.setForeground(Color.BLACK);
					isCopyStyle = false;
				}
			}			
		}
	}
	
	class SLayerDrawPanel extends JPanel {
		private static final long serialVersionUID = 2398159859489047426L;

		Element elem;
		int elemIndex;
		int elemCount;
		SLayerDrawPanel(Element e) {
			elem = e;
		}

		public void paintComponent(Graphics g) { //  drawVector ׸
			super.paintComponent(g); // panel paintComponent
			Graphics2D g2 = (Graphics2D)g;
			Graphics2D g2d = null;
			if (bimg == null || bimg.getWidth() != sDrawPanelWidth || bimg.getHeight() != sDrawPanelWidth) {
				bimg = (VolatileImage) createVolatileImage(
						Math.round(sDrawPanelWidth), 
						Math.round(sDrawPanelHeight));
			}
			g2d = bimg.createGraphics();
			if (antiMode) {
				g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
						RenderingHints.VALUE_ANTIALIAS_ON);
			}
			elemIndex = arrVector.indexOf(elem);	//-1
			elemCount = elem.getElementNum();
			//System.out.println(elem.getShape() + " " + elemIndex + " cou: " + elemCount);
			if (simpleDraw) {
				g2d.setBackground(Color.GRAY);
				g2d.clearRect(0, 0, 
						Math.round(sDrawPanelWidth), 
						Math.round(sDrawPanelHeight));
				for(int i=elemIndex-elemCount; i<elemIndex; i++) {
					if(i < 0) {
						System.out.println("Impossible");
						break;
					}
					if(arrVector.get(i).getToolName() != DrawToolConst.TEXT)
						arrVector.get(i).simpleDraw(g2d, sDrawPanelScaleValue);
				}
			} 
			else {
				//for(int i=elemIndex; i>elemIndex-elemCount; i--) {
				for(int i=elemIndex-elemCount; i<elemIndex; i++) {
					if(i < 0) {
						System.out.println("Impossible");
						break;
					}
					if(arrVector.get(i).getToolName() != DrawToolConst.TEXT)
						arrVector.get(i).smallDraw(g2d, sDrawPanelScaleValue);
				}
			}
			g2.drawImage(bimg, 0, 0, this);
			g2d.dispose();
			g2.dispose();
		}
	}
		
	class SDrawPanel extends JPanel {
		private static final long serialVersionUID = 2398159859489047426L;

		Element elem;

		SDrawPanel(Element e) {
			//super.setBorder(BorderFactory.createRaisedBevelBorder());
			elem = e;
		}

		public void paintComponent(Graphics g) { //  drawVector ׸
			super.paintComponent(g); // panel paintComponent
			Graphics2D g2 = (Graphics2D)g;
			Graphics2D g2d = null;
			if (bimg == null || bimg.getWidth() != sDrawPanelWidth || bimg.getHeight() != sDrawPanelWidth) {
				bimg = (VolatileImage) createVolatileImage(
						Math.round(sDrawPanelWidth), 
						Math.round(sDrawPanelHeight));
			}
			g2d = bimg.createGraphics();
			if (antiMode) {
				g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
						RenderingHints.VALUE_ANTIALIAS_ON);
			}
			if (simpleDraw) {
				g2d.setBackground(Color.GRAY);
				g2d.clearRect(0, 0, 
						Math.round(sDrawPanelWidth), 
						Math.round(sDrawPanelHeight));
				elem.simpleDraw(g2d, sDrawPanelScaleValue);
			} else {
				elem.smallDraw(g2d, sDrawPanelScaleValue);
			}
			g2.drawImage(bimg, 0, 0, this);
			g2d.dispose();
			g2.dispose();
		}
	}
	
	public void elementHide(boolean hide, String _compNum) {
		//System.out.println(arrVector.size()-1-compNum);
		int compNum = Integer.parseInt(_compNum);
		int arrVectorSize = arrVector.size()-1;
		int elemIndex = arrVectorSize-compNum;
		Element tempElement = arrVector.get(elemIndex);
		int elemCount = tempElement.getElementNum();
		if(tempElement.getToolName() != DrawToolConst.LAYER) {
			MainWindow.getInstance().getPanel().setHide(
					arrVector.get(elemIndex), 
					hide,
					elemIndex);
		}
		else {
			compNum++;
			for(int compIdx=compNum; compIdx<compNum+elemCount; compIdx++) {
				if(!isViewPanel) {
					JPanel tempPanel = ((JPanel)viewPanel.getComponent(compIdx));
					JButton tempButton = (JButton)tempPanel.getComponent(0);
					//tempButton.setIcon(null);
					tempButton.setEnabled(false);

					MainWindow.getInstance().getPanel().setHide(
							arrVector.get(arrVectorSize-compIdx), 
							hide,
							arrVectorSize-compIdx);	
				}
				else {
					JPanel tempPanel = ((JPanel)viewPanel.getComponent(compIdx));
					JButton tempButton = (JButton)tempPanel.getComponent(0);
					//tempButton.setIcon(viewIcon);
					tempButton.setEnabled(true);
					if(tempButton.getIcon() != null) {
						MainWindow.getInstance().getPanel().setHide(
								arrVector.get(arrVectorSize-compIdx), 
								hide,
								arrVectorSize-compIdx);	
					}
				}
			}/*
			elemIndex--;
			for(int elemIdx=elemIndex; elemIdx>elemIndex-elemCount; elemIdx--) {
				MainWindow.getInstance().getPanel().setHide(
						arrVector.get(elemIdx), 
						hide,
						elemIdx);	
			}*/
		}
	}
	
	private class ViewListener extends MouseAdapter {	
		public void mousePressed(MouseEvent e) {
			viewPanelClickFlag = true;
			JPanel tempPanel = (JPanel) e.getComponent();
			JButton tempButton = (JButton) tempPanel.getComponent(0);

			if(tempButton.isEnabled()) {
				if(tempButton.getIcon() != null) {
					tempButton.setIcon(null);
					isViewPanel = false;
					elementHide(true, tempButton.getName());
				}
				else {
					tempButton.setIcon(viewIcon);
					isViewPanel = true;
					elementHide(false, tempButton.getName());
				}
			}
		}
		
		public void mouseEntered(MouseEvent e) {
			if(viewPanelClickFlag) {
				JPanel tempPanel = (JPanel) e.getComponent();
				JButton tempButton = (JButton) tempPanel.getComponent(0);
				if(tempButton.isEnabled()) {
					if(isViewPanel) {
						if(tempButton.getIcon() == null) {
							tempButton.setIcon(viewIcon);
							elementHide(false, tempButton.getName());
						}
					}
					else {
						if(tempButton.getIcon() != null) {
							tempButton.setIcon(null);
							elementHide(true, tempButton.getName());
						}
					}
				}
			}
		}
		
		public void mouseReleased(MouseEvent e) {
			viewPanelClickFlag = false;			
		}
	}
	
	private class ViewButtonListener extends MouseAdapter {
		
		public void mousePressed(MouseEvent e) {
			viewPanelClickFlag = true;
			JButton tempButton = (JButton) e.getComponent();
			if(tempButton.isEnabled()) {
				if(tempButton.getIcon() != null) {
					tempButton.setIcon(null);
					isViewPanel = false;
					elementHide(true, tempButton.getName());
				}
				else {
					tempButton.setIcon(viewIcon);
					isViewPanel = true;
					elementHide(false, tempButton.getName());
				}
			}
		}
		
		public void mouseEntered(MouseEvent e) {
			if(viewPanelClickFlag) {
				JButton tempButton = (JButton) e.getComponent();
				if(tempButton.isEnabled()) {
					if(isViewPanel) {
						if(tempButton.getIcon() == null) {
							tempButton.setIcon(viewIcon);
							elementHide(false, tempButton.getName());
						}
					}
					else {
						if(tempButton.getIcon() != null) {
							tempButton.setIcon(null);
							elementHide(true, tempButton.getName());
						}
					}
				}
			}
		}
		
		public void mouseReleased(MouseEvent e) {
			viewPanelClickFlag = false;			
		}
	}
		
	private class MouseHandler extends MouseAdapter {
		public void mousePressed(MouseEvent e) {

		}

		public void mouseReleased(MouseEvent e) { // ư released
			//style 
			if (e.getButton() == 3 && e.getClickCount() == 2) {
				JLabel deleteLabel = null;
				String deleteText;
				int y = e.getY();
				funcPanel = (JPanel) e.getSource();
				int deleteNum = Integer.parseInt(funcPanel.getName());
				Element tempElement = arrVector.get(arrVector.size()-1-deleteNum);
				layoutCount = 0;
				if (tempElement.getTransformMode())
					layoutCount++;
				if (tempElement.getColorMode())
					layoutCount++;
				if (tempElement.getGradientMode())
					layoutCount++;
				if (tempElement.getPatternMode())
					layoutCount++;
				if (tempElement.getStrokeMode())
					layoutCount++;
				if (layoutCount > 0) {
					if (layoutCount == 1) {
						if (y >= 0 && y <= FUNC_INNERPANEL_HEIGHT*2) {
							deleteLabel = ((JLabel) funcPanel.getComponent(0));
							funcPanel.remove(0);
						}
					} else {
						if (y >= 0 && y <= FUNC_INNERPANEL_HEIGHT) {
							if (funcPanel.getComponentCount() > 0) {
								deleteLabel = ((JLabel) funcPanel.getComponent(0));
								funcPanel.remove(0);
							}
						} else if (y > FUNC_INNERPANEL_HEIGHT && 
								y <= FUNC_INNERPANEL_HEIGHT*2) {
							if (funcPanel.getComponentCount() > 1) {
								deleteLabel = ((JLabel) funcPanel.getComponent(1));
								funcPanel.remove(1);
							}
						} else if (y > FUNC_INNERPANEL_HEIGHT*2 && 
								y <= FUNC_INNERPANEL_HEIGHT*3) {
							if (funcPanel.getComponentCount() > 2) {
								deleteLabel = ((JLabel) funcPanel.getComponent(2));
								funcPanel.remove(2);
							}
						} else if (y > FUNC_INNERPANEL_HEIGHT*3 && 
								y <= FUNC_INNERPANEL_HEIGHT*4) {
							if (funcPanel.getComponentCount() > 3) {
								deleteLabel = ((JLabel) funcPanel.getComponent(3));
								funcPanel.remove(3);
							}
						}
					}
					deleteText = deleteLabel.getText();
					if (deleteText.equals("Transform")) {
						tempElement.setRotateMode(false);
						tempElement.setScaleMode(false);
					} else if (deleteText.equals("Color")) {
						tempElement.setColorMode(false);
					} else if (deleteText.equals("Gradient")) {
						tempElement.setGradientMode(false);
					} else if (deleteText.equals("Pattern")) {
						tempElement.setPatternMode(false);
					} else if (deleteText.equals("Stroke")) {
						tempElement.setStrokeMode(false);
					}
					layoutCount--;
					//realign Layout
					layerButton = (JButton) layerPanel.getComponent(deleteNum);
					if (layoutCount == 0) {
						defaultLabel = new JLabel("Nothing", SwingConstants.CENTER);
						defaultLabel.setBorder(BorderFactory.createRaisedBevelBorder());
						defaultLabel.setFont(font);
						funcPanel.add(defaultLabel);
						funcPanel.revalidate();
					} else {
						scroller = (JScrollPane) layerButton.getComponent(2);
						funcPanel.setPreferredSize(new Dimension(
								FUNC_SCROLLER_WIDTH-22,
								FUNC_INNERPANEL_HEIGHT * (layoutCount)));
						funcPanel.setLayout(new GridLayout(layoutCount, 1));
						funcPanel.revalidate();
						scroller.validate();
					}
					if(layerButton.getBackground() == Color.CYAN) {
						if (deleteText.equals("Color")) {
							MainWindow.getInstance().getPanel().setColorMode(false);
							WestToolBox.getInstance().setFillColorMode(false);
						} else if (deleteText.equals("Gradient")) {
							MainWindow.getInstance().getPanel().setGradientMode(false);
						} else if (deleteText.equals("Pattern")) {
							MainWindow.getInstance().getPanel().setPatternMode(false);
						} else if (deleteText.equals("Stroke")) {
							MainWindow.getInstance().getPanel().setStrokeMode(false);
							WestToolBox.getInstance().setStrokeColorMode(false);
						}
					}
					arrVector.set(arrVector.size()-1-deleteNum, tempElement);
					MainWindow.getInstance().getPanel().repaintAll();
				}
				if (selectLabel != null)
					selectLabel.setForeground(Color.BLACK);
				isCopyStyle = false;
			} else if (isCopyStyle) {
				destPanel = (JPanel) e.getSource();
				destName = destPanel.getName();
				if (funcName != destName) {
					funcNum = Integer.parseInt(funcName);
					destNum = Integer.parseInt(destName);
					element = arrVector.get(arrVector.size()-1-funcNum);
					destElement = arrVector.get(arrVector.size()-1-destNum);
					destLayoutCount = 0;
					if (destElement.getTransformMode())
						destLayoutCount++;
					if (destElement.getColorMode())
						destLayoutCount++;
					if (destElement.getGradientMode())
						destLayoutCount++;
					if (destElement.getPatternMode())
						destLayoutCount++;
					if (destElement.getStrokeMode())
						destLayoutCount++;

					if (destLayoutCount == 0) {
						destPanel.removeAll();
					}
					layerButton = (JButton) layerPanel.getComponent(
							Integer.parseInt(destName));
					if (selectText.equals("Transform")) {
						if (!destElement.getTransformMode()) {
							destElement.setRotateAndScale(
									element.getScaleX(), 
									element.getScaleY(), 
									element.getRotateAngle());
							editLabel = new JLabel(
									"Transform", SwingConstants.CENTER);
							editLabel.setBorder(
									BorderFactory.createRaisedBevelBorder());
							editLabel.setFont(font);
							destPanel.add(editLabel);
							destLayoutCount++;
						}
					} else if (selectText.equals("Color")) {
						if (!destElement.getColorMode()) {
							destElement.setFillColorFromSVG(
									element.getFillColor(), 
									element.getColorOpacity());
							colorLabel = new JLabel(
									"Color", SwingConstants.CENTER);
							colorLabel.setBorder(
									BorderFactory.createRaisedBevelBorder());
							colorLabel.setFont(font);
							destPanel.add(colorLabel);
							destLayoutCount++;
							if(layerButton.getBackground() == Color.CYAN) {
								MainWindow.getInstance().getPanel().setColorMode(true);
								WestToolBox.getInstance().setFillColor(
										true, element.getFillColor());
							}
						}
					} else if (selectText.equals("Gradient")) {
						if (!destElement.getGradientMode()) {
							gradList = new ArrayList<GradientTool>();
							tempGradList = element.getGradList();
							for (int i = 0; i < tempGradList.size(); i++) {
								gradList.add(new GradientTool(tempGradList.get(i)));
							}
							destElement.setGradient(gradList, 
									element.getGradOpacityPercent(), true);
							destElement.setGradVar(
									element.getGradScalePercent(),
									element.getGradAngle());
							gradLabel = new JLabel("Gradient",
									SwingConstants.CENTER);
							gradLabel.setBorder(BorderFactory
									.createRaisedBevelBorder());
							gradLabel.setFont(font);
							destPanel.add(gradLabel);
							destLayoutCount++;
							if(layerButton.getBackground() == Color.CYAN) {
								MainWindow.getInstance().getPanel().setGradientMode(true);
							}
						}
					} else if (selectText.equals("Pattern")) {
						if (!destElement.getPatternMode()) {
							destElement.setPatternImage(
									element.getPatternPath(), 
									Math.round(element.getPatternScalePercent()), 
									Math.round(element.getPatternOpacityPercent()), true);
							patternLabel = new JLabel("Pattern",
									SwingConstants.CENTER);
							patternLabel.setBorder(BorderFactory
									.createRaisedBevelBorder());
							patternLabel.setFont(font);
							destPanel.add(patternLabel);
							destLayoutCount++;
							if(layerButton.getBackground() == Color.CYAN) {
								MainWindow.getInstance().getPanel().setPatternMode(true);
							}
						}
					} else if (selectText.equals("Stroke")) {
						if (!destElement.getStrokeMode()) {
							int strokeFillMode = element.getStrokeFillMode();
							destElement.setStrokeFromSVG(
									element.getStrokeSize(), 
									element.getStrokeOpacity(), 
									element.getStrokePosition(), strokeFillMode);
							if (strokeFillMode == 0) {
								destElement.setStrokeColor(
										element.getStrokeColor());
								if(layerButton.getBackground() == Color.CYAN) {
									WestToolBox.getInstance().setStrokeColor(
											true, element.getStrokeColor());
								}
							} else if (strokeFillMode == 1) { // gradient
								strokeGradList = new ArrayList<GradientTool>();
								tempStrokeGradList = element.getStrokeGradList();
								for (int i = 0; i < tempStrokeGradList.size(); i++) {
									strokeGradList.add(new GradientTool(
											tempStrokeGradList.get(i)));
								}
								destElement.setStrokeGradient(strokeGradList);
								destElement.setStrokeGradScale(
										element.getStrokeGradScalePercent());
								destElement.setStrokeGradAngle(
										element.getStrokeGradAngle());
							} else if (strokeFillMode == 2) { // pattern
								destElement.setStrokePatternImage(
										element.getStrokePatternPath(),
										Math.round(element.getStrokePatternScalePercent()));
							}
							strokeLabel = new JLabel(
									"Stroke", SwingConstants.CENTER);
							strokeLabel.setBorder(
									BorderFactory.createRaisedBevelBorder());
							strokeLabel.setFont(font);
							destPanel.add(strokeLabel);
							destLayoutCount++;
							if(layerButton.getBackground() == Color.CYAN) {
								UpperToolBox.setStrokeSize(
										element.getStrokeSize());
								MainWindow.getInstance().getPanel().setStrokeMode(true);
							}
						}
					}
					// default
					if (destLayoutCount == 0) {
						destPanel.add(defaultLabel);
					} else {
						//layerButton = (JButton) layerPanel.getComponent(
						//		Integer.parseInt(destName));
						scroller = (JScrollPane) layerButton.getComponent(2);
						destPanel.setPreferredSize(new Dimension(
								FUNC_SCROLLER_WIDTH-22, 
								FUNC_INNERPANEL_HEIGHT * (destLayoutCount)));
						destPanel.setLayout(new GridLayout(destLayoutCount, 1));
						destPanel.revalidate();
						scroller.validate();
					}
					arrVector.set(arrVector.size()-1-destNum, destElement);
					MainWindow.getInstance().getPanel().repaintAll();
				}
				if (selectLabel != null)
					selectLabel.setForeground(Color.BLACK);
				isCopyStyle = false;
			} else if (e.getButton() == 1 && e.getClickCount() == 2) {
				int y = e.getY();
				funcPanel = (JPanel) e.getSource();
				int styleNum = Integer.parseInt(funcPanel.getName());
				Element tempElement = arrVector.get(arrVector.size()-1-styleNum);
				layoutCount = 0;
				if (tempElement.getTransformMode())
					layoutCount++;
				if (tempElement.getColorMode())
					layoutCount++;
				if (tempElement.getGradientMode())
					layoutCount++;
				if (tempElement.getPatternMode())
					layoutCount++;
				if (tempElement.getStrokeMode())
					layoutCount++;
				if (selectLabel != null)
					selectLabel.setForeground(Color.BLACK);
				if (!((JLabel) funcPanel.getComponent(0)).getText().equals(
						"Nothing") && layoutCount>0) {
					if (layoutCount == 1) {
						if (y >= 0 && y <= FUNC_INNERPANEL_HEIGHT*2)
							selectLabel = ((JLabel) funcPanel.getComponent(0));
					} else {
						if (y >= 0 && y <= FUNC_INNERPANEL_HEIGHT) {
							if (funcPanel.getComponentCount() > 0)
								selectLabel = ((JLabel) funcPanel.getComponent(0));
						} else if (y > FUNC_INNERPANEL_HEIGHT && 
								y <= FUNC_INNERPANEL_HEIGHT*2) {
							if (funcPanel.getComponentCount() > 1)
								selectLabel = ((JLabel) funcPanel.getComponent(1));
						} else if (y > FUNC_INNERPANEL_HEIGHT*2 && 
								y <= FUNC_INNERPANEL_HEIGHT*3) {
							if (funcPanel.getComponentCount() > 2)
								selectLabel = ((JLabel) funcPanel.getComponent(2));
						} else if (y > FUNC_INNERPANEL_HEIGHT*3 && 
								y <= FUNC_INNERPANEL_HEIGHT*4) {
							if (funcPanel.getComponentCount() > 3)
								selectLabel = ((JLabel) funcPanel.getComponent(3));
						}
					}
					funcName = funcPanel.getName();
					selectText = selectLabel.getText();
					selectLabel.setForeground(Color.CYAN);
					isCopyStyle = true;
				}
			}
		}
	}
	
	class FuncScrollAdjust implements AdjustmentListener {
		public void adjustmentValueChanged(AdjustmentEvent evt) {
            Adjustable source = evt.getAdjustable();
            source.setUnitIncrement(FUNC_INNERPANEL_HEIGHT);
		}
	}
	
	
	public int getSDrawPanelHeight() {
		return sDrawPanelHeight;
	}

	public int getSDrawPanelWidth() {
		return sDrawPanelWidth;
	}
	
	public void setBtnCompIndex(int btnCompIndex) {
		this.btnCompIndex = btnCompIndex;
	}
}
