package com.sharppaint.printpreview;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.text.NumberFormatter;

import com.sharppaint.Constants;
import com.sharppaint.MainWindow;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.*;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.awt.print.PageFormat;
import java.awt.print.Paper;

public class PreviewDialog {	// implements ActionLis
	/**
	 * 
	 */
	private static final long serialVersionUID = 8406237362944735198L;
	
	private static PreviewDialog previewDialog = null;
	
	private JDialog previewJDialog;
	
	private JPanel westPanel, westInPanel, centerPanel, eastPanel;
	
	private JButton okButton, cancelButton;
	
	private JButton verticalButton, horizontalButton;
	
    private Border loweredetched;
    
	private Font font;
	
    private NumberFormat numberFormat;
    
    private NumberFormatter formatter;
    
	private JFormattedTextField topT, leftT, bottomT, rightT, scaleT, widthT, heightT;
	
	private JPanel mediaP, positionP, scalePrintP;
	
	private JLabel topL, leftL, rightL, bottomL, scaleL, widthL, heightL;
	
	//private JLabel paperL, paperDirectionL;
	
	private JLabel unitL;
	
	private JSlider scaleS;
	
	private JSlider topSlider, bottomSlider, leftSlider, rightSlider;
	
	private JComboBox comboBoxWidth, comboBoxHeight;
	
	private JComboBox comboBoxSpace, comboBoxLeft;
	
	private JComboBox comboBoxPaper;
	
	private String cBoxSelection, prevCommand, prevMarginCommand;
	
	private String[] paperSize = {
			" A4", " A5", " B5", 			
			" Letter", " Legal", " Envelope",
			" 4  6", " 5  7" };
	//"", 
	
	private String[] listSize = {"pixels", "inches", "cm"};
	
	private float pixelPerInch;
	
	private DecimalFormat df;

	private float canvasWidth, canvasHeight;
	
	private float topV, leftV, bottomV, rightV, scaleV, scaleCanvasWidth, scaleCanvasHeight;
	
	private float scale;
	
	private float previewScale;
	
	private float tempWidth, tempHeight, scaleTop, scaleLeft;
	
	private String paperSelection;
			
	private PreviewPanel previewPanel;
		
	private Paper paper;
	
	private PageFormat pf;
	
	private static final int TEXTFIELDSIZE = 6;
	
	private static final int TEXTFIELDSIZE_SPACE = 5;
	
	private ImageIcon verticalIcon;
	
	private ImageIcon horizontalIcon;
	
	private Insets inset;
	
	public static final float A4_WESTPANEL_WIDTH = 210.0f;
	public static final float A4_WESTPANEL_HEIGHT = 297.0f;
	public static final float LETTER_WESTPANEL_WIDTH = 216.0f;
	public static final float LETTER_WESTPANEL_HEIGHT = 279.0f;
	public static final float LEGAL_WESTPANEL_WIDTH = 180.3f;
	public static final float LEGAL_WESTPANEL_HEIGHT = 297.0f;
	public static final float ENVELOPE_WESTPANEL_WIDTH = 128.8682f;
	public static final float ENVELOPE_WESTPANEL_HEIGHT = 297.0f;
	public static final float _4X6_WESTPANEL_WIDTH = 198.0f;
	public static final float _4X6_WESTPANEL_HEIGHT = 297.0f;
	public static final float _5X7_WESTPANEL_WIDTH = 212.143f;
	public static final float _5X7_WESTPANEL_HEIGHT = 297.0f;
	
	public static final float A4_previewScale = 0.35277778f;
	
	public static final float A4_WIDTH = 595.2756f;
	public static final float A4_HEIGHT = 841.8898f;
	public static final float A5_WIDTH = 419.5276f;
	public static final float A5_HEIGHT = 595.2756f;
	public static final float B5_WIDTH = 515.9055f;
	public static final float B5_HEIGHT = 728.5039f;
	public static final float LETTER_WIDTH = 612.0f;
	public static final float LETTER_HEIGHT = 792.0f;
	public static final float LEGAL_WIDTH = 612.0f;
	public static final float LEGAL_HEIGHT = 1008.0f;
	public static final float ENVELOPE_WIDTH = 296.7874f;
	public static final float ENVELOPE_HEIGHT = 684.0f;
	public static final float _4X6_WIDTH = 288.0f;
	public static final float _4X6_HEIGHT = 432.0f;
	public static final float _5X7_WIDTH = 360.0f;
	public static final float _5X7_HEIGHT = 504.0f;
	
	/* /
	 * pf.setOrientation(PageFormat.LANDSCAPE); 
	 * pf.setOrientation(PageFormat.PORTRAIT);
	 * if(pf.getOrientation() == PageFormat.PORTRAIT) {
	            westPanel.setPreferredSize(
	            		new Dimension(
	            				Math.round(A4_WESTPANEL_WIDTH), 
	            				Math.round(A4_WESTPANEL_HEIGHT)) );
	            previewScale = A4_WESTPANEL_WIDTH / (float)pf.getWidth();
	        }
	        else {	//paper horizontal
	            westPanel.setPreferredSize(
	            		new Dimension(
	            				Math.round(A4_WESTPANEL_WIDTH), 
	            				Math.round(A4_WESTPANEL_WIDTH)) );
	            previewScale = A4_WESTPANEL_WIDTH / (float)pf.getHeight();
	        }
	 */
	
	/*
	 * ũ
	 *
    
	 */
	
	/** 
     * previewPanel.setSpace(
    		(int)Math.round(pf.getImageableWidth() *previewScale),
    		(int)Math.round(pf.getImageableHeight() *previewScale)
    );
    */
	
    
    
    /***
     * 
     *       ּ  
     *  dialog ٷ ~!
     * ׷  ؾ  
     * 1.   
     * 2., Ⱦ  
     * 3.
     * 
     * 
     */
	
	public static PreviewDialog getInstance() {
		if (previewDialog == null)
			previewDialog = new PreviewDialog();
		return previewDialog;
	}
	
	private PreviewDialog() {
		previewJDialog = new JDialog(MainWindow.getInstance(), "Preview", false);
        okButton = new JButton("Print");
        cancelButton = new JButton("Cancel"); 
        westPanel = new JPanel();
        westInPanel = new JPanel();
        centerPanel = new JPanel();
        eastPanel = new JPanel(); 
        centerPanel.setPreferredSize(new Dimension(255, 385));
        centerPanel.setLayout(
        		new BoxLayout(centerPanel, BoxLayout.Y_AXIS));
        eastPanel.setPreferredSize(new Dimension(95, 390));
        
        okButton.setPreferredSize(new Dimension(83, 20));
        okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				okButton_actionPerformed();
			}
		});
        cancelButton.setPreferredSize(new Dimension(83, 20));
        cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cancelButton_actionPerformed();
			}
		});       
        
        initPageSetup();        

        loweredetched = BorderFactory.createEtchedBorder(
        		EtchedBorder.LOWERED);
        
		westInPanel.setLayout(null);
        westInPanel.setBackground(Color.WHITE);              


        previewPanel = PreviewPanel.getInstance();
        westInPanel.add(previewPanel);
        //westPanel.setLayout(new BorderLayout());
        
        westPanel.add(westInPanel);
        westPanel.setBorder(
				BorderFactory.createTitledBorder(loweredetched, " Preview "));		
        westPanel.setPreferredSize(new Dimension(320, 380));
        
        eastPanel.add(Box.createRigidArea(new Dimension(90, 7)));
        eastPanel.add(okButton);
        eastPanel.add(Box.createRigidArea(new Dimension(90, 5)));
        eastPanel.add(cancelButton);
        
        previewJDialog.getContentPane().setLayout(new FlowLayout());
        previewJDialog.getContentPane().add(westPanel);
        previewJDialog.getContentPane().add(centerPanel);
        previewJDialog.getContentPane().add(eastPanel);
        

		
		
		df = new DecimalFormat("#.###");
        font = new Font("arial",Font.BOLD,11);
        numberFormat = java.text.NumberFormat.getIntegerInstance();
        formatter = new NumberFormatter(numberFormat);
        formatter.setMinimum(new Float(1));
        formatter.setMaximum(new Float(2000));
		paper = new Paper();
        makeCenterGUI();
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		//System.out.println(Math.round(scaleLeft) +" " + Math.round(scaleTop));
		previewJDialog.setLocation(screenSize.width/3, screenSize.height/3);
		previewJDialog.setResizable(false);     
	}
	
    private void makeCenterGUI() {
		centerPanel.removeAll();
		mediaP = new JPanel();
		positionP = new JPanel();
		scalePrintP = new JPanel();
		mediaP.setBorder(
				BorderFactory.createTitledBorder(loweredetched, " Media "));
		positionP.setBorder(
				BorderFactory.createTitledBorder(loweredetched, " Position "));
		scalePrintP.setBorder(
				BorderFactory.createTitledBorder(loweredetched, " Scaled Print Size "));			
		mediaP.setPreferredSize(new Dimension(200, 80));
		positionP.setPreferredSize(new Dimension(200, 205));
		scalePrintP.setPreferredSize(new Dimension(200, 130));
        
		//paperL = new JLabel("Size: ");
		comboBoxPaper = new JComboBox(paperSize);
		//paperDirectionL = new JLabel("Direction: ");
		
		verticalIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "vertical_paper.gif"));
		horizontalIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "horizontal_paper.gif"));
		verticalButton = new JButton(verticalIcon);
		horizontalButton = new JButton(horizontalIcon);
		inset = new java.awt.Insets(0, 0, 0, 0);
		verticalButton.setMargin(inset);
		horizontalButton.setMargin(inset);
		
		verticalButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				verticalButton_actionPerformed(e);
			}
		});
		horizontalButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				horizontalButton_actionPerformed(e);
			}
		});
		
		comboBoxPaper.setBorder(BorderFactory.createEtchedBorder());
		comboBoxPaper.setPreferredSize(new Dimension(115, 22));
		comboBoxPaper.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				comboBoxPaper_actionPerformed(e);
			}
		});
		
		scaleS = new JSlider(1, 500, 100); 	
		scaleS.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				scaleS_stateChanged(e);
			}
		});
		scaleS.setPreferredSize(new Dimension(80, 18));
		
		topSlider = new JSlider(1, 200, 72); 	
		topSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				topSlider_stateChanged(e);
			}
		});
		topSlider.setPreferredSize(new Dimension(80, 18));
		
		bottomSlider = new JSlider(1, 200, 72); 	
		bottomSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				bottomSlider_stateChanged(e);
			}
		});
		bottomSlider.setPreferredSize(new Dimension(80, 18));
		leftSlider = new JSlider(1, 200, 72); 	
		leftSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				leftSlider_stateChanged(e);
			}
		});
		leftSlider.setPreferredSize(new Dimension(80, 18));
		rightSlider = new JSlider(1, 200, 72); 	
		rightSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				rightSlider_stateChanged(e);
			}
		});
		rightSlider.setPreferredSize(new Dimension(80, 18));
		
		topT = new JFormattedTextField(formatter);
		topT.setColumns(TEXTFIELDSIZE_SPACE); //get some space
		topT.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				topT_propertyChange(e);				
			}
        });
		leftT = new JFormattedTextField(formatter);
		leftT.setColumns(TEXTFIELDSIZE_SPACE);
		leftT.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				leftT_propertyChange(e);				
			}
        });
		rightT = new JFormattedTextField(formatter);
		rightT.setColumns(TEXTFIELDSIZE_SPACE);
		rightT.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				rightT_propertyChange(e);				
			}
        });
		bottomT = new JFormattedTextField(formatter);
		bottomT.setColumns(TEXTFIELDSIZE_SPACE);
		bottomT.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				bottomT_propertyChange(e);				
			}
        });
		scaleT = new JFormattedTextField(formatter);
		scaleT.setColumns(TEXTFIELDSIZE);
		scaleT.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				scaleT_propertyChange(e);				
			}
        });
		widthT = new JFormattedTextField(formatter);
		widthT.setColumns(TEXTFIELDSIZE);
		widthT.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				widthT_propertyChange(e);				
			}
        });
		heightT = new JFormattedTextField(formatter);
		heightT.setColumns(TEXTFIELDSIZE); 
		heightT.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				heightT_propertyChange(e);				
			}
        });		
		topT.setText(Float.toString(topV));
		leftT.setText(Float.toString(leftV));
		rightT.setText(Float.toString(rightV));
		bottomT.setText(Float.toString(bottomV));
		scaleT.setText("100");
		topL = new JLabel("          Top:", SwingConstants.RIGHT);
		leftL = new JLabel("         Left:", SwingConstants.RIGHT);
		rightL = new JLabel("        Right:", SwingConstants.RIGHT);
		bottomL = new JLabel("     Bottom:", SwingConstants.RIGHT);
        scaleL = new JLabel("  Scale:", SwingConstants.RIGHT);
        heightL = new JLabel("  Height:", SwingConstants.RIGHT);
        widthL = new JLabel("  Width:", SwingConstants.RIGHT);
        unitL = new JLabel("     Unit:", SwingConstants.RIGHT);
        topL.setFont(font);
        leftL.setFont(font);    
		rightL.setFont(font);  
		bottomL.setFont(font);  
        widthL.setFont(font);
        heightL.setFont(font);
        scaleL.setFont(font);
        unitL.setFont(font);        
        
        prevCommand="pixels";
        prevMarginCommand="pixels";
        pixelPerInch = 72.0f;
    	comboBoxWidth = new JComboBox(listSize);
    	comboBoxHeight = new JComboBox(listSize); 
    	comboBoxSpace = new JComboBox(listSize);
    	comboBoxLeft = new JComboBox(listSize); 
		comboBoxWidth.setBorder(BorderFactory.createEtchedBorder());
		comboBoxWidth.setPreferredSize(new Dimension(79, 22));
		comboBoxHeight.setBorder(BorderFactory.createEtchedBorder());
		comboBoxHeight.setPreferredSize(new Dimension(79, 22));
		comboBoxSpace.setBorder(BorderFactory.createEtchedBorder());
		comboBoxSpace.setPreferredSize(new Dimension(85, 22));
		comboBoxLeft.setBorder(BorderFactory.createEtchedBorder());
		comboBoxLeft.setPreferredSize(new Dimension(79, 22));
		comboBoxWidth.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				comboBoxWidth_actionPerformed(e);
			}
		});
		comboBoxHeight.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				comboBoxHeight_actionPerformed(e);
			}
		});
		comboBoxSpace.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				comboBoxSpace_actionPerformed(e);
			}
		});
		//mediaP.add(paperL);
		mediaP.add(comboBoxPaper);
		//mediaP.add(paperDirectionL);
		mediaP.add(verticalButton);
		mediaP.add(horizontalButton);
        positionP.add(topL);
        positionP.add(topT);
        positionP.add(topSlider);
        //positionP.add(new JLabel("                    "));
        positionP.add(leftL);
        positionP.add(leftT);
        positionP.add(leftSlider);
        positionP.add(rightL);
        positionP.add(rightT);
        positionP.add(rightSlider);
        positionP.add(bottomL);
        positionP.add(bottomT);
        positionP.add(bottomSlider);
        positionP.add(unitL);
        positionP.add(comboBoxSpace);
        positionP.add(new JLabel("            "));
        scalePrintP.add(scaleL);
        scalePrintP.add(scaleT);
        scalePrintP.add(scaleS);
        scalePrintP.add(widthL);
        scalePrintP.add(widthT);
        scalePrintP.add(comboBoxWidth);
        scalePrintP.add(heightL);
        scalePrintP.add(heightT);
        scalePrintP.add(comboBoxHeight);

		centerPanel.add(Box.createRigidArea(new Dimension(0, 3)));
		centerPanel.add(mediaP);
		centerPanel.add(Box.createRigidArea(new Dimension(0, 5)));
		centerPanel.add(positionP);
		centerPanel.add(Box.createRigidArea(new Dimension(0, 5)));
		centerPanel.add(scalePrintP);
		//centerPanel.add(Box.createRigidArea(new Dimension(0, 3)));
        keyCheck();
	}
    
	@SuppressWarnings("unchecked")
	public void setCanvasSize(Dimension canvasSize) {
		canvasWidth = (float)canvasSize.getWidth();
        canvasHeight = (float)canvasSize.getHeight();
        scaleCanvasWidth = canvasWidth;
		scaleCanvasHeight = canvasHeight;
		/****
		 * preview panel 
		 * 
		 */
        previewPanel = PreviewPanel.getInstance();
        previewPanel.setCanvasSize(canvasWidth, canvasHeight);
        previewPanel.setVector(
        		MainWindow.getInstance().getPanel().getVector());
        previewPanel.initBound(
        		Math.round(scaleLeft), 
        		Math.round(scaleTop), 
        		previewScale);
        previewPanel.setSpace(
        		(int)Math.round(pf.getImageableWidth() *previewScale),
        		(int)Math.round(pf.getImageableHeight() *previewScale)
        );
        //previewPanel.revalidate();
        if(pf.getOrientation() == PageFormat.PORTRAIT) {
        	westInPanel.setPreferredSize(new Dimension(
        			Math.round(A4_WESTPANEL_WIDTH), 
        			Math.round(A4_WESTPANEL_HEIGHT)));
        }
        else {      	
	    	westInPanel.setPreferredSize(new Dimension(
	    			Math.round(A4_WESTPANEL_HEIGHT), 
	    			Math.round(A4_WESTPANEL_WIDTH)));
        }
        //westPanel.revalidate();
		previewJDialog.pack();		
		previewJDialog.setVisible(true);
		widthT.setText(Float.toString(scaleCanvasWidth));
		heightT.setText(Float.toString(scaleCanvasHeight));
	}

	public void initPageSetup() {
		pf = new PageFormat();        
        pf.setOrientation(PageFormat.PORTRAIT);
        //pf.setOrientation(PageFormat.LANDSCAPE);        
        
        paper = new Paper();
        paper.setSize(A4_WIDTH, A4_HEIGHT);
        paper.setImageableArea(72.0, 72.0, A4_WIDTH-144, A4_HEIGHT-144);
        pf.setPaper(paper);
        //System.out.println("w:" + pf.getWidth() + " h:" + pf.getHeight() + " x" + pf.getImageableX() + " y" 
        //		+ pf.getImageableY() + " width" + pf.getImageableWidth() +  " height" + pf.getImageableHeight()); 
        
        /*
        topV = (float)pf.getImageableY();
    	leftV = (float)pf.getImageableX();
    	scaleTop = topV*previewScale;
    	scaleLeft = leftV*previewScale;*/
        paperSelection = " A4";
    	topV = 72.0f;
    	leftV = 72.0f;
    	rightV = 72.0f;
    	bottomV = 72.0f;
    	scaleTop = topV*A4_previewScale;
    	scaleLeft = leftV*A4_previewScale;
    	//scaleRight = rightV*A4_previewScale;
    	//scaleBottom = bottomV*A4_previewScale;
        previewScale = A4_previewScale;
	}
	/*
    public PageFormat getPageFormat() {
		return pf;
	}*/
    
    private void comboBoxWidth_actionPerformed(ActionEvent e) {
		JComboBox cb = (JComboBox)e.getSource();
		cBoxSelection = (String)cb.getSelectedItem();		
		tempWidth = Float.parseFloat(widthT.getText());
		tempHeight = Float.parseFloat(heightT.getText());
        
		if(cBoxSelection.equals("pixels")) {
			if(prevCommand.equals("inches")) {
				widthT.setText(df.format(tempWidth * pixelPerInch));
				heightT.setText(df.format(tempHeight * pixelPerInch));
			}
			else if(prevCommand.equals("cm")) {
				widthT.setText(df.format(tempWidth * pixelPerInch / 2.54f));
				heightT.setText(df.format(tempHeight * pixelPerInch / 2.54f));
			}
			comboBoxHeight.setSelectedItem("pixels");
			prevCommand = "pixels";
		}
		else if(cBoxSelection.equals("inches")) {
			if(prevCommand.equals("pixels")) {
				widthT.setText(df.format(tempWidth / pixelPerInch));
				heightT.setText(df.format(tempHeight / pixelPerInch));
			}
			else if(prevCommand.equals("cm")) {
				widthT.setText(df.format(tempWidth / 2.54f));
				heightT.setText(df.format(tempHeight / 2.54f));
			}
			comboBoxHeight.setSelectedItem("inches");
			prevCommand = "inches";
		}
		else if(cBoxSelection.equals("cm")) {
			if(prevCommand.equals("pixels")) {
				widthT.setText(df.format(tempWidth / pixelPerInch * 2.54f));
				heightT.setText(df.format(tempHeight / pixelPerInch * 2.54f));
			}
			else if(prevCommand.equals("inches")) {
				widthT.setText(df.format(tempWidth * 2.54f));
				heightT.setText(df.format(tempHeight * 2.54f));
			}
			comboBoxHeight.setSelectedItem("cm");
			prevCommand = "cm";
		}
	}
    private void comboBoxHeight_actionPerformed(ActionEvent e) {
		JComboBox cb = (JComboBox)e.getSource();
		cBoxSelection = (String)cb.getSelectedItem();
		if(cBoxSelection.equals("pixels")) {
			comboBoxWidth.setSelectedItem("pixels");
		}
		else if(cBoxSelection.equals("inches")) {
			comboBoxWidth.setSelectedItem("inches");
		}
		else if(cBoxSelection.equals("cm")) {
			comboBoxWidth.setSelectedItem("cm");
		}
	}
    private void paperSetup() {
    	if(paperSelection == " 4  6") {
			if(pf.getOrientation() == PageFormat.PORTRAIT) {
				westInPanel.setPreferredSize(new Dimension(
		    			Math.round(_4X6_WESTPANEL_WIDTH), 
		    			Math.round(_4X6_WESTPANEL_HEIGHT)));
		    }
		    else {      	
		    	westInPanel.setPreferredSize(new Dimension(
		    			Math.round(_4X6_WESTPANEL_HEIGHT), 
		    			Math.round(_4X6_WESTPANEL_WIDTH)));
		    }
	    	previewScale = _4X6_WESTPANEL_WIDTH / _4X6_WIDTH;
	        paper.setSize(_4X6_WIDTH, _4X6_HEIGHT);
	        paper.setImageableArea(leftV, topV, _4X6_WIDTH-leftV-rightV, _4X6_HEIGHT-topV-bottomV);
	        pf.setPaper(paper);
		}
		else if(paperSelection == " 5  7") {
			if(pf.getOrientation() == PageFormat.PORTRAIT) {
				westInPanel.setPreferredSize(new Dimension(
		    			Math.round(_5X7_WESTPANEL_WIDTH), 
		    			Math.round(_5X7_WESTPANEL_HEIGHT)));
		    }
		    else {      	
		    	westInPanel.setPreferredSize(new Dimension(
		    			Math.round(_5X7_WESTPANEL_HEIGHT), 
		    			Math.round(_5X7_WESTPANEL_WIDTH)));
		    }
	    	previewScale = _5X7_WESTPANEL_WIDTH / _5X7_WIDTH;
	        paper.setSize(_5X7_WIDTH, _5X7_HEIGHT);
	        paper.setImageableArea(leftV, topV, _5X7_WIDTH-leftV-rightV, _5X7_HEIGHT-topV-bottomV);
	        pf.setPaper(paper);

		}
		else if(paperSelection == " Letter") {
			if(pf.getOrientation() == PageFormat.PORTRAIT) {
				westInPanel.setPreferredSize(new Dimension(
		    			Math.round(LETTER_WESTPANEL_WIDTH), 
		    			Math.round(LETTER_WESTPANEL_HEIGHT)));
		    }
		    else {      	
		    	westInPanel.setPreferredSize(new Dimension(
		    			Math.round(LETTER_WESTPANEL_HEIGHT), 
		    			Math.round(LETTER_WESTPANEL_WIDTH)));
		    }
	    	previewScale = LETTER_WESTPANEL_WIDTH / LETTER_WIDTH;
	        paper.setSize(LETTER_WIDTH, LETTER_HEIGHT);
	        paper.setImageableArea(leftV, topV, LETTER_WIDTH-leftV-rightV, LETTER_HEIGHT-topV-bottomV);
	        pf.setPaper(paper);	
		}
		else if(paperSelection == " Legal") {
			if(pf.getOrientation() == PageFormat.PORTRAIT) {
				westInPanel.setPreferredSize(new Dimension(
		    			Math.round(LEGAL_WESTPANEL_WIDTH), 
		    			Math.round(LEGAL_WESTPANEL_HEIGHT)));
		    }
		    else {      	
		    	westInPanel.setPreferredSize(new Dimension(
		    			Math.round(LEGAL_WESTPANEL_HEIGHT), 
		    			Math.round(LEGAL_WESTPANEL_WIDTH)));
		    }
	    	previewScale = LEGAL_WESTPANEL_WIDTH / LEGAL_WIDTH;
	        paper.setSize(LEGAL_WIDTH, LEGAL_HEIGHT);
	        paper.setImageableArea(leftV, topV, LEGAL_WIDTH-leftV-rightV, LEGAL_HEIGHT-topV-bottomV);
	        pf.setPaper(paper);
		}
		else if(paperSelection == " Envelope") {
			if(pf.getOrientation() == PageFormat.PORTRAIT) {
		    	westInPanel.setPreferredSize(new Dimension(
		    			Math.round(ENVELOPE_WESTPANEL_WIDTH), 
		    			Math.round(ENVELOPE_WESTPANEL_HEIGHT)));
		    }
		    else {      	
		    	westInPanel.setPreferredSize(new Dimension(
		    			Math.round(ENVELOPE_WESTPANEL_HEIGHT), 
		    			Math.round(ENVELOPE_WESTPANEL_WIDTH)));
		    }
	    	previewScale = ENVELOPE_WESTPANEL_WIDTH / ENVELOPE_WIDTH;
	        paper.setSize(ENVELOPE_WIDTH, ENVELOPE_HEIGHT);
	        paper.setImageableArea(leftV, topV, ENVELOPE_WIDTH-leftV-rightV, ENVELOPE_HEIGHT-topV-bottomV);
	        pf.setPaper(paper);
		}
		else if(paperSelection == " A4") {
			if(pf.getOrientation() == PageFormat.PORTRAIT) {
				westInPanel.setPreferredSize(new Dimension(
		    			Math.round(A4_WESTPANEL_WIDTH), 
		    			Math.round(A4_WESTPANEL_HEIGHT)));
		    }
		    else {      	
		    	westInPanel.setPreferredSize(new Dimension(
		    			Math.round(A4_WESTPANEL_HEIGHT), 
		    			Math.round(A4_WESTPANEL_WIDTH)));
		    }
	    	previewScale = A4_WESTPANEL_WIDTH / A4_WIDTH;
	        paper.setSize(A4_WIDTH, A4_HEIGHT);
	        paper.setImageableArea(leftV, topV, A4_WIDTH-leftV-rightV, A4_HEIGHT-topV-bottomV);
	        pf.setPaper(paper);
		}
		else if(paperSelection == " A5") {
			if(pf.getOrientation() == PageFormat.PORTRAIT) {
				westInPanel.setPreferredSize(new Dimension(
		    			Math.round(A4_WESTPANEL_WIDTH), 
		    			Math.round(A4_WESTPANEL_HEIGHT)));
		    }
		    else {      	
		    	westInPanel.setPreferredSize(new Dimension(
		    			Math.round(A4_WESTPANEL_HEIGHT), 
		    			Math.round(A4_WESTPANEL_WIDTH)));
		    }
	    	previewScale = A4_WESTPANEL_WIDTH / A5_WIDTH;
	        paper.setSize(A5_WIDTH, A5_HEIGHT);
	        paper.setImageableArea(leftV, topV, A5_WIDTH-leftV-rightV, A5_HEIGHT-topV-bottomV);
	        pf.setPaper(paper);
		}
		else if(paperSelection == " B5") {
			if(pf.getOrientation() == PageFormat.PORTRAIT) {
				westInPanel.setPreferredSize(new Dimension(
		    			Math.round(A4_WESTPANEL_WIDTH), 
		    			Math.round(A4_WESTPANEL_HEIGHT)));
		    }
		    else {      	
		    	westInPanel.setPreferredSize(new Dimension(
		    			Math.round(A4_WESTPANEL_HEIGHT), 
		    			Math.round(A4_WESTPANEL_WIDTH)));
		    }
	    	previewScale = A4_WESTPANEL_WIDTH / B5_WIDTH;
	        paper.setSize(B5_WIDTH, B5_HEIGHT);
	        paper.setImageableArea(leftV, topV, B5_WIDTH-leftV-rightV, B5_HEIGHT-topV-bottomV);
	        pf.setPaper(paper);
		}
    }
    private void verticalButton_actionPerformed(ActionEvent e) {	   	 
	   	pf.setOrientation(PageFormat.PORTRAIT);
	   	paperSetup();
        previewPanel.setSpace(
        		(int)Math.round(pf.getImageableWidth() *previewScale),
        		(int)Math.round(pf.getImageableHeight() *previewScale)
        );
		westInPanel.revalidate();
		previewJDialog.pack();
    }
    private void horizontalButton_actionPerformed(ActionEvent e) {
    	pf.setOrientation(PageFormat.LANDSCAPE); 
	   	paperSetup();
        previewPanel.setSpace(
        		(int)Math.round(pf.getImageableWidth() *previewScale),
        		(int)Math.round(pf.getImageableHeight() *previewScale)
        );
		westInPanel.revalidate();	
		previewJDialog.pack();
    }
	public void comboBoxPaper_actionPerformed(ActionEvent e) {
		JComboBox cb = (JComboBox)e.getSource();
		paperSelection = (String)cb.getSelectedItem();
	   	paperSetup();				
        //System.out.println("w:" + pf.getWidth() + " h:" + pf.getHeight() + " x" + pf.getImageableX() + " y" 
       // 		+ pf.getImageableY() + " width" + pf.getImageableWidth() +  " height" + pf.getImageableHeight());
		previewPanel.setLocation(
				Math.round(leftV*previewScale), Math.round(topV*previewScale));
        
    	scaleTop = topV*previewScale;
    	scaleLeft = leftV*previewScale;
        previewPanel.initBound(
        		Math.round(scaleLeft), 
        		Math.round(scaleTop), 
        		previewScale);
        previewPanel.setSpace(
        		(int)Math.round(pf.getImageableWidth() *previewScale),
        		(int)Math.round(pf.getImageableHeight() *previewScale)
        );
        previewPanel.setScaleSize(previewScale);
	    //previewPanel.setScalePrint(scaleV/100.0f);
		westPanel.revalidate();
	    //previewPanel.validate();
	}
    private void comboBoxSpace_actionPerformed(ActionEvent e) {
		JComboBox cb = (JComboBox)e.getSource();
		cBoxSelection = (String)cb.getSelectedItem();		
		float tempTop = Float.parseFloat(topT.getText());
		float tempLeft = Float.parseFloat(leftT.getText());
		float tempRight = Float.parseFloat(rightT.getText());
		float tempBottom = Float.parseFloat(bottomT.getText());
        
		if(cBoxSelection.equals("pixels")) {
			if(prevMarginCommand.equals("inches")) {
				topT.setText(df.format(tempTop * pixelPerInch));
				leftT.setText(df.format(tempLeft * pixelPerInch));
				rightT.setText(df.format(tempRight * pixelPerInch));
				bottomT.setText(df.format(tempBottom * pixelPerInch));
			}
			else if(prevMarginCommand.equals("cm")) {
				topT.setText(df.format(tempTop * pixelPerInch / 2.54f));
				leftT.setText(df.format(tempLeft * pixelPerInch / 2.54f));
				rightT.setText(df.format(tempRight * pixelPerInch / 2.54f));
				bottomT.setText(df.format(tempBottom * pixelPerInch / 2.54f));
			}
			//comboBoxLeft.setSelectedItem("pixels");
			prevMarginCommand = "pixels";
		}
		else if(cBoxSelection.equals("inches")) {
			if(prevMarginCommand.equals("pixels")) {
				topT.setText(df.format(tempTop / pixelPerInch));
				leftT.setText(df.format(tempLeft / pixelPerInch));
				rightT.setText(df.format(tempRight / pixelPerInch));
				bottomT.setText(df.format(tempBottom / pixelPerInch));
			}
			else if(prevMarginCommand.equals("cm")) {
				topT.setText(df.format(tempTop / 2.54f));
				leftT.setText(df.format(tempLeft / 2.54f));
				rightT.setText(df.format(tempRight / 2.54f));
				bottomT.setText(df.format(tempBottom / 2.54f));
			}
			//comboBoxLeft.setSelectedItem("inches");
			prevMarginCommand = "inches";
		}
		else if(cBoxSelection.equals("cm")) {
			if(prevMarginCommand.equals("pixels")) {
				topT.setText(df.format(tempTop / pixelPerInch * 2.54f));
				leftT.setText(df.format(tempLeft / pixelPerInch * 2.54f));
				rightT.setText(df.format(tempRight / pixelPerInch * 2.54f));
				bottomT.setText(df.format(tempBottom / pixelPerInch * 2.54f));
			}
			else if(prevMarginCommand.equals("inches")) {
				topT.setText(df.format(tempTop * 2.54f));
				leftT.setText(df.format(tempLeft * 2.54f));
				rightT.setText(df.format(tempRight * 2.54f));
				bottomT.setText(df.format(tempBottom * 2.54f));
			}
			//comboBoxLeft.setSelectedItem("cm");
			prevMarginCommand = "cm";
		}
	}
	
	private void scaleT_propertyChange(PropertyChangeEvent e) {
		if("value".equals(e.getPropertyName())) {
			scaleV = Float.parseFloat(scaleT.getText());
			scaleCanvasWidth = canvasWidth*scaleV/100.0f;
			scaleCanvasHeight = canvasHeight*scaleV/100.0f;
			if(prevCommand.equals("pixels")) {
		        widthT.setText(df.format(scaleCanvasWidth));
		        heightT.setText(df.format(scaleCanvasHeight));
			}
			else if(prevCommand.equals("inches")) {
				widthT.setText(df.format(scaleCanvasWidth / pixelPerInch));
		        heightT.setText(df.format(scaleCanvasHeight / pixelPerInch));
			}
			else if(prevCommand.equals("cm")) {
				widthT.setText(df.format(scaleCanvasWidth / pixelPerInch * 2.54f));
		        heightT.setText(df.format(scaleCanvasHeight / pixelPerInch * 2.54f));
			}
			MainWindow.getInstance().getPanel().setScalePrint(scaleV/100.0f);
		    previewPanel.setScalePrint(scaleV/100.0f);
		}
	}
	private void heightT_propertyChange(PropertyChangeEvent e) {
		if("value".equals(e.getPropertyName())) {
			if(prevCommand.equals("pixels")) {
				scaleCanvasHeight = Float.parseFloat(heightT.getText());
				scale = scaleCanvasHeight/canvasHeight;
				scaleCanvasWidth = canvasWidth*scale;
		        widthT.setText(df.format(scaleCanvasWidth));
			}
			else if(prevCommand.equals("inches")) {
				scaleCanvasHeight = Float.parseFloat(heightT.getText()) * pixelPerInch;
				scale = scaleCanvasHeight/canvasHeight;
				scaleCanvasWidth = canvasWidth*scale;
				widthT.setText(df.format(scaleCanvasWidth / pixelPerInch));
			}
			else if(prevCommand.equals("cm")) {
				scaleCanvasHeight = Float.parseFloat(
						heightT.getText()) * pixelPerInch / 2.54f;
				scale = scaleCanvasHeight/canvasHeight;
				scaleCanvasWidth = canvasWidth*scale;
				widthT.setText(df.format(scaleCanvasWidth / pixelPerInch * 2.54f));
			}
			scaleV = 100.0f*scale;
	        scaleT.setText(df.format(scaleV));
	        MainWindow.getInstance().getPanel().setScalePrint(scaleV/100.0f);
	        previewPanel.setScalePrint(scaleV/100.0f);
		}
	}
	private void widthT_propertyChange(PropertyChangeEvent e) {
		if("value".equals(e.getPropertyName())) {
			if(prevCommand.equals("pixels")) {
				scaleCanvasWidth = Float.parseFloat(widthT.getText());
				scale = scaleCanvasWidth/canvasWidth;
				scaleCanvasHeight = canvasHeight*scale;		
				heightT.setText(df.format(scaleCanvasHeight));
			}
			else if(prevCommand.equals("inches")) {
				scaleCanvasWidth = Float.parseFloat(widthT.getText()) * pixelPerInch;
				scale = scaleCanvasWidth/canvasWidth;
				scaleCanvasHeight = canvasHeight*scale;		
				heightT.setText(df.format(scaleCanvasHeight / pixelPerInch));
			}
			else if(prevCommand.equals("cm")) {
				scaleCanvasWidth = Float.parseFloat(
						widthT.getText()) * pixelPerInch / 2.54f;
				scale = scaleCanvasWidth/canvasWidth;
				scaleCanvasHeight = canvasHeight*scale;	
				heightT.setText(df.format(scaleCanvasHeight / pixelPerInch * 2.54f));
			}
			scaleV = 100.0f*scale;	
			scaleT.setText(df.format(scaleV));
			MainWindow.getInstance().getPanel().setScalePrint(scaleV/100.0f);
	        previewPanel.setScalePrint(scaleV/100.0f);
		}
	}
	private void rightT_propertyChange(PropertyChangeEvent e) {
		if("value".equals(e.getPropertyName())) {
			if(prevMarginCommand.equals("pixels")) {
				rightV = Float.parseFloat(rightT.getText());
			}
			else if(prevMarginCommand.equals("inches")) {
				rightV = Float.parseFloat(rightT.getText()) * pixelPerInch;
			}
			else if(prevMarginCommand.equals("cm")) {
				rightV = Float.parseFloat(rightT.getText()) * pixelPerInch / 2.54f;
			}
		}
		if(pf.getOrientation() == PageFormat.LANDSCAPE) {
			paper.setImageableArea(
					topV, rightV, 
	        		pf.getHeight()-topV-bottomV, 
	        		pf.getWidth()-leftV-rightV);
			//topV, pf.getWidth()-pf.getImageableWidth()-leftV, 
			//pf.getImageableHeight(), pf.getImageableWidth());
		}		
		else {
	        paper.setImageableArea(leftV, topV, 
	        		pf.getWidth()-leftV-rightV, 
	        		pf.getHeight()-topV-bottomV);
		}
		pf.setPaper(paper);
		previewPanel.setLocation(
				Math.round(leftV*previewScale), Math.round(topV*previewScale));
        previewPanel.setSpace(
        		(int)Math.round(pf.getImageableWidth() *previewScale),
        		(int)Math.round(pf.getImageableHeight() *previewScale)
        );
		previewPanel.validate();		
	}

	private void bottomT_propertyChange(PropertyChangeEvent e) {
		if("value".equals(e.getPropertyName())) {
			if(prevMarginCommand.equals("pixels")) {
				bottomV = Float.parseFloat(bottomT.getText());
			}
			else if(prevMarginCommand.equals("inches")) {
				bottomV = Float.parseFloat(bottomT.getText()) * pixelPerInch;
			}
			else if(prevMarginCommand.equals("cm")) {
				bottomV = Float.parseFloat(bottomT.getText()) * pixelPerInch / 2.54f;
			}
		}
		if(pf.getOrientation() == PageFormat.LANDSCAPE) {
	        paper.setImageableArea(topV, rightV, 
	        		pf.getHeight()-topV-bottomV, 
	        		pf.getWidth()-leftV-rightV);
		}
		else {
	        paper.setImageableArea(leftV, topV, 
	        		pf.getWidth()-leftV-rightV, 
	        		pf.getHeight()-topV-bottomV);
		}
        //paper.setImageableArea(leftV, topV, B5_WIDTH-leftV-rightV, B5_HEIGHT-topV-bottomV);
        //System.out.println("w:" + pf.getWidth() + " h:" + pf.getHeight() + " x" + pf.getImageableX() + " y" 
        //		+ pf.getImageableY() + " width" + pf.getImageableWidth() +  " height" + pf.getImageableHeight()); 
		pf.setPaper(paper);
        //System.out.println("w:" + pf.getWidth() + " h:" + pf.getHeight() + " x" + pf.getImageableX() + " y" 
        //		+ pf.getImageableY() + " width" + pf.getImageableWidth() +  " height" + pf.getImageableHeight()); 
        previewPanel.setSpace(
        		(int)Math.round(pf.getImageableWidth() *previewScale),
        		(int)Math.round(pf.getImageableHeight() *previewScale)
        );
		previewPanel.validate();
	}
	private void leftT_propertyChange(PropertyChangeEvent e) {
		if("value".equals(e.getPropertyName())) {
			if(prevMarginCommand.equals("pixels")) {
				leftV = Float.parseFloat(leftT.getText());
			}
			else if(prevMarginCommand.equals("inches")) {
				leftV = Float.parseFloat(leftT.getText()) * pixelPerInch;
			}
			else if(prevMarginCommand.equals("cm")) {
				leftV = Float.parseFloat(leftT.getText()) * pixelPerInch / 2.54f;
			}
		}
		if(pf.getOrientation() == PageFormat.LANDSCAPE) {
			paper.setImageableArea(
					topV, rightV, 
	        		pf.getHeight()-topV-bottomV, 
	        		pf.getWidth()-leftV-rightV);
		}
		else {
			paper.setImageableArea(
					leftV, topV, pf.getWidth()-leftV-rightV, pf.getHeight()-topV-bottomV);
		}
		pf.setPaper(paper);
		previewPanel.setLocation(
				Math.round(leftV*previewScale), Math.round(topV*previewScale));
        previewPanel.setSpace(
        		(int)Math.round(pf.getImageableWidth() * previewScale),
        		(int)Math.round(pf.getImageableHeight() * previewScale));
		previewPanel.validate();
	}
	private void topT_propertyChange(PropertyChangeEvent e) {
		if("value".equals(e.getPropertyName())) {
			if(prevMarginCommand.equals("pixels")) {
				topV = Float.parseFloat(topT.getText());
			}
			else if(prevMarginCommand.equals("inches")) {
				topV = Float.parseFloat(topT.getText()) * pixelPerInch;
			}
			else if(prevMarginCommand.equals("cm")) {
				topV = Float.parseFloat(topT.getText()) * pixelPerInch / 2.54f;
			}
		}
		if(pf.getOrientation() == PageFormat.LANDSCAPE) {
			paper.setImageableArea(
					topV, rightV, 
	        		pf.getHeight()-topV-bottomV, 
	        		pf.getWidth()-leftV-rightV);
		}
		else {
			paper.setImageableArea(
					leftV, topV, pf.getWidth()-leftV-rightV, pf.getHeight()-topV-bottomV);
		}
		pf.setPaper(paper);
		previewPanel.setLocation(
				Math.round(leftV*previewScale), Math.round(topV*previewScale));
        previewPanel.setSpace(
        		(int)Math.round(pf.getImageableWidth() *previewScale),
        		(int)Math.round(pf.getImageableHeight() *previewScale));
		previewPanel.validate();
	}

	private void topSlider_stateChanged(ChangeEvent e) {
		JSlider source = (JSlider)e.getSource();
		topV = (float)source.getValue();
        if (!source.getValueIsAdjusting()) { //done adjusting
        	topT.setValue(topV);
        } else { //value is adjusting; just set the text
        	topT.setText(df.format(topV));        	   
        }
		if(pf.getOrientation() == PageFormat.LANDSCAPE) {
			paper.setImageableArea(
					topV, rightV, 
	        		pf.getHeight()-topV-bottomV, 
	        		pf.getWidth()-leftV-rightV);
		}
		else {
			paper.setImageableArea(
					leftV, topV, pf.getWidth()-leftV-rightV, pf.getHeight()-topV-bottomV);
		}
		pf.setPaper(paper);
		previewPanel.setLocation(
				Math.round(leftV*previewScale), Math.round(topV*previewScale));
        previewPanel.setSpace(
        		(int)Math.round(pf.getImageableWidth() *previewScale),
        		(int)Math.round(pf.getImageableHeight() *previewScale));
		previewPanel.validate();
	}
	private void leftSlider_stateChanged(ChangeEvent e) {
		JSlider source = (JSlider)e.getSource();
		leftV = (float)source.getValue();
        if (!source.getValueIsAdjusting()) { //done adjusting
        	leftT.setValue(leftV);
        } else { //value is adjusting; just set the text
        	leftT.setText(df.format(leftV));        	   
        }
		if(pf.getOrientation() == PageFormat.LANDSCAPE) {
			paper.setImageableArea(
					topV, rightV, 
	        		pf.getHeight()-topV-bottomV, 
	        		pf.getWidth()-leftV-rightV);
		}
		else {
			paper.setImageableArea(
					leftV, topV, pf.getWidth()-leftV-rightV, pf.getHeight()-topV-bottomV);
		}
		pf.setPaper(paper);
		previewPanel.setLocation(
				Math.round(leftV*previewScale), Math.round(topV*previewScale));
        previewPanel.setSpace(
        		(int)Math.round(pf.getImageableWidth() *previewScale),
        		(int)Math.round(pf.getImageableHeight() *previewScale));
		previewPanel.validate();
	}
	private void rightSlider_stateChanged(ChangeEvent e) {
		JSlider source = (JSlider)e.getSource();
		rightV = (float)source.getValue();
        if (!source.getValueIsAdjusting()) { //done adjusting
        	rightT.setValue(rightV);
        } else { //value is adjusting; just set the text
        	rightT.setText(df.format(rightV));        	   
        }
		if(pf.getOrientation() == PageFormat.LANDSCAPE) {
			paper.setImageableArea(
					topV, rightV, 
	        		pf.getHeight()-topV-bottomV, 
	        		pf.getWidth()-leftV-rightV);
		}		
		else {
	        paper.setImageableArea(leftV, topV, 
	        		pf.getWidth()-leftV-rightV, 
	        		pf.getHeight()-topV-bottomV);
		}
		pf.setPaper(paper);
		previewPanel.setLocation(
				Math.round(leftV*previewScale), Math.round(topV*previewScale));
        previewPanel.setSpace(
        		(int)Math.round(pf.getImageableWidth() *previewScale),
        		(int)Math.round(pf.getImageableHeight() *previewScale)
        );
		previewPanel.validate();
	}
	private void bottomSlider_stateChanged(ChangeEvent e) {
		JSlider source = (JSlider)e.getSource();
		bottomV = (float)source.getValue();
        if (!source.getValueIsAdjusting()) { //done adjusting
        	bottomT.setValue(bottomV);
        } else { //value is adjusting; just set the text
        	bottomT.setText(df.format(bottomV));        	   
        }
		if(pf.getOrientation() == PageFormat.LANDSCAPE) {
	        paper.setImageableArea(topV, rightV, 
	        		pf.getHeight()-topV-bottomV, 
	        		pf.getWidth()-leftV-rightV);
		}
		else {
	        paper.setImageableArea(leftV, topV, 
	        		pf.getWidth()-leftV-rightV, 
	        		pf.getHeight()-topV-bottomV);
		}
		pf.setPaper(paper);
        previewPanel.setSpace(
        		(int)Math.round(pf.getImageableWidth() *previewScale),
        		(int)Math.round(pf.getImageableHeight() *previewScale)
        );
		previewPanel.validate();
	}
	private void scaleS_stateChanged(ChangeEvent e) {
		JSlider source = (JSlider)e.getSource();
		scaleV = (float)source.getValue();
        if (!source.getValueIsAdjusting()) { //done adjusting
        	scaleT.setValue(scaleV);
        } else { //value is adjusting; just set the text
        	scaleT.setText(df.format(scaleV));        	   
        }
        MainWindow.getInstance().getPanel().setScalePrint(scaleV/100.0f);
	    previewPanel.setScalePrint(scaleV/100.0f);
	}
	private void okButton_actionPerformed() {
		previewJDialog.dispose();
		MainWindow.getInstance().printMethod(pf);
	}
	private void cancelButton_actionPerformed() {
		previewJDialog.dispose();
	}
	@SuppressWarnings("serial")
	private void keyCheck() {
		topT.getInputMap().put(KeyStroke.getKeyStroke(
	            KeyEvent.VK_ENTER, 0),
	            "check");
		topT.getActionMap().put("check", new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (!topT.isEditValid()) { //The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					topT.selectAll();
				} else try {                    //The text is valid,
					topT.commitEdit();     //so use it.
				} catch (java.text.ParseException exc) { }
			}
		});
		leftT.getInputMap().put(KeyStroke.getKeyStroke(
	            KeyEvent.VK_ENTER, 0),
	            "check");
		leftT.getActionMap().put("check", new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (!leftT.isEditValid()) { //The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					leftT.selectAll();
				} else try {                    //The text is valid,
					leftT.commitEdit();     //so use it.
				} catch (java.text.ParseException exc) { }
			}
		});
		rightT.getInputMap().put(KeyStroke.getKeyStroke(
	            KeyEvent.VK_ENTER, 0),
	            "check");
		rightT.getActionMap().put("check", new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (!rightT.isEditValid()) { //The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					rightT.selectAll();
				} else try {                    //The text is valid,
					rightT.commitEdit();     //so use it.
				} catch (java.text.ParseException exc) { }
			}
		});
		bottomT.getInputMap().put(KeyStroke.getKeyStroke(
	            KeyEvent.VK_ENTER, 0),
	            "check");
		bottomT.getActionMap().put("check", new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (!bottomT.isEditValid()) { //The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					bottomT.selectAll();
				} else try {                    //The text is valid,
					bottomT.commitEdit();     //so use it.
				} catch (java.text.ParseException exc) { }
			}
		});
		scaleT.getInputMap().put(KeyStroke.getKeyStroke(
	            KeyEvent.VK_ENTER, 0),
	            "check");
		scaleT.getActionMap().put("check", new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (!scaleT.isEditValid()) { //The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					scaleT.selectAll();
				} else try {                    //The text is valid,
					scaleT.commitEdit();     //so use it.
				} catch (java.text.ParseException exc) { }
			}
		});
		widthT.getInputMap().put(KeyStroke.getKeyStroke(
	            KeyEvent.VK_ENTER, 0),
	            "check");
		widthT.getActionMap().put("check", new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (!widthT.isEditValid()) { //The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					widthT.selectAll();
				} else try {                    //The text is valid,
					widthT.commitEdit();     //so use it.
				} catch (java.text.ParseException exc) { }
			}
		});
		heightT.getInputMap().put(KeyStroke.getKeyStroke(
	            KeyEvent.VK_ENTER, 0),
	            "check");
		heightT.getActionMap().put("check", new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (!heightT.isEditValid()) { //The text is invalid.
					Toolkit.getDefaultToolkit().beep();
					heightT.selectAll();
				} else try {                    //The text is valid,
					heightT.commitEdit();     //so use it.
				} catch (java.text.ParseException exc) { }
			}
		});
	}
}