package com.sharppaint.toolbar;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.geom.*;

import javax.swing.*;

public class FillPanel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1932179379227483421L;
	final static float FILLPANEL_SHAPE_WIDTH = 26.0f; 
	final static BasicStroke basicStroke = new BasicStroke(1.0f);
	final static BasicStroke transStroke = new BasicStroke(2.2f);
	final static Shape shape = new Rectangle2D.Float(2.0f, 2.0f, FILLPANEL_SHAPE_WIDTH, FILLPANEL_SHAPE_WIDTH);
	final static Shape transLineShape = new Line2D.Float(2.0f, 28.0f, 28.0f, 2.0f);
	
	boolean fillMode;
	
	Color fillColor;
			
	public FillPanel() {
		setBackground(Color.WHITE);	
		fillColor = Color.WHITE;
		fillMode = false;	
	}
	public void setColorMode(boolean _fillMode) {
		fillMode = _fillMode;
		repaint();
	}
	public void setFillColor(Color _color) {
		fillMode = true;
		fillColor = _color;
		repaint();
	}
	public void paintComponent(Graphics g) {
		super.paintComponent(g);	//panel paintComponent
    	Graphics2D g2 = (Graphics2D)g;

    	if(fillMode) {
	    	g2.setColor(fillColor);
	    	g2.fill(shape);
    	}
    	else {
	    	g2.setStroke(transStroke);	
	    	g2.setColor(Color.RED);
	    	g2.draw(transLineShape);
	    	g2.setStroke(basicStroke);	
    	}
	}
}
