package com.sharppaint.toolbar;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.geom.Line2D;
import java.awt.geom.Rectangle2D;

import javax.swing.JPanel;

public class StrokePanel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = -1409017845234769233L;
	final static float FILLPANEL_SHAPE_WIDTH = 26.3f; 
	final static float STROKEPANEL_SHAPE_WIDTH = 20.0f; 
	final static float STROKEPANEL_INNERSHAPE_WIDTH = 11.0f; 
	final static BasicStroke basicStroke = new BasicStroke(1.0f);
	final static BasicStroke lineStroke = new BasicStroke(5.5f);
	final static BasicStroke transStroke = new BasicStroke(2.2f);
	/*final static Shape shape = new Rectangle2D.Float(
			2.2f, 2.0f, 
			FILLPANEL_SHAPE_WIDTH, FILLPANEL_SHAPE_WIDTH);*/
	final static Shape rectLineShape = new Rectangle2D.Float(
			4.9f, 4.9f, 
			STROKEPANEL_SHAPE_WIDTH, STROKEPANEL_SHAPE_WIDTH);
	final static Shape innerRectShape = new Rectangle2D.Float(
			9f, 9f, 
			STROKEPANEL_INNERSHAPE_WIDTH, STROKEPANEL_INNERSHAPE_WIDTH);
	final static Shape innerRectShape2 = new Rectangle2D.Float(
			10.0f, 10.0f, 
			STROKEPANEL_INNERSHAPE_WIDTH-1, STROKEPANEL_INNERSHAPE_WIDTH-1);
	final static Shape transLineShape = new Line2D.Float(2.0f, 28.0f, 28.0f, 2.0f);

	boolean strokeMode;
	
	Color strokeColor;
	
	public StrokePanel() {
		setBackground(Color.WHITE);	
		strokeColor = Color.BLACK;
		strokeMode = true;	
	}
	public void setStrokeColor(Color _color) {
		strokeMode = true;
		strokeColor = _color;
		repaint();
	}
	public void setStrokeMode(boolean _strokeMode) {
		strokeMode = _strokeMode;
		repaint();
	}
	public void paintComponent(Graphics g) {
		super.paintComponent(g);	//panel paintComponent
    	Graphics2D g2 = (Graphics2D)g;
    	g2.setStroke(lineStroke);
    	
    	if(strokeMode) {
	    	g2.setColor(strokeColor);
	    	g2.draw(rectLineShape);
	    	g2.setStroke(basicStroke);
	    	g2.setColor(Color.LIGHT_GRAY);
	    	g2.fill(innerRectShape2);
	    	g2.setColor(Color.BLACK);
	    	g2.draw(innerRectShape);
    	}
    	else {
	    	g2.setColor(Color.WHITE);
	    	g2.draw(rectLineShape);
	    	g2.setStroke(basicStroke);
	    	g2.setColor(Color.LIGHT_GRAY);
	    	g2.fill(innerRectShape2);
	    	g2.setColor(Color.BLACK);
	    	g2.draw(innerRectShape);
	    	
	    	g2.setStroke(transStroke);	
	    	g2.setColor(Color.RED);
	    	g2.draw(transLineShape);
	    	g2.setStroke(basicStroke);	
    	}
	}
}
