package com.sharppaint.toolbar;

import java.awt.*;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.text.NumberFormat;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.text.NumberFormatter;

import com.sharppaint.MainWindow;

//     ư,  toolBar
public class UpperToolBox {

	private static JButton txt;

	private static JLabel strokeSizelabel, fontSizelabel, fontNamelabel;

	private static JComboBox strokeBox, sizeBox, nameBox;

	private static JCheckBox boldCheck, italicCheck, underlineCheck;
	
	private final static String sizeStrokeArr[] = {"0.25", "0.5", "0.75", "1", "2", "3", "4", "5",
			"6", "7", "8", "10", "20", "30", "40", "50", "60", "70", "80", "90", "100" };

	private final static String sizeArr[] = { "8", "10", "12", "14", "18",
			"24", "30", "36", "48", "60", "72" };

	private static float strokeSize;
	
	private int fontSize, fontStyle, chkBold, chkItalic;

	private String fontName;

	private static final int ARC_MIN=0;
	
	private static final int ARC_MAX=500;
	
	private static boolean isAdjustByTextField;
	
	private static JLabel arcWidthLabel;
	
	private static JLabel arcHeightLabel;
	
	private static JLabel arcWidthPxLabel;
	
	private static JLabel arcHeightPxLabel;
	
	private static JFormattedTextField arcWidthTextField;
	
	private static JFormattedTextField arcHeightTextField;
	
	private static NumberFormatter formatter;
	
	private static NumberFormat numberFormat;
	
	private static float roundRectArcWidth;
	
	private static float roundRectArcHeight;
	
	private static JSlider arcWidthSlider;
	
	private static JSlider arcHeightSlider;
	
	static private byte select;

	final static byte DRAW = 0;

	final static byte DEFAULT = 1;

	final static byte TEXT = 2;
	
	final static byte DRAW_ROUNDRECT = 3;

	final static int INSET = 1;

	public UpperToolBox() {
		//font = new Font("dialog", Font.BOLD, 8);
		makeToolBar();
	}

	public void makeToolBar() {
		strokeSizelabel = new JLabel("StrokeSize: ");
		fontSizelabel = new JLabel("Size: ");
		fontNamelabel = new JLabel("Name: ");
		//strokeSizelabel.setFont(font);
		//fontSizelabel.setFont(font);
		//fontNamelabel.setFont(font);
		strokeBox = new JComboBox(sizeStrokeArr);
		sizeBox = new JComboBox(sizeArr);
		strokeBox.setEditable(true);
		sizeBox.setEditable(true);
		strokeBox.setPreferredSize(new Dimension(55, 22));
		sizeBox.setPreferredSize(new Dimension(50, 22));
		//strokeBox.setFont(font);
		//sizeBox.setFont(font);
		strokeBox.setSelectedIndex(3);
		sizeBox.setSelectedIndex(1);

		GraphicsEnvironment gEnv = GraphicsEnvironment
				.getLocalGraphicsEnvironment();
		String envfonts[] = gEnv.getAvailableFontFamilyNames();
		Vector<String> vector = new Vector<String>();
		for (int i = 1; i < envfonts.length; i++) {
			vector.addElement(envfonts[i]);
		}
		nameBox = new JComboBox(vector);
		nameBox.setMaximumRowCount(9);
		nameBox.setPreferredSize(new Dimension(178, 23));
		//nameBox.setFont(font);
		// fontchoice = envfonts[0];
		boldCheck = new JCheckBox("Bold");
		italicCheck = new JCheckBox("Italic");
		boldCheck.setOpaque(false);
		italicCheck.setOpaque(false);
		boldCheck.setPreferredSize(new Dimension(55, 23));
		italicCheck.setPreferredSize(new Dimension(58, 23));
		underlineCheck = new JCheckBox("Underline");
		//boldCheck.setFont(font);
		//italicCheck.setFont(font);
		//underlineCheck.setFont(font);
		txt = new JButton("Text");
		txt.setForeground(Color.WHITE);
		txt.setBackground(Color.BLACK);
		txt.setPreferredSize(new Dimension(37, 23));
		txt.setToolTipText(" Ӽ");
		// ̺Ʈ
		strokeBox.addItemListener(new strokeSizeListener());
		sizeBox.addItemListener(new fontSizeListener());
		//sizeBox.addFocusListener(new fontSizeListener());
		nameBox.addItemListener(new fontNameListener());
		//nameBox.addFocusListener(new fontNameListener());
		boldCheck.addItemListener(new fontStyleListener());
		italicCheck.addItemListener(new fontStyleListener());
		underlineCheck.addItemListener(new fontStyleListener());	
		initRoundRectSetting();
		
		// save.setEnabled(false); //undo.setEnabled(false);
		// redo.setEnabled(false);
		// ٿ add
		MainWindow.toolBar.add(strokeSizelabel);
		MainWindow.toolBar.add(strokeBox);
		MainWindow.toolBar.add(new JLabel("        "));
		// this.add(new JLabel(" ")); //this.add(boldCheck);
		// //this.add(italicCheck);
		// StartDraw.toolBar.add(new JLabel(" "));
		select = 0;
	}

	static private void initRoundRectSetting() {
		isAdjustByTextField = false;
		roundRectArcWidth = 10;
		roundRectArcHeight = 10;
        numberFormat = java.text.NumberFormat.getIntegerInstance();
        formatter = new NumberFormatter(numberFormat);
		arcWidthLabel = new JLabel("ArcWidth: ");
		arcHeightLabel = new JLabel("ArcHeight: ");
		arcWidthPxLabel = new JLabel(" px   ");
		arcHeightPxLabel = new JLabel(" px");
		arcWidthTextField = new JFormattedTextField(formatter);
		arcHeightTextField = new JFormattedTextField(formatter); 
		arcWidthSlider = new JSlider(ARC_MIN, ARC_MAX, 10);
		arcWidthSlider.setPreferredSize(new Dimension(100, 18));
		arcWidthSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				arcWidthSlider_stateChanged(e);
			}
		});
		arcWidthSlider.setOpaque(false);
		arcHeightSlider = new JSlider(ARC_MIN, ARC_MAX, 10);
		arcHeightSlider.setPreferredSize(new Dimension(100, 18));
		arcHeightSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				arcHeightSlider_stateChanged(e);
			}
		});
		arcHeightSlider.setOpaque(false);
		/*arcWidthLabel.setFont(font);
		arcHeightLabel.setFont(font);
		arcWidthPxLabel.setFont(font);
		arcHeightPxLabel.setFont(font);
		arcWidthTextField.setFont(font);
		arcHeightTextField.setFont(font);*/
	    
		formatter.setMinimum(new Float(ARC_MIN));
		formatter.setMaximum(new Float(2000));
		arcWidthTextField.setValue(new Float(10));
		arcWidthTextField.setColumns(3); 
		arcWidthTextField.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				arcWidthTextField_propertyChange(e);
			}
		});
		arcHeightTextField.setValue(new Float(10));
		arcHeightTextField.setColumns(3); 
		arcHeightTextField.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				arcHeightTextField_propertyChange(e);
			}
		});
	}
	
	static public void drawTool() {
		if (select != DRAW) {
			MainWindow.toolBar.removeAll();
			MainWindow.addToolBar();
			MainWindow.toolBar.add(strokeSizelabel);
			MainWindow.toolBar.add(strokeBox);
			MainWindow.toolBar.validate();
			MainWindow.toolBar.repaint();
			select = DRAW;
		}
	}
	
	static public void drawRoundRectTool() {
		if (select != DRAW_ROUNDRECT) {
			MainWindow.toolBar.removeAll();
			MainWindow.addToolBar();
			MainWindow.toolBar.add(strokeSizelabel);
			MainWindow.toolBar.add(strokeBox);
			MainWindow.toolBar.add(new JLabel("     "));
			MainWindow.toolBar.add(arcWidthLabel);
			MainWindow.toolBar.add(arcWidthSlider);
			MainWindow.toolBar.add(arcWidthTextField);
			MainWindow.toolBar.add(arcWidthPxLabel);
			MainWindow.toolBar.add(arcHeightLabel);
			MainWindow.toolBar.add(arcHeightSlider);
			MainWindow.toolBar.add(arcHeightTextField);
			MainWindow.toolBar.add(arcHeightPxLabel);
			MainWindow.toolBar.validate();
			MainWindow.toolBar.repaint();
			select = DRAW_ROUNDRECT;
		}
	}
	
	static public void textTool() {
		if (select != TEXT) {
			MainWindow.toolBar.removeAll();
			MainWindow.addToolBar();
			MainWindow.toolBar.add(strokeSizelabel);
			MainWindow.toolBar.add(strokeBox);
			MainWindow.toolBar.add(new JLabel("     "));
			MainWindow.toolBar.add(txt);
			MainWindow.toolBar.add(new JLabel("   "));
			MainWindow.toolBar.add(fontSizelabel);
			MainWindow.toolBar.add(sizeBox);
			MainWindow.toolBar.add(new JLabel("   "));
			MainWindow.toolBar.add(fontNamelabel);
			MainWindow.toolBar.add(nameBox);
			MainWindow.toolBar.add(boldCheck);
			MainWindow.toolBar.add(italicCheck);

			MainWindow.toolBar.add(new JLabel("     "));
			MainWindow.toolBar.validate();
			MainWindow.toolBar.repaint();
			select = TEXT;
		}
	}

	
	private static void arcWidthSlider_stateChanged(ChangeEvent e) {
		if(!isAdjustByTextField) {
			JSlider source = (JSlider) e.getSource();
			roundRectArcWidth = (float) source.getValue();
			if (source.getValueIsAdjusting()) { // value is adjusting; just set the text
				arcWidthTextField.setText(String.valueOf(roundRectArcWidth));
			} else { 
				//arcWidthTextField.setValue(roundRectArcWidth);
			}
			if(MainWindow.getInstance().getPanel() != null) {
				MainWindow.getInstance().getPanel().setRoundRectArcWidth(roundRectArcWidth);
			}
		}
	}
	
	private static void arcHeightSlider_stateChanged(ChangeEvent e) {
		if(!isAdjustByTextField) {
			JSlider source = (JSlider) e.getSource();
			roundRectArcHeight = (float) source.getValue();
			if (source.getValueIsAdjusting()) { // value is adjusting; just set the text
				arcHeightTextField.setText(String.valueOf(roundRectArcHeight));
			} else { 
				//arcHeightTextField.setValue(roundRectArcHeight);
			}
			if(MainWindow.getInstance().getPanel() != null) {
				MainWindow.getInstance().getPanel().setRoundRectArcHeight(roundRectArcHeight);
			}
		}
	}
	private static void arcWidthTextField_propertyChange(PropertyChangeEvent e) {
		if ("value".equals(e.getPropertyName())) {
			Number value = (Number) e.getNewValue();
			if (arcWidthTextField != null && value != null) {
				isAdjustByTextField = true;
				if(value.intValue() <= 500) {
					arcWidthSlider.setValue(value.intValue());
				} else {
					arcWidthSlider.setValue(500);
				}
				isAdjustByTextField = false;
				roundRectArcWidth = value.floatValue();					
				if(MainWindow.getInstance().getPanel() != null) {
					MainWindow.getInstance().getPanel().setRoundRectArcWidth(roundRectArcWidth);
				}
			}
		}
	}
	
	private static void arcHeightTextField_propertyChange(PropertyChangeEvent e) {		
		if ("value".equals(e.getPropertyName())) {
			Number value = (Number) e.getNewValue();
			if (arcHeightTextField != null && value != null) {
				isAdjustByTextField = true;
				if(value.intValue() <= 500) {
					arcHeightSlider.setValue(value.intValue());
				} else {
					arcHeightSlider.setValue(500);
				}
				isAdjustByTextField = false;			
				roundRectArcHeight = value.floatValue();
				if(MainWindow.getInstance().getPanel() != null) {
					MainWindow.getInstance().getPanel().setRoundRectArcHeight(roundRectArcHeight);
				}
			}
		}		
	}

	static public void setStrokeSize(float _strokeSize) {
		strokeSize = _strokeSize;
		strokeBox.setSelectedItem(Float.toString(strokeSize));
		strokeBox.getEditor().setItem(strokeSize);
	}
	
	class strokeSizeListener implements ItemListener { //  size set
		public void itemStateChanged(ItemEvent event) {
			strokeSize = Float.parseFloat((String) strokeBox.getSelectedItem());
			if(MainWindow.getInstance().getPanel() != null)
				MainWindow.getInstance().getPanel().setStrokeSize(strokeSize);
		}
	}

	class fontSizeListener implements ItemListener { // font size																	
		public void itemStateChanged(ItemEvent event) {
			fontSize = Integer.parseInt((String) sizeBox.getSelectedItem());
			if(MainWindow.getInstance().getPanel() != null)
				MainWindow.getInstance().getPanel().setFontSize(fontSize);
		}
	}

	class fontNameListener implements ItemListener { // font name  FocusListener
		public void itemStateChanged(ItemEvent event) {
			fontName = (String) nameBox.getSelectedItem();
			if(MainWindow.getInstance().getPanel() != null)
				MainWindow.getInstance().getPanel().setFontName(fontName);
		}
		/*
		public void focusGained(FocusEvent arg0) {
			//MainWindow.getInstance().getPanel().setFocusToTextArea();
		}

		public void focusLost(FocusEvent arg0) {
		}*/
	}

	class fontStyleListener implements ItemListener { // font style set
		public void itemStateChanged(ItemEvent event) {
			if (boldCheck.isSelected())
				chkBold = 1;
			else
				chkBold = 0;
			if (italicCheck.isSelected())
				chkItalic = 2;
			else
				chkItalic = 0;
			fontStyle = chkBold + chkItalic;
			if(MainWindow.getInstance().getPanel() != null)
				MainWindow.getInstance().getPanel().setFontStyle(fontStyle);
		}
	}

	public static float getStrokeSize() {
		return strokeSize;
	}

	public static void setRoundRectArcHeight(float roundRectArcHeight) {
		UpperToolBox.roundRectArcHeight = roundRectArcHeight;
		arcHeightSlider.setValue(Math.round(roundRectArcHeight));
		arcHeightTextField.setText(String.valueOf(roundRectArcHeight));
				
	}

	public static void setRoundRectArcWidth(float roundRectArcWidth) {
		UpperToolBox.roundRectArcWidth = roundRectArcWidth;
		arcWidthSlider.setValue(Math.round(roundRectArcWidth));
		arcWidthTextField.setText(String.valueOf(roundRectArcWidth));
	}
}
