package com.sharppaint.toolbar;
import java.awt.*;

import javax.swing.*;

import com.sharppaint.Constants;
import com.sharppaint.MainWindow;
import com.sharppaint.drawtools.DrawToolConst;

import java.awt.event.*;



//ַ Drawtool õ  toolbar
public class WestToolBox extends JToolBar{	
	/**
	 * 
	 */
	private static final long serialVersionUID = -1268115316626795296L;
	
	private JPanel northPanel, centerPanel, southPanel;
	
	private JPanel fillSelectPanel;
	
	JPanel colorButtonInnerPanel;
	
	private FillPanel fillPanel;
	
	private StrokePanel strokePanel;
	
	private JButton multiLine, pen, rect, oval, line, roundRect;
	
	private JButton move, copy, text, image;
	
	private JButton transButton, colorButton;
	
	//private JButton resize; //function
	
	private JButton button;
	
	private Color fillColor, strokeColor;
	
	private Color tempFillColor, tempStrokeColor;
	
	private boolean fillFlag;
		
	private ImageIcon penIcon, multiLineIcon, lineIcon, rectIcon, circleIcon, rountRectIcon;
	
	private ImageIcon copyIcon, moveIcon;
	
	private ImageIcon textIcon, imageIcon;
	
	private ImageIcon transIcon;
	
	private Insets inset;
	
	public final static int INSET=1;

	public final static int RECT_WIDTH=45;
	
	public final static int FILLPANEL_WIDTH = 30; 	

	private static WestToolBox westToolBox = null;

	public static WestToolBox getInstance() {
		if(westToolBox == null)
			westToolBox = new WestToolBox();
		return westToolBox;
	}
	
	private WestToolBox() {
		fillFlag = false;
		fillColor = Color.WHITE;
		strokeColor = Color.BLACK;
		
		multiLine = new JButton();
		pen = new JButton();
		line = new JButton();
		rect = new JButton();
		oval = new JButton();
		roundRect = new JButton();
		copy = new JButton();
		move = new JButton();
		text = new JButton();
		image = new JButton();
		//resize = new JButton();
				
		transButton = new JButton();
		colorButton = new JButton();

		inset = new java.awt.Insets(INSET, INSET, INSET, INSET);
		multiLine.setMargin(inset);
		pen.setMargin(inset);
		line.setMargin(inset);
		rect.setMargin(inset);
		oval.setMargin(inset);
		roundRect.setMargin(inset);
		copy.setMargin(inset);
		move.setMargin(inset);
		text.setMargin(inset);
		image.setMargin(inset);
		transButton.setMargin(inset);
		colorButton.setMargin(inset);
		//resize.setMargin(inset);
		/*
		Color compColor = new Color(238, 238, 238);
		multiLine.setBackground(compColor);
		pen.setBackground(compColor);
		line.setBackground(compColor);
		rect.setBackground(compColor);
		oval.setBackground(compColor);
		roundRect.setBackground(compColor);
		copy.setBackground(compColor);
		move.setBackground(compColor);
		text.setBackground(compColor);
		image.setBackground(compColor);
		transButton.setBackground(compColor);
		colorButton.setBackground(compColor);*/
		
		copy.setMnemonic(KeyEvent.VK_C);
		pen.setToolTipText("");
		multiLine.setToolTipText("귯");
		line.setToolTipText("");
		rect.setToolTipText("簢");
		oval.setToolTipText("Ÿ");
		roundRect.setToolTipText("ձ 簢");
		copy.setToolTipText("");
		move.setToolTipText("̵");
		text.setToolTipText("ؽƮ");
		image.setToolTipText("̹");
		//resize.setToolTipText("ũ ");
		transButton.setToolTipText("");
		colorButton.setToolTipText("");
		
		pen.addActionListener(new ShapeListener());
		multiLine.addActionListener(new ShapeListener());
		line.addActionListener(new ShapeListener());
		rect.addActionListener(new ShapeListener());
		oval.addActionListener(new ShapeListener());
		roundRect.addActionListener(new ShapeListener());
		copy.addActionListener(new ShapeListener());
		move.addActionListener(new ShapeListener());
		text.addActionListener(new ShapeListener());
		image.addActionListener(new ShapeListener());
		//resize.addActionListener(new ShapeListener());
		//fillButton.addMouseListener(new FillListener());
		//strokeButton.addMouseListener(new StrokeListener());
		
		penIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "pen.gif"));
		multiLineIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "multiline.gif"));
		lineIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "line.gif"));
		rectIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "rect.gif"));
		circleIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "ellipse.gif"));
		rountRectIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "roundrect.gif"));
		copyIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "copy.gif"));
		moveIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "move.gif"));
		textIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "text.gif"));
		imageIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "image.gif"));
		transIcon = new ImageIcon(getClass().getResource(
				Constants.ICON_PATH + "transparency.gif"));
		//resizeIcon = new ImageIcon(getClass().getResource(Constants.ICON_PATH + "resize.gif"));
		colorButtonInnerPanel = new JPanel();
		colorButtonInnerPanel.setPreferredSize(new Dimension(18, 18));
		
		pen.setIcon(penIcon);
		multiLine.setIcon(multiLineIcon);
		rect.setIcon(rectIcon);
		oval.setIcon(circleIcon);
		line.setIcon(lineIcon);
		roundRect.setIcon(rountRectIcon);
		copy.setIcon(copyIcon);
		move.setIcon(moveIcon);
		text.setIcon(textIcon);
		image.setIcon(imageIcon);	
		transButton.setIcon(transIcon);
		colorButton.add(colorButtonInnerPanel);
		colorButtonInnerPanel.setBackground(strokeColor);
		/*
		fillButton.setBackground(fillColor);
		strokeButton.setBorder(BorderFactory.createLineBorder(strokeColor, 5));
		fillButton.setPreferredSize(new Dimension(30, 30));
		strokeButton.setPreferredSize(new Dimension(30, 30));*/
		//fillButton.setBounds(5, 5, 30, 30);
		//strokeButton.setBounds(20, 20, 30, 30);
		//resize.setIcon(resizeIcon);		
		
		northPanel = new JPanel();
		centerPanel = new JPanel(); 
		southPanel = new JPanel();
		fillSelectPanel = new JPanel();
		fillPanel = new FillPanel();
		strokePanel = new StrokePanel();
		fillPanel.setBounds(5, 6, FILLPANEL_WIDTH, FILLPANEL_WIDTH);
		strokePanel.setBounds(19, 19, FILLPANEL_WIDTH, FILLPANEL_WIDTH);
		fillPanel.addMouseListener(new FillListener());
		strokePanel.addMouseListener(new StrokeListener());
		transButton.addActionListener(new TransListener());
		colorButton.addActionListener(new ColorListener());
		fillPanel.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		strokePanel.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		//fillPanel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, Color.BLACK, Color.LIGHT_GRAY));
		//fillPanel.setBorder(BorderFactory.createLineBorder(Color.BLACK, 1));
		//strokePanel.setBorder(BorderFactory.createLineBorder(Color.BLACK, 1));
		//fillPanel.setBackground(Color.WHITE);
		//strokePanel.setBackground(Color.BLUE);

		centerPanel.setLayout(null);
		centerPanel.setPreferredSize(new Dimension(55, 55));
		//fillSelectPanel.setPreferredSize(new Dimension(55, 25));
		northPanel.setLayout(new GridLayout(5, 2, 0, 1));
		southPanel.setLayout(new GridLayout(7, 2, 0, 1));
		fillSelectPanel.setLayout(new GridLayout(1, 2, 0, 1));
		northPanel.add(move);		northPanel.add(copy);			
		northPanel.add(pen);		northPanel.add(multiLine);
		northPanel.add(line);		northPanel.add(oval);		
		northPanel.add(rect);		northPanel.add(roundRect);		
		northPanel.add(text);		northPanel.add(image);
		//add(resize);
		//add(new JLabel(""));	add(new JLabel(""));
		//fillPanel.add(fillButton);
		//strokePanel.add(strokeButton);
		centerPanel.add(strokePanel);
		centerPanel.add(fillPanel);
		fillSelectPanel.add(colorButton);		fillSelectPanel.add(transButton);	
		
		//this.addSeparator();
		//add(new JLabel(""));	add(new JLabel(""));

		
		button = makeColorButton("black");
		southPanel.add(button);
		button = makeColorButton("darkgray");
		southPanel.add(button);
		button = makeColorButton("cyan");
		southPanel.add(button);
		button = makeColorButton("gray");
		southPanel.add(button);
		button = makeColorButton("green");
		southPanel.add(button);
		button = makeColorButton("lightgray");
		southPanel.add(button);
		button = makeColorButton("magenta");
		southPanel.add(button);
		button = makeColorButton("orange");
		southPanel.add(button);
		button = makeColorButton("blue");
		southPanel.add(button);
		button = makeColorButton("pink");
		southPanel.add(button);
		button = makeColorButton("red");
		southPanel.add(button);
		button = makeColorButton("yellow");
		southPanel.add(button);
		button = makeColorButton("white");
		southPanel.add(button);
		
		this.setLayout(
        		new BoxLayout(this, BoxLayout.Y_AXIS));
		northPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		centerPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		fillSelectPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		southPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		this.add(northPanel);
		//this.addSeparator();
		this.add(centerPanel);
		this.add(fillSelectPanel);
		//strokePanel.setEnabled(false);
		//fillPanel.setEnabled(false);
		//colorButton.setEnabled(false);
		//transButton.setEnabled(false);
		//this.addSeparator();
		this.add(southPanel);
	}

	/*
	public void setEnableColorButton() {
		strokePanel.setEnabled(true);
		fillPanel.setEnabled(true);
		colorButton.setEnabled(true);
		transButton.setEnabled(true);		
	}
	
	public void setDisableColorButton() {
		strokePanel.setEnabled(false);
		fillPanel.setEnabled(false);
		colorButton.setEnabled(false);
		transButton.setEnabled(false);
	}*/
	
	class FillListener extends MouseAdapter  {
		public void paint(Graphics g) {
			g.drawRect(5, 5, 10, 10);
		}
		public void mousePressed(MouseEvent e) {
			fillFlag = true;
			centerPanel.add(strokePanel);
			fillPanel.repaint();
			if (e.getButton() == 1 && e.getClickCount() == 2) {
				tempFillColor = fillColor;

				if(MainWindow.getInstance().getPanel() != null) {
		        	fillColor=JColorChooser.showDialog(
		        			MainWindow.getInstance(), " ", fillColor);
					if (fillColor == null)
						fillColor = tempFillColor;
					else {
						fillPanel.setFillColor(fillColor);
			        	MainWindow.getInstance().getPanel().setFillColor(fillColor);
						MainWindow.getInstance().setMode(Status.COLOR);
					}
				}				
			}
			colorButtonInnerPanel.setBackground(fillColor);
		}
	}
	
	class StrokeListener extends MouseAdapter  {
		public void mousePressed(MouseEvent e) {
			fillFlag = false;
			centerPanel.add(fillPanel);
			strokePanel.repaint();
			if (e.getButton() == 1 && e.getClickCount() == 2) {
				tempStrokeColor = strokeColor;

				if(MainWindow.getInstance().getPanel() != null) {
					strokeColor=JColorChooser.showDialog(
		        			MainWindow.getInstance(), " ", strokeColor);
					if (strokeColor == null)
						strokeColor = tempStrokeColor;
					else {
						strokePanel.setStrokeColor(strokeColor);
			        	MainWindow.getInstance().getPanel().setStrokeColor(strokeColor);
						MainWindow.getInstance().setMode(Status.COLOR);
					}
				}				
			}	
			colorButtonInnerPanel.setBackground(strokeColor);		
		}
	}
	
	public void setFillColor(boolean colorMode, Color fillColor) {
		fillPanel.setColorMode(colorMode);
		if(colorMode)
			fillPanel.setFillColor(fillColor);
	}
	
	public void setFillColorMode(boolean colorMode) {
		fillPanel.setColorMode(colorMode);
	}
	
	public void setStrokeColor(boolean strokeMode, Color strokeColor) {
		strokePanel.setStrokeMode(strokeMode);	
		if(strokeMode)
			strokePanel.setStrokeColor(strokeColor);
	}
	
	public void setStrokeColorMode(boolean strokeMode) {
		strokePanel.setStrokeMode(strokeMode);
	}
	
	class TransListener implements ActionListener {
		public void actionPerformed(ActionEvent event) {
			if(MainWindow.getInstance().getPanel() != null) {
				if(fillFlag) {
					fillPanel.setColorMode(false);
					MainWindow.getInstance().getPanel().setColorMode(false);				
				}
				else {
					strokePanel.setStrokeMode(false);
					MainWindow.getInstance().getPanel().setStrokeMode(false);
				}
			}
		}		
	}
	
	class ColorListener implements ActionListener {
		public void actionPerformed(ActionEvent event) {
			if(MainWindow.getInstance().getPanel() != null) {
				if(fillFlag) {
					fillPanel.setFillColor(fillColor);
					MainWindow.getInstance().getPanel().setFillColor(fillColor);
				}
				else {
					strokePanel.setStrokeColor(strokeColor);
					MainWindow.getInstance().getPanel().setStrokeColor(strokeColor);
				}
			}
		}		
	}
	
	//ư Ŭϸ ؾ  DrawPanel set
	class ShapeListener implements ActionListener {
		public void actionPerformed(ActionEvent event) {
			if(event.getSource() == rect) {
				setTool(DrawToolConst.RECT);
				MainWindow.getInstance().setMode(Status.RECTANGLE);
				UpperToolBox.drawTool();
			}
			else if(event.getSource() == pen) {
				setTool(DrawToolConst.PEN);
				MainWindow.getInstance().setMode(Status.PEN);
				UpperToolBox.drawTool();
			}
			else if(event.getSource() == multiLine) {
				setTool(DrawToolConst.MULTILINE);
				MainWindow.getInstance().setMode(Status.MULTILINE);
				UpperToolBox.drawTool();
			}
			else if(event.getSource() == oval) {
				setTool(DrawToolConst.ELLIPSE);
				MainWindow.getInstance().setMode(Status.ELLIPSE);
				UpperToolBox.drawTool();
			}
			else if(event.getSource() == line) {
				setTool(DrawToolConst.LINE);
				MainWindow.getInstance().setMode(Status.LINE);
				UpperToolBox.drawTool();
			}
			else if(event.getSource() == roundRect) {
				setTool(DrawToolConst.ROUNDRECT);
				MainWindow.getInstance().setMode(Status.ROUNDRECT);
				UpperToolBox.drawRoundRectTool();
			}
			else if(event.getSource() == move) {
				setTool(DrawToolConst.MOVE);
				MainWindow.getInstance().setMode(Status.MOVE);
				UpperToolBox.drawTool();
			}
			else if(event.getSource() == copy) {
				setTool(DrawToolConst.COPY);
				MainWindow.getInstance().setMode(Status.COPY);
				UpperToolBox.drawTool();
			}
			else if(event.getSource() == text) {
				setTool(DrawToolConst.TEXT);
				MainWindow.getInstance().setMode(Status.TEXT);
				UpperToolBox.textTool();
			}
			else if(event.getSource() == image) {
				setTool(DrawToolConst.IMAGE);
				MainWindow.getInstance().setMode(Status.IMAGE);
				UpperToolBox.drawTool();
			}
			/*
			else if(event.getSource() == resize) {
				setTool(DrawToolConst.RESIZE);
				MainWindow.getInstance().setMode(Status.RESIZE);
				UpperToolBox.defaultTool();
			}*/
		}
	}
	
	private void setTool(int tool) {
		if(MainWindow.getInstance().getPanel() != null)
			MainWindow.getInstance().getPanel().setDrawingTool(tool);
	}
		
	private void setColor(Color color) {
		if(MainWindow.getInstance().getPanel() != null) {
			if(fillFlag) {
				fillColor = color;
				fillPanel.setFillColor(fillColor);
				MainWindow.getInstance().getPanel().setFillColor(fillColor);	
				colorButtonInnerPanel.setBackground(fillColor);				
			}
			else {
				strokeColor = color;
				strokePanel.setStrokeColor(strokeColor);
				MainWindow.getInstance().getPanel().setStrokeColor(strokeColor);
				colorButtonInnerPanel.setBackground(strokeColor);
			}
		}
	}
	
	public JButton makeColorButton(String action) {
		String tooltiptext = action;
		JButton button = new JButton();
		button.setMargin(inset);
		//button.putClientProperty(SubstanceLookAndFeel.TOOLBAR_BUTTON_FLAT, Boolean.FALSE);
		button.setIcon(new ImageIcon(getClass().getResource
				(Constants.COLORICON_PATH + action + ".gif")));
		button.setToolTipText(tooltiptext);
		button.setActionCommand(action);
		button.addActionListener(new ColorHandler());		
		return button;
	}
	//Įư Ŭ DrawPanel õ  set,  ٿ Color status  
	class ColorHandler implements ActionListener {
		public void actionPerformed(ActionEvent event) {
			String cmd = event.getActionCommand();
			if(cmd.equals("black")) {
				setColor(Color.BLACK);
			}
			else if(cmd.equals("darkgray")) {
				setColor(Color.DARK_GRAY);
			}
			else if(cmd.equals("cyan")) {
				setColor(Color.CYAN);
			}
			else if(cmd.equals("gray")) {
				setColor(Color.GRAY);
			}
			else if(cmd.equals("green")) {
				setColor(Color.GREEN);
			}
			else if(cmd.equals("lightgray")) {
				setColor(Color.LIGHT_GRAY);
			}
			else if(cmd.equals("magenta")) {
				setColor(Color.MAGENTA);
			}
			else if(cmd.equals("orange")) {
				setColor(Color.ORANGE);
			}
			else if(cmd.equals("blue")) {
				setColor(Color.BLUE);
			}
			else if(cmd.equals("pink")) {
				setColor(Color.PINK);
			}
			else if(cmd.equals("red")) {
				setColor(Color.RED);
			}
			else if(cmd.equals("yellow")) {
				setColor(Color.YELLOW);
			}
			else if(cmd.equals("white")) {
				setColor(Color.WHITE);
			}
		}
	}
}
